<?php
	require_once 'base.php';
	include_once $babInstallPath."admin/acl.php";

	$babBody->setTitle(bab_translate("Synchronization between the Ovidentia application and the ORPEO Active Directory", $GLOBALS['babAddonFolder']));
	
	if (!bab_isUserAdministrator()) {
		$babBody->addError( bab_translate("Access denied", $GLOBALS['babAddonFolder']));
		return;
	}
	
	if( isset($_POST['updateaccess']))
	{
		maclGroups();
		$babBody->addError( bab_translate("Update done", $GLOBALS['babAddonFolder']));
	}

	$macl = new macl($GLOBALS['babAddonTarget']."/admin", 'idx_value', 1000, 'updateaccess');
	$macl->addtable( 'sad_admin_groups',bab_translate("Who can parameter the synchronisation program?", $GLOBALS['babAddonFolder']));
	$macl->filter(0,0,1,1,1);
	$macl->addtable( 'sad_create_admins_groups',bab_translate("Who can create new delegated administrators?", $GLOBALS['babAddonFolder']));
	$macl->filter(0,0,1,1,1);
	$macl->addtable( 'sad_create_objects_groups',bab_translate("Who can create new Ovidentia objects by delegation?", $GLOBALS['babAddonFolder']));
	$macl->filter(0,0,1,1,1);
	$macl->addtable( 'sad_sync_accounts_groups',bab_translate("Who can synchronize all the accounts with Active Directory?", $GLOBALS['babAddonFolder']));
	$macl->filter(0,0,1,1,1);
	$macl->babecho();
?>
