<?php
require_once 'base.php';

function synchroad_getAdminSectionMenus(&$url, &$text)
{
	return false;
}

 
function synchroad_getUserSectionMenus(&$url, &$text)
{
	return false;
}
 
function synchroad_onSectionCreate(&$title, &$content)
{
	
	global $babDB;
	global $babBody;
	
	if (bab_isAccessValid('sad_create_objects_groups', 1000) || bab_isAccessValid('sad_create_admins_groups', 1000) || bab_isAccessValid('sad_sync_accounts_groups', 1000) || bab_isUserAdministrator())
	{
		$title = bab_translate("Synchronization AD", $GLOBALS['babAddonFolder']);
		$content = "<ul>\n";
		if (bab_isAccessValid('sad_create_objects_groups', 1000))
		{
			$res = $babDB->db_query("
			SELECT
			`id_deleg`
			FROM
			`sad_created_class_deleg`
			WHERE
			`id_deleg` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$content .= "<li><a href='".$GLOBALS['babAddonUrl']."create_objects' title = '".bab_translate("Creation of the objects inside the delegation", $GLOBALS['babAddonFolder'])."'>".bab_translate("Creation of the objects", $GLOBALS['babAddonFolder'])."</a></li>\n";
			}
			else
			{
				$res = $babDB->db_query("
				SELECT
				`id_deleg`
				FROM
				`sad_created_group_deleg`
				WHERE
				`id_deleg` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
				");
				if ($babDB->db_num_rows($res) > 0)
				{
					$content .= "<li><a href='".$GLOBALS['babAddonUrl']."create_objects' title = '".bab_translate("Creation of the objects inside the delegation", $GLOBALS['babAddonFolder'])."'>".bab_translate("Creation of the objects", $GLOBALS['babAddonFolder'])."</a></li>\n";
				}
			}
		}
		if (bab_isAccessValid('sad_create_admins_groups', 1000))
		{
			$content .= "<li><a href='".$GLOBALS['babAddonUrl']."set_params' title='".bab_translate("Settings of the synchronization", $GLOBALS['babAddonFolder'])."'>".bab_translate("Setting", $GLOBALS['babAddonFolder'])."</a></li>\n";
			$content .= "<li><a href='".$GLOBALS['babAddonUrl']."sync_delegs' title='".bab_translate("Synchronization of delegations", $GLOBALS['babAddonFolder'])."'>".bab_translate("Sync. of delegations", $GLOBALS['babAddonFolder'])."</a></li>\n";
		}
		if (bab_isAccessValid('sad_sync_accounts_groups', 1000))
		{
			$content .= "<li><a href='".$GLOBALS['babAddonUrl']."sync_accounts' title='".bab_translate("Synchronization of users accounts", $GLOBALS['babAddonFolder'])."'>".bab_translate("Sync. of accounts", $GLOBALS['babAddonFolder'])."</a></li>\n";
		}
		if (bab_isUserAdministrator())
		{
			$content .= "<li><a href=\"".$GLOBALS['babAddonUrl']."user\">".bab_translate("Site personnalization", $GLOBALS['babAddonFolder'])."</a></li>\r\n";
		}
		$content .= "</ul>\n";
		return true;
	}
	else
	{
		return false;
	}
}

function synchroad_upgrade($version_base,$version_ini)
{
	global $babDB;
	global $babBody;

	copy($GLOBALS['babInstallPath']."addons/synchroad/sync_cron.php", "sync_cron.php");
	
	require_once 'sad_ini.php';
	
	if ( !bab_isTable("sad_params")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `sad_params` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT(11) UNSIGNED NOT NULL DEFAULT '0',
		`host` VARCHAR(255) NOT NULL DEFAULT '',
		`port` INT(11) UNSIGNED NOT NULL DEFAULT '389',
		`dn` TEXT NOT NULL DEFAULT '',
		`password` BLOB NOT NULL DEFAULT '',
		`crypt` BLOB NOT NULL DEFAULT '',
		`etab` VARCHAR(255) NOT NULL DEFAULT '',
		`domaine` VARCHAR(255) NOT NULL DEFAULT 'ORPEO',
		`suffixe` VARCHAR(255) NOT NULL DEFAULT 'local',
		PRIMARY KEY (id))
		"); 
	}  
	if ( !bab_isTable("sad_admin_groups")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `sad_admin_groups` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_object` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_group` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		"); 
	}  
	if ( !bab_isTable("sad_create_admins_groups")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `sad_create_admins_groups` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_object` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_group` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_deleg` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		"); 
	}  
	if ( !bab_isTable("sad_create_objects_groups")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `sad_create_objects_groups` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT(11) UNSIGNED NOT NULL,
		`id_object` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_group` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		"); 
	}
	if ( !bab_isTable("sad_sync_accounts_groups")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `sad_sync_accounts_groups` (
		`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT(11) UNSIGNED NOT NULL,
		`id_object` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		`id_group` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		"); 
	} 
	
	if ( !bab_isTable("sad_created_class_deleg")) 
	{
		$res = $babDB->db_query("
		CREATE TABLE `sad_created_class_deleg` (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT( 11 ) UNSIGNED NOT NULL,
		`e` VARCHAR( 255 ) NOT NULL,
		`c` VARCHAR( 255 ) NULL,
		`n` VARCHAR( 255 ) NULL,
		`s` VARCHAR( 255 ) NULL,
		`i` VARCHAR( 255 ) NULL,
		`g` VARCHAR( 255 ) NULL,
		`id_deleg` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		");
	}
	if ( !bab_isTable("sad_created_class_deleg_temp")) 
	{
		$res = $babDB->db_query("
		CREATE TABLE `sad_created_class_deleg_temp` (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT( 11 ) UNSIGNED NOT NULL,
		`e` VARCHAR( 255 ) NOT NULL,
		`c` VARCHAR( 255 ) NULL,
		`n` VARCHAR( 255 ) NULL,
		`s` VARCHAR( 255 ) NULL,
		`i` VARCHAR( 255 ) NULL,
		`g` VARCHAR( 255 ) NULL,
		`id_deleg` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		");
	}

	if ( !bab_isTable("sad_created_group_deleg")) 
	{
		$res = $babDB->db_query("
		CREATE TABLE `sad_created_group_deleg` (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT,
		`id_site` INT( 11 ) UNSIGNED NOT NULL,
		`group_name` VARCHAR( 255 ) NOT NULL,
		`manager_dn` TEXT NULL,
		`id_deleg` INT(11) UNSIGNED DEFAULT '0' NOT NULL,
		PRIMARY KEY ( `id` ))
		");
	}
	if ( !bab_isTable("sad_groups_tree")) 
	{
		$res = $babDB->db_query("
		CREATE TABLE `sad_groups_tree` (
		`id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
		`id_deleg` INT( 11 ) UNSIGNED NOT NULL ,
		`id_group` INT( 11 ) UNSIGNED NOT NULL ,
		`dn` TEXT NOT NULL ,
		PRIMARY KEY ( `id` ))
		");
	}
	// Cration de la structure initiale des groupes
	require_once $GLOBALS['babInstallPath']."utilit/grpincl.php";
	// Cration ventuelle du groupe des gestionnaires du sites d'tablissement
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(ETABGEST_GROUP_NAME)."'
	AND
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = ETABGEST_GROUP_NAME;
		$description = $etabgest_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup( $name, $description, $managerid);;
	}
	
	/*
	include_once $GLOBALS['babInstallPath']."utilit/eventincl.php";
	bab_addEventListener('bab_eventUserAttachedToGroup','synchroad_onUserAttachToGroup','addons/synchroad/events.php', $GLOBALS['babAddonFolder'], 100);
	*/
	
	// Cration ventuelle du groupe des administrateurs dlgus
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE `name` = '".$babDB->db_escape_string(ADMINS_GROUP_NAME)."'
	AND
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = ADMINS_GROUP_NAME;
		$description = $admins_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup( $name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des gestionnaires des dlgations
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups`
	WHERE 
	`name` = '".$babDB->db_escape_string(GESTS_GROUP_NAME)."'
	AND
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = GESTS_GROUP_NAME;
		$description = $gests_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup( $name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des lves et tudiants de l'tablissement (sans rpertoire privatif)
	$res = $babDB->db_query("
	SELECT
	`id`
	FROM
	`bab_groups`
	WHERE
	`name` = '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."'
	AND
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = STUDENTS_GROUP_NAME;
		$description = $students_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		$id_groupe_EtabElv = bab_createGroup( $name, $description, $managerid);
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_groupe_EtabElv = $temp["id"];
	}
	$res = $babDB->db_query("
	UPDATE
	`bab_groups`
	SET
	`ustorage` = 'N' 
	WHERE
	`id` = '".$babDB->db_escape_string($id_groupe_EtabElv)."'
	");
	// Cration ventuelle du groupe des enseignants de l'tablissement (avec rpertoire privatif)
	$res = $babDB->db_query("
	SELECT
	`id`
	FROM
	`bab_groups`
	WHERE
	`name` = '".$babDB->db_escape_string(TEACHERS_GROUP_NAME)."'
	AND
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = TEACHERS_GROUP_NAME;
		$description = $teachers_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		$id_groupe_EtabProf = bab_createGroup( $name, $description, $managerid); 

	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_groupe_EtabProf = $temp["id"];
	}
	$res = $babDB->db_query("UPDATE
	`bab_groups`
	SET 
	`ustorage` = 'Y' 
	WHERE 
	`id` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
	// Cration ventuelle du sur-groupe inter-classes
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(GIC_GROUP_NAME)."' 
	AND 
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = GIC_GROUP_NAME;
		$description = $gic_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		$gic_group_id = bab_createGroup( $name, $description, $managerid);;
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$gic_group_id = $temp["id"];
	}
	return true;
}

function synchroad_onDeleteAddon()
{
	if (file_exists("sync_cron.php")) unlink("sync_cron.php");
	return true;
}
?>