<?php
	require_once('base.php');
	
	require_once($GLOBALS["babInstallPath"].'addons/synchroad/functions.php');
	
	// Longueur des mots de passe gnrs par dfaut (valeur minimale pour tre compatible avec l'utilisation d'Ovidentia : 6)
	define ("LENGTH", 8);
	
	// Mode d'authentification prdfinis
	$authentification_method[0] = bab_translate("Ovidentia Database", $GLOBALS['babAddonFolder']);
	$authentification_method[1] = bab_translate("LDAP Directory", $GLOBALS['babAddonFolder']);
	$authentification_method[2] = bab_translate("Active Directory", $GLOBALS['babAddonFolder']);
	
	/*
	// Groupe des utilisateurs enregistrs
	define("BAB_REGISTERED_GROUP", 1);
	
	// Groupe des administerateurs
	define("BAB_ADMINISTRATOR_GROUP", 3);
		
	define ("BAB_GROUPS_TBL", 'bab_groups");
	*/
	
	// Groupe des gestionnaires du site d'tablissement
	define ("ETABGEST_GROUP_NAME", "EtabGest");
	$etabgest_group_description = bab_translate("Group of the site managers", $GLOBALS["babAddonFolder"]);
	
	// Groupe des administrateurs dlgus
	define ("ADMINS_GROUP_NAME", "Admins");
	$admins_group_description = bab_translate("Group of delegated administrators", $GLOBALS["babAddonFolder"]);
	
	// Groupe des gestionnaires dlgus
	define ("GESTS_GROUP_NAME", "Gests");
	$gests_group_description = bab_translate("Group of delegated managers", $GLOBALS["babAddonFolder"]);
	
	// Groupe des lves et tudiants
	define ("STUDENTS_GROUP_NAME", "EtabElv");
	$students_group_description = bab_translate("Group of all students of the establishment", $GLOBALS["babAddonFolder"]);
	define ("STUDENTS_GROUP_ID", FindGroupIdFromName(STUDENTS_GROUP_NAME, BAB_REGISTERED_GROUP));
	
	// Groupe des enseignants
	define ("TEACHERS_GROUP_NAME", "EtabProf");
	$teachers_group_description = bab_translate("Group of all teachers of the establishment", $GLOBALS["babAddonFolder"]);
	define ("TEACHERS_GROUP_ID", FindGroupIdFromName(TEACHERS_GROUP_NAME, BAB_REGISTERED_GROUP));
	
	// Ensemble des groupes inter-classes
	define ("GIC_GROUP_NAME", "Inter-classes");
	$gic_group_description = bab_translate("All inter-classes groups", $GLOBALS["babAddonFolder"]);
	
	// Suffixes des noms de groupe
	define ("STUDENTS_GROUP_SUFFIX", "Elv");
	define ("TEACHERS_GROUP_SUFFIX", "Prof");
	define ("MANAGERS_GROUP_SUFFIX", "Gest");

	// Suffixe des schmas de modration
	define ("FLOW_APPROVERS_SUFFIX", "ProfMod");
	
	// Suffixe du rpertoire spcifiques aux enseignements
	define ("ENSEIGNEMENT_FOLDER_NAME", bab_translate("Enseignements", $GLOBALS["babAddonFolder"]));
	
	// Nombre par dfaut de thmes par catgories de thmes
	define ("TOPICS_DEFAULT_NUMBER", 6);
	
	// Paramtrage de la cration des classes des lves des sections tertiaires de type lyce technologique
	
	$Categorie['Igc'] = "SECONDE IGC";
	$Espace['Igc'] = "Espace IGC";
	$Theme['Igc'] = array();
	
	$Categorie['Pstg'] = "PREMIERE STG";
	$Espace['Pstg'] = "Espace Premires";
	$Theme['Pstg'] = array();
	$Theme['Pstg'][0] = "Management ";
	$Theme['Pstg'][1] = "Information et Gestion";
	$Theme['Pstg'][2] = "Information et Communication";

	$Categorie['Tstg'] = "TERMINALE STG";
	$Espace['Tstg'] = "Espace Terminales";
	$Theme['Tstg'] = array();
	$Theme['Tstg'][0] = "Economie Droit ";
	$Theme['Tstg'][1] = "Management ";
	$Theme['Tstg'][2] = "Mercatique";
	$Theme['Tstg'][3] = "Comptabilit et finance des entreprises";
	$Theme['Tstg'][4] = "Gestion des systmes d'informations";
	$Theme['Tstg'][5] = "Communication et gestion des ressources humaines";

	// Paramtrage de la cration des sections de techniciens suprieurs

	// Thmes MUC
	$Categorie['Muc'] = "STS MUC";
	$Espace['Muc'] = "Espace MUC";
	$Stages['Muc'] = "Stages et projets";
	$Theme['Muc'][0] = "Economie Droit";
	$Theme['Muc'][1] = "Management et gestion des units commerciales";
	$Theme['Muc'][2] = "Gestion de la relation commerciale";
	$Theme['Muc'][3] = "Dveloppement de l'unit commerciale";
	$Theme['Muc'][4] = "Informatique commerciale";
	$Theme['Muc'][5] = "Communication";

	// Thmes NRC
	$Categorie['Nrc'] = "STS NRC";
	$Espace['Nrc'] = "Espace NRC";
	$Stages['Nrc'] = "Projets";
	$Theme['Nrc'][0] = "Economie Droit";
	$Theme['Nrc'][1] = "Mercatique";
	$Theme['Nrc'][2] = "Gestion commerciale";
	$Theme['Nrc'][3] = "Management commercial";
	$Theme['Nrc'][4] = "Technologies commerciales";
	$Theme['Nrc'][5] = "Communication et ngociation";
	
?>
