<?php
	
	function mail_for_information($message)
	{
		global $babInstallPath;
		global $babDB;
		
		$subject = "Synchronisation Ovidentia / Active Directory d'ORPEO";
		
		$res = $babDB->db_query("
		SELECT 
		`adminemail`, 
		`adminname` 
		FROM 
		`bab_sites` 
		WHERE 
		`name`= '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'
		");
		list($adminemail, $adminname) = $babDB->db_fetch_row($res);
		
		$headers = "From:".$adminname."<".$adminemail.">";
		
		$administrators_array = bab_getGroupsMembers(BAB_ADMINISTRATOR_GROUP);
		foreach ($administrators_array as &$value)
		{
			$to = $value["email"];
			$to_name = $value["name"];
			mail($to, $subject, $message, $headers);
		}
	}	
	
	function actionImportAccountsForm($test)
	{
		global $babBody;
		global $error_in_ad_reading;
		class actionImportAccountsFormClass 
		{
			function actionImportAccountsFormClass($test)
			{
				require_once $GLOBALS['babInstallPath']."addons/synchroad/sad_ini.php";
				require_once $GLOBALS['babInstallPath']."addons/synchroad/functions.php";
				require_once $GLOBALS['babInstallPath'].'admin/register.php';
				require_once $GLOBALS['babInstallPath'].'utilit/userincl.php';

				global $babDB;
				global $babBody;
				global $error_in_ad_reading;
				$error_in_ad_reading = false;
				// Rcupration des paramtres de synchronisation
				list($r, $ds, $etab, $domain, $suffix) = $test;
				if ($r === false || $ds === false)
				{
					$error_in_ad_reading = true;
					$this->action_error_report = bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					// Identification du groupe des lves et tudiants de l'tablissement
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_groups` 
					WHERE 
					`name`= '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."' 
					AND 
					`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
					");
					$temp = $babDB->db_fetch_array($res);
					$EtabElv_group_id = $temp["id"];
					// Importation des comptes des lves et tudiants dans la structure d'Ovidentia
					$base_dn = "OU=groupe, OU=".$etab.", DC=".$domain.", DC=".$suffix;
					$filter = "(CN=eleve)";
					$sr = @ldap_search($ds, $base_dn, $filter);
					if ($sr === false)
					{
						$error_in_ad_reading = true;
						$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
					}
					else
					{
						$temp = @ldap_count_entries($ds, $sr);
						if ($temp === false)
						{
							$error_in_ad_reading = true;
							$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
						}
						else
						{
							if ($temp > 0)
							{
								$entry = @ldap_first_entry($ds, $sr);
								if ($entry === false)
								{
									$error_in_ad_reading = true;
									$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
								}
								else
								{
									$attributes = ldap_get_attributes($ds, $entry);
									if ($attributes === false)
									{
										$error_in_ad_reading = true;
										$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
									}
									else
									{
										if (in_array("member", $attributes))
										{
											$members = ldap_get_values($ds, $entry, "member");
											if (count($members) > 0)
											{
												for ($i = 0; $i < count($members) - 1; $i++)
												{
													$temp = ldap_explode_dn($members[$i], 1);
													$uid = $temp[0];
													if (!empty($uid))
													{
														$uid = mb_strtolower($uid);
														$id_user = bab_getUserIdByNickname($uid);
														if ($id_user === 0)
														{
															$firstname = $uid;
															$lastname = $uid;
															$middlename = "";
															$nickname = $uid;
															$email = "a_saisir@serveur.ext";
															$password1 = "123456";
															$password2 = $password1;
															$confirmed  = true;
															$error = "";
															$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup = true); 
															$this->res = $babDB->db_query("
															UPDATE 
															`bab_users` 
															SET 
															`db_authentification` = 'N' 
															WHERE 
															`id`='".$babDB->db_escape_string($id_user)."'
															");
														}
														bab_attachUserToGroup($id_user, $EtabElv_group_id);
													}
												}
											}
										}
										$this->action_report_part1 = bab_translate("The accounts of new students in ORPEO have been created in Ovidentia database and attach to the group", "synchroad")." ".STUDENTS_GROUP_NAME.".";
											
										// Identification du groupe des enseignants de l'tablissement
										$res = $babDB->db_query("SELECT 
										`id` 
										FROM 
										`bab_groups` 
										WHERE 
										`name`= '".$babDB->db_escape_string(TEACHERS_GROUP_NAME)."' 
										AND
										`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."
										'");
										$temp = $babDB->db_fetch_array($res);
										$EtabProf_group_id = $temp["id"];
										// Importation des comptes des enseignants dans la structure d'Ovidentia
										$base_dn = "OU=prof, OU=".$etab.", DC=".$domain.", DC=".$suffix;
										$filter = "(CN=*)";
										$sr = @ldap_search($ds, $base_dn, $filter);
										if ($sr === false)
										{
											$error_in_ad_reading = true;
											$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
										}
										else
										{
											if (@ldap_count_entries($ds, $sr) === false)
											{
												$error_in_ad_reading = true;
												$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
											}
											else
											{
												if (ldap_count_entries($ds, $sr) > 0)
												{
													$entry = ldap_first_entry($ds, $sr);
													if ($entry === false)
													{
														$error_in_ad_reading = true;
														$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
													}
													else
													{
														while ($entry)
														{
															$dn = ldap_get_dn($ds, $entry);
															if ($dn === false)
															{
																$error_in_ad_reading = true;
																$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
															}
															else
															{
																$temp = ldap_explode_dn($dn, 1);
																$uid = $temp[0];
																$uid = mb_strtolower($uid);
																$id_user = bab_getUserIdByNickname($uid);
																if ($id_user === 0)
																{
																	$firstname = $uid;
																	$lastname = $uid;
																	$middlename = "";
																	$nickname = $uid;
																	$email = "a_saisir@serveur.ext";
																	$password1 = "123456";
																	$password2 = $password1;
																	$confirmed = true;
																	$error = "";
																	$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup = true);
																	$this->res = $babDB->db_query("
																	UPDATE 
																	`bab_users` 
																	SET 
																	`db_authentification` = 'N' 
																	WHERE 
																	`id`='".$babDB->db_escape_string($id_user)."
																	'");
																}
																
																bab_attachUserToGroup($id_user, $EtabProf_group_id);
																$entry = ldap_next_entry($ds, $entry);
															}
														}
													}
												}
											}
											$this->action_report_part2 = bab_translate("The accounts of new teachers in ORPEO have been created in Ovidentia database and attach to the group", "synchroad")." ".TEACHERS_GROUP_NAME.".";
										}
									}
								}
							}
						}
					}
					ldap_close($ds);
				}
			}
		}
		$obj= new actionImportAccountsFormClass($test);
		if (is_object($babBody))
		{
			if ($GLOBALS['error_in_ad_reading'])
			{
				$babBody->addError(bab_translate("Unsuccessfull operation!", "synchroad"));
				$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_error"));
			}
			else
			{
				$babBody->addError(bab_translate("Successfull operation!", "synchroad"));
				$babBody->babecho(bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_report"));
			}
		}
		return($error_in_ad_reading);
	}

	function actionDeleteAccountsForm($test)
	{
		global $babBody;
		global $error_in_ad_reading;
		class actionDeleteAccountsFormClass 
		{
			function actionDeleteAccountsFormClass($test)
			{
				require_once $GLOBALS['babInstallPath']."addons/synchroad/sad_ini.php";
				require_once $GLOBALS['babInstallPath']."addons/synchroad/functions.php";
				require_once $GLOBALS['babInstallPath'].'admin/register.php';
				require_once $GLOBALS['babInstallPath'].'utilit/userincl.php';
				require_once $GLOBALS['babInstallPath'].'utilit/delincl.php';
				require_once $GLOBALS['babInstallPath'].'utilit/upgradeincl.php';
				
				global $babDB;
				global $LENGTH;
				global $error_in_ad_reading;
				$error_in_ad_reading = false;
				// Rcupration des paramtres de synchronisation
				list($r, $ds, $etab, $domain, $suffix) = $test;
				if ($r === false || $ds === false)
				{
					$this->error_in_ad_reading = true;
					$this->error_message = bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					// Identification du groupe des lves et tudiants de l'tablissement
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_groups` 
					WHERE 
					`name`= '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."' 
					AND 
					`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."
					'");
					$temp = $babDB->db_fetch_array($res);
					$EtabElv_group_id = $temp["id"];
					// Scrutation des comptes lves et tudiants dans l'Active Directory d'ORPEO
					$base_dn = "OU=groupe, OU=".$etab.", DC=".$domain.", DC=".$suffix;
					$filter = "(CN=eleve)";
					$sr = @ldap_search($ds, $base_dn, $filter);
					if ($sr === false)
					{
						$error_in_ad_reading = true;
						$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
					}
					else
					{
						if (ldap_count_entries($ds, $sr) === false)
						{
							$error_in_ad_reading = true;
							$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
						}
						else
						{
							if (ldap_count_entries($ds, $sr) === false)
							{
								$error_in_ad_reading = true;
								$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
							}
							else
							{
								if (ldap_count_entries($ds, $sr) > 0)
								{
									$entry = ldap_first_entry($ds, $sr);
									if ($entry === false)
									{
										$error_in_ad_reading = true;
										$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
									}
									else
									{
										$dn = ldap_get_dn($ds, $entry);
										if ($dn === false)
										{
											$error_in_ad_reading = true;
											$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
										}
										else
										{
											$attributes = ldap_get_attributes($ds, $entry);
											if ($attributes === false)
											{
												$error_in_ad_reading = true;
												$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
											}
											else
											{
												if (in_array("member", $attributes))
												{
													$members = ldap_get_values($ds, $entry, "member");
													if ($members === false)
													{
														$error_in_ad_reading = true;
														$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
													}
													else
													{
														$uid = array();
														if (count($members) > 0)
														{
															for ($i = 0; $i < count($members) - 1; $i++)
															{
																$temp = $members[$i];
																$temp = ldap_explode_dn($temp, 1);
																$uid[] = mb_strtolower($temp[0]);
															}
														}
														// Scrutation des comptes des lves dans la structure d'Ovidentia
														$res = $babDB->db_query("
														SELECT 
														`id_object`, 
														`nickname` 
														FROM 
														`bab_users`, 
														`bab_users_groups` 
														WHERE 
														`bab_users`.`id` = `id_object` 
														AND 
														`id_group` = '".$babDB->db_escape_string($EtabElv_group_id)."' 
														AND 
														`db_authentification` = 'N' 
														");
														while ($temp = $babDB->db_fetch_array($res))
														{
															$id_user = $temp["id_object"];
															$nickname = $temp["nickname"];
															if (!in_array($nickname, $uid))
															{
																if (bab_isTable("dp_folders")) 
																{
																	$res1 = $babDB->db_query("
																	SELECT 
																	`id`, 
																	`id_folder`, 
																	`id_personal_group` 
																	FROM 
																	`dp_folders` 
																	WHERE 
																	`id_user` = '".$babDB->db_escape_string($id_user)."'
																	");
																	if ($babDB->db_num_rows($res1) > 0)
																	{
																		list($id, $id_folder, $id_personal_group) = $babDB->db_fetch_row($res1);
																		// Suppression du groupe personnel de l'lve
																		bab_removeGroup($id_personal_group);
																		// Suppression du dossier personnel partag 
																		bab_deleteFolder($id_folder);
																		// Suppression de l'enregistrement de suivi du dossier personnel partag
																		$res1 = $babDB->db_query("
																		DELETE 
																		FROM 
																		`dp_folders` 
																		WHERE 
																		`id` = '".$babDB->db_escape_string($id)."'
																		");
																	}
																}
																bab_deleteUser($id_user);
															}
														}
														$this->action_report_part1 = bab_translate("The accounts of former students in Ovidentia database have been removed as their personal ressources", "synchroad").".";
														
														// Identification du groupe des enseignants de l'tablissement
														$res = $babDB->db_query("
														SELECT 
														`id` 
														FROM 
														`bab_groups` 
														WHERE 
														`name`= '".$babDB->db_escape_string(TEACHERS_GROUP_NAME)."' 
														AND 
														`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
														");
														$temp = $babDB->db_fetch_array($res);
														$EtabProf_group_id = $temp["id"];
														// Scrutation des comptes des enseignants dans la structure d'Ovidentia
														$res = $babDB->db_query("SELECT `id_object`, `nickname` FROM `bab_users`, `bab_users_groups` WHERE `bab_users`.`id` = `id_object` AND `id_group` = '".$babDB->db_escape_string($EtabProf_group_id)."' AND `db_authentification` = 'N' ");
														while ($temp = $babDB->db_fetch_array($res))
														{
															$id_user = $temp["id_object"];
															$nickname = mb_strtolower($temp["nickname"]);
															$base_dn = "OU=prof, OU=".$etab.", DC=".$domain.", DC=".$suffix;
															$filter = "(CN=".$nickname.")";
															$sr = ldap_search($ds, $base_dn, $filter);
															if ($sr === false) 
															{
																$error_in_ad_reading = true;
																$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
															}
															if (ldap_count_entries($ds, $sr) == 0)
															{
																bab_deleteUser($id_user);
															}
														}
														$this->action_report_part2 = bab_translate("The accounts of former teachers in Ovidentia database have been removed as their personal ressources", "synchroad").".";
													}
												}
											}
										}
									}
								}
							}
						}
					}
					ldap_close($ds);
				}
			}
		}
		$obj= new actionDeleteAccountsFormClass($test);
		if (is_object($babBody))
		{
			if ($error_in_ad_reading)
			{
				$babBody->addError(bab_translate("Unsuccessfull operation!", "synchroad"));
				$babBody->babecho(bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_error"));
			}
			else
			{
				$babBody->addError(bab_translate("Successfull operation!", "synchroad"));
				$babBody->babecho(bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_report"));
			}
		}
		return($error_in_ad_reading);
	}

	function actionAttachAccountsForm($test)
	{
		global $babBody;
		global $error_in_ad_reading;
		global $warning_in_ad_reading;
		global $desync1_groups_table;
		global $desync2_groups_table;
		global $unsync_groups_table;
		
		class actionAttachAccountsFormClass 
		{
			function actionAttachAccountsFormClass($test)
			{
				require_once $GLOBALS['babInstallPath']."addons/synchroad/sad_ini.php";
				require_once $GLOBALS['babInstallPath']."addons/synchroad/functions.php";
				require_once $GLOBALS['babInstallPath'].'admin/register.php';
				require_once $GLOBALS['babInstallPath'].'utilit/userincl.php';
				require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
				
				global $babDB;
				global $error_in_ad_reading;
				$error_in_ad_reading = false;
				global $warning_in_ad_reading;
				$warning_in_ad_reading = false;
				global $desync1_groups_table;
				$desync1_groups_table = array();
				global $desync2_groups_table;
				$desync2_groups_table = array();
				global $unsync_groups_table;
				$unsync_groups_table = array();
				
				$this->action_report_part1 = "";
				$this->action_report_part2 = "";
				
				$this->desync1_warning_flag = false;
				$this->desync2_warning_flag = false;
				$this->unsync_warning_flag = false;
				
				$this->desync1_warning_report  = bab_translate("The ORPEO groups listed below, formerly synchronized with Ovidentia groups, have no more correspondant in the actual Ovidentia structure:", "synchroad");
				$this->desync2_warning_report  = bab_translate("The Ovidentia groups listed below, formerly synchronized with ORPEO groups, have no more correspondant in the actual Active Directory structure:", "synchroad");
				$this->unsync_warning_report = bab_translate("The groups listed below, newly created in Active Directory, do not correspond to any Ovidentia groups:", "synchroad");
				
				$this->desync_groups_list1 = "";
				$this->desync_groups_list2 = "";
				$this->unsync_groups_list = "";
				
				// Rcupration des paramtres de synchronisation
				list($r, $ds, $etab, $domain, $suffix) = $test;
				if ($r === false || $ds === false)
				{
					$error_in_ad_reading = true;
					$this->action_error_report = bab_translate("Error ! No connexion to ORPEO server.", "synchroad");
				}
				else
				{
					// Lecture de l'arborescence des groupes crs dans la base de donnes Ovidentia
					$this->res = $babDB->db_query("
					SELECT 
					`id_group`, 
					`dn` 
					FROM 
					`sad_groups_tree`
					WHERE 
					1
					");
					if ($babDB->db_num_rows($this->res) > 0)
					{
						while ((list($id_group, $dn) = $babDB->db_fetch_row($this->res)) && (!$error_in_ad_reading))
						{
							$temp = ldap_explode_dn($dn, 1);
							$CN = $temp[0];
							
							//  Le groupe (repr par son id) est-il toujours prsent dans la table des groupes d'Ovidentia ?
							$res = $babDB->db_query("
							SELECT
							`name`
							FROM 
							`bab_groups`
							WHERE
							`id` = '".$babDB->db_escape_string($id_group)."'
							");
							if ($babDB->db_num_rows($res) === 0)
							{
								$warning_in_ad_reading = true;
								$this->desync1_warning_flag = true;
								$this->desync1_groups_table[] = $CN;
								$this->desync1_groups_list .= "<li>".$CN."</li>\r\n";
							}
							else
							{
								// Affectation des nouveaux venus aux groupes
								$this->base_dn = "OU=groupe, OU=".$etab.", DC=".$domain.", DC=".$suffix;
								$filter = "(CN=".$CN.")";
								$sr = @ldap_search($ds, $this->base_dn, $filter);
								if ($sr === false) 
								{
									$error_in_ad_reading = true;
									$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
								}
								else
								{
									$temp = @ldap_count_entries($ds, $sr);
									if ($temp === false)
									{
										$warning_in_ad_reading = true;
										$this->desync2_warning_flag = true;
										$group_name = $babDB->db_fetch_array($res);
										$group_name = $group_name['name'];
										$this->desync2_groups_table[] = $group_name;
										$this->desync2_groups_list .= "<li>".$group_name."</li>\r\n";
									}
									else
									{
										if ($temp > 0)
										{
											$entry = @ldap_first_entry($ds, $sr);
											if ($entry === false)
											{
												$error_in_ad_reading = true;
												$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
											}
											else
											{
												$attributes = @ldap_get_attributes($ds, $entry);
												if ($attributes === false)
												{
													$error_in_ad_reading = true;
													$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
												}
												else
												{
													if (in_array("member", $attributes))
													{
														$members = @ldap_get_values($ds, $entry, "member");
														if ($members === false)
														{
															$error_in_ad_reading = true;
															$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
														}
														else
														{
															if (count($members) > 0)
															{
																$members_number = $members["count"];
																$i = 0;
																while ($i < $members_number)
																{
																	$temp = $members[$i];
																	$temp = ldap_explode_dn($temp, 1);
																	$uid = $temp[0];
																	$nickname = mb_strtolower($uid);
																	$id_user = bab_getUserIdByNickname($uid);
																	if ($id_user > 0)
																	{
																		if (!bab_isMemberOfGroup($id_group, $id_user))
																		{
																			bab_attachUserToGroup($id_user, $id_group);
																			if (bab_isTable("dp_folders"))
																			{
																				$res = $babDB->db_query("
																				SELECT 
																				`id_folder`, 
																				`id_prof_group` 
																				FROM 
																				`dp_folders` 
																				WHERE 
																				`id_user` = '".$babDB->db_escape_string($id_user)."'
																				");
																				if ($babDB->db_num_rows($res) > 0)
																				{
																					list($id_folder, $id_old_prof_group) = $babDB->db_fetch_array($res);
																					$res = $babDB->db_query("
																					SELECT 
																					`id_group` 
																					FROM 
																					`sad_groups_tree` 
																					WHERE 
																					`dn` = '".$babDB->db_escape_string(str_ireplace("CN=l_eleve", "CN=l_prof", $dn))."'
																					");
																					if ($babDB->db_num_rows($res) > 0)
																					{
																						list($id_new_prof_group) = $babDB->db_fetch_array($res);
																						transfer_right_on_folder($id_folder, "upload", $id_old_prof_group + BAB_ACL_GROUP_TREE, $id_new_prof_group + BAB_ACL_GROUP_TREE);
																						transfer_right_on_folder($id_folder, "download", $id_old_prof_group + BAB_ACL_GROUP_TREE, $id_new_prof_group + BAB_ACL_GROUP_TREE);
																						transfer_right_on_folder($id_folder, "update", $id_old_prof_group + BAB_ACL_GROUP_TREE, $id_new_prof_group + BAB_ACL_GROUP_TREE);
																						// transfer_right_on_folder($id_folder, "notify", $id_old_prof_group + BAB_ACL_GROUP_TREE, $id_new_prof_group + BAB_ACL_GROUP_TREE);
																						transfer_right_on_folder($id_folder, "manage", $id_old_prof_group + BAB_ACL_GROUP_TREE, $id_new_prof_group + BAB_ACL_GROUP_TREE);
																						$res = $babDB->db_query("
																						UPDATE 
																						`dp_folders` 
																						SET 
																						`id_prof_group` = '".$babDB->db_escape_string($id_new_prof_group)."' 
																						WHERE 
																						`id_user` = '".$babDB->db_escape_string($id_user)."' 
																						AND 
																						`id_prof_group` = '".$babDB->db_escape_string($id_old_prof_group)."'
																						");
																					}
																				}
																			}
																		}
																	}
																	$i++;
																}
															}
															$this->action_report_part1 = bab_translate("The accounts of students and teachers have been attached to their newer groups", $GLOBALS["babAddonFolder"]);
															
															// Dsinscription des anciens membres du groupe
															$filter = "(CN=".$CN.")";
															$sr = @ldap_search($ds, $this->base_dn, $filter);
															if ($sr === false) 
															{
																$error_in_ad_reading = true;
																$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
															}
															else
															{
																$temp = @ldap_count_entries($ds, $sr);
																if ($temp === false)
																{
																	$error_in_ad_reading = true;
																	$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
																}
																else
																{
																	if ($temp > 0)
																	{
																		$entry = @ldap_first_entry($ds, $sr);
																		if ($entry === false)
																		{
																			$error_in_ad_reading = true;
																			$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
																		}
																		else
																		{
																			$attributes = @ldap_get_attributes($ds, $entry);
																			if ($attributes === false)
																			{
																				$error_in_ad_reading = true;
																				$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
																			}
																			else
																			{
																				if (in_array("member", $attributes))
																				{
																					$members = @ldap_get_values($ds, $entry, "member");
																					if ($members === false)
																					{
																						$error_in_ad_reading = true;
																						$this->action_error_report = bab_translate("Fatal error in reading ORPEO Active Directory", "synchroad");
																					}
																					else
																					{
																						if (count($members) > 0)
																						{
																							$uid = array();
																							for ($i = 0; $i < count($members) - 1; $i++)
																							{
																								$temp = $members[$i];
																								$temp = ldap_explode_dn($temp, 1);
																								$temp = $temp[0];
																								$uid[] = mb_strtolower($temp);
																							}
																							$res = $babDB->db_query("
																							SELECT 
																							`id_object`,
																							`nickname` 
																							FROM 
																							`bab_users`, 
																							`bab_users_groups` 
																							WHERE 
																							`bab_users`.`id` = `id_object`
																							AND 
																							`id_group` = '".$babDB->db_escape_string($id_group)."' 
																							AND 
																							`db_authentification` = 'N' 
																							");
																							while ($arr = $babDB->db_fetch_array($res))
																							{
																								$id_user = $arr["id_object"];
																								$nickname = mb_strtolower($arr["nickname"]);
																								if (!in_array($nickname, $uid))
																								{
																									bab_detachUserFromGroup($id_user, $id_group);
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
															$this->action_report_part2 = bab_translate("The accounts of students and teachers have been deleted form their former groups", $GLOBALS["babAddonFolder"]);											
														}
													}
												}
											}	
										}
										else
										{
											// Le groupe existe toujours dans Ovidentia mais a t supprim de l'Active Directory d'ORPO ; il est vid de ses utilisateurs s'authentifiant d'aprs l'Active Directory d'ORPO
											$res = $babDB->db_query("
											SELECT
											`id_object`, 
											`nickname` 
											FROM 
											`bab_users`, 
											`bab_users_groups` 
											WHERE
											`bab_users`.`id` = `id_object` 
											AND 
											`id_group` = '".$babDB->db_escape_string($id_group)."' 
											AND 
											`db_authentification` = 'N'
											");
											
											while ($arr = $babDB->db_fetch_array($res))
											{
												$id_user = $arr["id_object"];
												bab_detachUserFromGroup($id_user, $id_group);
											}
										}
									}
								}
							}
						}
					}
					else
					{
						$this->action_error_report = bab_translate("No synchronized group has been found", "synchroad");
					}
					// Lecture de la table des dlgations  la recherche des groupes devant tre inclus dans les dlgations
					list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = $test;
					if ($this->r === false || $this->ds === false)
					{
						$error_in_ad_reading = true;
						$this->action_error_report = bab_translate("Error ! No connexion to ORPEO server.", "synchroad");
					}
					else
					{
						$this->res = $babDB->db_query("
						SELECT 
						`id_deleg`, 
						`bab_dg_groups`.`name`, 
						`e`,
						`c`,
						`n`, 
						`s`, 
						`i` 
						FROM 
						`sad_created_class_deleg`, 
						`bab_dg_groups`, 
						`bab_sites` 
						WHERE 
						`id_deleg` = `bab_dg_groups`.`id` 
						AND 
						`id_site` = `bab_sites`.`id` 
						AND 
						`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS['babSiteName'])."'
						");
						if ($babDB->db_num_rows($this->res) > 0)
						{
							while( list($id_deleg, $deleg_name, $ens, $cycle, $level, $speciality, $iclass ) =  $babDB->db_fetch_array($this->res))
							{
								if (!is_null($ens) && is_null($cycle) && is_null($level) && is_null($speciality) && is_null($iclass))
								{
									// Dlgation au niveau Enseignement
									$base_dn= "OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
								}
								else
								{
									if (!is_null($ens) && !is_null($cycle) && is_null($level) && is_null($speciality )&& is_null($iclass))
									{
										// Dlgation au niveau Cycle
										$base_dn= "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
									}
									else
									{
										if (!is_null($ens) && !is_null($cycle) && !is_null($level) && is_null($speciality )&& is_null($iclass))
										{
											// Dlgation au niveau Niveau
											$base_dn= "OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
										}
										else
										{
											if (!is_null($ens) && !is_null($cycle) && !is_null($speciality )&& is_null($iclass))
											{
												// Dlgation au niveau Spcialit : voir traitement particulier repris plus loin
												unset($base_dn);
											}
											else
											{
												if (!is_null($ens) && !is_null($cycle) && !is_null($level) && !is_null($speciality )&& !is_null($iclass))
												{
													// Dlgation au niveau classe
													$base_dn= "OU=".$level.$cycle.$speciality.$iclass.", OU=".$level.$cycle.$speciality. ",OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
												}
											}
										}
									}
								}
								if (isset ($base_dn))
								{	
									$filter = "(OU=*)";
									$sr = ldap_search($this->ds, $base_dn, $filter);
									$entry = ldap_first_entry($this->ds, $sr);
									while ($entry)
									{
										$dn = ldap_get_dn($this->ds, $entry);
										$temp = ldap_explode_dn($dn, 1);
										if (count($temp) == 11)
										{
											/*
											Si le nom de la classe  est initialis avec son code GEP
											$attr = ldap_get_attributes($this->ds, $entry);
											if (in_array("postalCode", $attr))
											{
												$temp = ldap_get_values($this->ds, $entry, "postalCode");
												$iclass = $temp[0];
											}
											else
											{
												$iclass = $temp[0];
											}
											*/
											$iclass_name = $temp[0];
											$iclass_elv_group_name = $iclass_name.STUDENTS_GROUP_SUFFIX;
											$res = $babDB->db_query("
											SELECT 
											`id` 
											FROM 
											`sad_groups_tree` 
											WHERE 
											`dn` = '".$babDB->db_escape_string("CN=l_eleve".$iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix)."' 
											AND
											`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
											");
											if ($babDB->db_num_rows($res) === 0)
											{
												$warning_in_ad_reading = true;
												$this->unsync_warning_flag = true;
												$unsync_groups_table[] = $iclass_name;
												$this->unsync_groups_list .= "<li>".$iclass_name." (".bab_translate("inside the delegation: ", "synchroad").$deleg_name.")</li>\r\n";
											}
										}
										$entry = ldap_next_entry($this->ds, $entry);
									}
								}
								else // Traitement du cas o la dlgation est pose au niveau Spcialit
								{
									if (!is_null($ens) && !is_null($cycle) && is_null($level) && !is_null($speciality) && is_null($iclass))
									{
										$base_dn = "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
										$filter = "(OU=*)";
										$sr = ldap_search($this->ds, $base_dn, $filter);
										$entry = ldap_first_entry($this->ds, $sr);
										$this->arr = array();
										while ($entry)
										{
											$dn = ldap_get_dn($ds, $entry);
											$temp = ldap_explode_dn($dn, 1);
											if (count($temp) == 11)
											{
												$e = $temp[4];
												$c = $temp[3];
												$l = explode($temp[3], $temp[2]);
												$l = $l[0];
												$s = explode($temp[2], $temp[1]);
												$s = $s[1];
												$iclass_name = $temp[0];
												if (($ens == $e) && ($cycle == $c) && ($speciality == $s))
												{
													$res = $babDB->db_query("
													SELECT 
													`id` 
													FROM 
													`sad_groups_tree` 
													WHERE 
													`dn` = '".$babDB->db_escape_string("CN=l_eleve".$iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix)."' 
													AND 
													`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
													");
													if ($babDB->db_num_rows($res) == 0)
													{
														$warning_in_ad_reading = true;
														$this->unsync_warning_flag = true;
														$unsync_groups_table[] = $iclass_name;
														$this->unsync_groups_list .= "<li>".$iclass_name." (".bab_translate("inside the delegation: ", "synchroad").$deleg_name.")</li>\r\n";
													}
												}
											}
											$entry = ldap_next_entry($this->ds, $entry);
										}
									}
								}
							}
						}
					}
					ldap_close($ds);
				}
				if (!empty($this->unsync_groups_list)) $this->action_warning_report = bab_translate("The groups listed below, newly created in Active Directory, do not correspond to any Ovidentia groups:", "synchroad");
			}
		}
		$obj= new actionAttachAccountsFormClass($test);
		
		if (is_object($babBody))
		{
			if ($error_in_ad_reading)
			{
				$babBody->addError(bab_translate("Unsuccessfull operation!", "synchroad"));
				$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_error"));
			}
			else
			{
				if ($warning_in_ad_reading)
				{
					$babBody->addError(bab_translate("Warning!", "synchroad"));
					$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_warning"));
				}
				else
				{
					$babBody->addError(bab_translate("Successfull operation!", "synchroad"));
					$babBody->babecho(bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_report"));
				}
			}
		}
		return(array($error_in_ad_reading, $warning_in_ad_reading, $desync1_groups_table, $desync2_groups_table, $unsync_groups_table));
	}
?>
