<?php
require_once 'base.php';
require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";
require_once $GLOBALS['babAddonPhpPath']."functions.php";
require_once $GLOBALS['babInstallPath']."admin/register.php";
require_once $GLOBALS['babInstallPath']."utilit/userincl.php";


function actionDeleteDeleg()
{
	global $babBody;
	global $babDB;
	
	$delete_deleg = bab_pp("delete_deleg", array());
	if (count($delete_deleg) > 0)
	{
		$arr_deleg = bab_pp("arr_deleg", array());
		if (count($arr_deleg) > 0)
		{
			for ($i = 0; $i < count($delete_deleg); $i++)
			{
				for ($j = 0; $j < count($arr_deleg); $j++)
				{
					if ($delete_deleg[$i] == $j)
					{
						$arr = unserialize($arr_deleg[$j]);
						$id_deleg = $arr["id_deleg"];
						$res = $babDB->db_query("SELECT `id_group` FROM `bab_dg_groups` WHERE `id` = '".$babDB->db_escape_string($id_deleg)."'");
						if ($babDB->db_num_rows($res) > 0)
						{
							$temp = $babDB->db_fetch_array($res);
							$id_group = $temp["id_group"];
							remove_group_and_all_children($id_group);
						}
						delete_delegation($id_deleg);
						$res = $babDB->db_query("DELETE FROM `sad_created_class_deleg_temp` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						$res = $babDB->db_query("DELETE FROM `sad_created_class_deleg` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						$res = $babDB->db_query("DELETE FROM `sad_created_group_deleg` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						$res = $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
					}
				}
			}
		}
	}
}

function displayDeleteFormerDelegationsForm()
{
	global $babBody;
	class displayDeleteFormerDelegationsFormClass
	{
		function displayDeleteFormerDelegationsFormClass()
		{
			global $babDB;
			
			list($r, $ds, $etab, $domain, $suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->arr = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
				$this->count = count($this->arr);
				$this->deleg_name_label = bab_translate("Delegations name", $GLOBALS["babAddonFolder"]);
				$this->validate = bab_translate("Delete the delegations", $GLOBALS["babAddonFolder"]);
				$this->bg = false;
			}
		}
		
		////////////////////////////////////////////////////		
		function getnext()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{
				$this->bg = !$this->bg;
				$temp = $this->arr[$k];
				$this->group_name = $temp["group_name"];
				$this->arr_deleg = serialize($temp);
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////		
	}
	$obj= new displayDeleteFormerDelegationsFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "delete_delegs_form"));
}

// Action de cration/suppression de dlgations bases sur les groupes interclasses
function actionCreateGroupsDelegForm()
{
	global $babBody;
	class actionCreateGroupsDelegFormClass
	{
		function actionCreateGroupsDelegFormClass()
		{
			global $babDB;
			
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{			
				$this->group_name_label = bab_translate("Inter-classes group", $GLOBALS["babAddonFolder"]);
				$this->deleg_name_label = bab_translate("Delegation", $GLOBALS["babAddonFolder"]);
				$this->deleg_group_name_label = bab_translate("Delegated group", $GLOBALS["babAddonFolder"]);
				$this->manager_label = bab_translate("Delegated administrator", $GLOBALS["babAddonFolder"]);
				$this->manager_login_label = bab_translate("Login", $GLOBALS["babAddonFolder"]);
				$this->manager_lastname_label = bab_translate("Lastname", $GLOBALS["babAddonFolder"]);
				$this->manager_firstname_label = bab_translate("Firstname", $GLOBALS["babAddonFolder"]);
				$this->print_label = bab_translate("Print", $GLOBALS["babAddonFolder"]);
				
				$this->count = count(bab_pp("create_deleg", array()));
				if ($this->count > 0)
				{
					$this->bg = true;
					$this->exist_selected_groups = true;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						if (in_array($i, bab_pp("create_deleg", array())))
						{
							$create_deleg = bab_pp("create_deleg", array());
							for ($j = 0; $j < $this->count; $j++)
							{
								$create_deleg = bab_pp("create_deleg", array());
								$create_deleg = $create_deleg[$j];
								if ($create_deleg == $i)
								{
									$arr_deleg = bab_pp("arr_deleg", array());
									$arr_deleg = $arr_deleg[$i];
									$arr_deleg = unserialize($arr_deleg);
									$this->group_name = $arr_deleg[0];
									$this->deleg_name = $arr_deleg[0];
									$this->deleg_group_name = $arr_deleg[0];
									$manager_dn = $arr_deleg[1];
									$res = $babDB->db_query("SELECT `id`FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
									$id_site = $babDB->db_fetch_array($res);
									$id_site = $id_site[0];
									$res = $babDB->db_query("SELECT `id` FROM `sad_created_group_deleg` WHERE `group_name` = '".$babDB->db_escape_string($this->group_name)."' AND `id_site` = ".$id_site);
									if ($babDB->db_num_rows($res) == 0)
									{
										$res = $babDB->db_query("INSERT INTO `sad_created_group_deleg` (`id_site`, `group_name`, `manager_dn`) VALUES ( ".$id_site.", '".$babDB->db_escape_string($this->group_name)."', '".$manager_dn."')");
										$id_record = $babDB->db_insert_id($res);
									}
									else
									{
										$temp = $babDB->db_fetch_array($res);
										$id_record = $temp["id"];
										$res = $babDB->db_query("UPDATE `sad_created_group_deleg` SET `manager_dn` = '".$babDB->db_escape_string($manager_dn)."' WHERE `id_site` = ".$id_site." AND `group_name` = '".$babDB->db_escape_string($this->group_name)."'");
									}
									$login = ldap_explode_dn($manager_dn, 1);
									$login = $login[0];
									$this->manager_login = $login;
									$base_dn = "OU=prof, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
									$filter = "(cn=".$login.")";
									$sr = ldap_search($this->ds, $base_dn, $filter);
									if (ldap_count_entries($this->ds, $sr) > 0)
									{
										$entry = ldap_first_entry($this->ds, $sr);
										$attributes = ldap_get_attributes($this->ds, $entry);
										if (in_array("sn", $attributes))
										{
											$temp = ldap_get_values($this->ds, $entry, "sn");
											$this->manager_lastname = $temp[0];
										}
										else
										{
											$this->manager_lastname = "";
										}
										if (in_array("givenName", $attributes))
										{
											$temp = ldap_get_values($this->ds, $entry, "givenName");
											$this->manager_firstname = $temp[0];
										}
										else
										{
											$this->manager_firstname = "";
										}
										if (in_array("mail", $attributes))
										{
											$temp = ldap_get_values($this->ds, $entry, "mail");
											$this->manager_mail = $temp[0];
										}
										// Cration ventuelle du compte de l'administrateur dlgu dans Ovidentia
										$res = $babDB->db_query("SELECT `id`FROM `bab_users` WHERE `nickname` = '".$babDB->db_escape_string($login)."'");
										if ($babDB->db_num_rows($res) == 0)
										{
											$firstname = $this->manager_firstname;
											$lastname = $this->manager_lastname;
											$middlename = "";
											$nickname = $this->manager_login;
											$email = $this->manager_mail;
											$password1 = "123456";
											$password2 = $password1;
											$confirmed = true;
											$error = "";
											$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup = true);
											$this->res = $babDB->db_query("UPDATE `bab_users` SET `db_authentification` = 'N' WHERE `id`=".$id_user);
										}
										else
										{
											$id_user = $babDB->db_fetch_array($res);
											$id_user = $id_user[0];
										}
										// Recherche de l'id du sur-groupe groupes inter-classes
										$res = $babDB->db_query("SELECT `id`FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(GIC_GROUP_NAME)."' AND `id_parent`= '".BAB_REGISTERED_GROUP."'");
										$temp = $babDB->db_fetch_array($res);
										$id_gic = $temp["id"];
										// Cration du groupe dlgu et insertion de l'administrateur dlgu dans le groupe dlgu
										$res = $babDB->db_query("SELECT `id`FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($this->deleg_group_name)."' AND `id_parent` = ".$id_gic);
										if ($babDB->db_num_rows($res) == 0)
										{
											$name = $this->deleg_group_name;
											$description = bab_translate("Inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->deleg_group_name;
											$managerid = $id_user;
											$parent = $id_gic;
											$id_deleg_group = bab_createGroup($name, $description, $managerid, $parent);
										}
										else
										{
											$id_deleg_group = $babDB->db_fetch_array($res);
											$id_deleg_group = $id_deleg_group[0];
										}
										$iduser = $id_user;
										$idgroup = $id_deleg_group;
										bab_attachUserToGroup($iduser, $idgroup);
										// Insertion de l'administrateur dgu dans le groupe des administrateurs dlgus
										$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(ADMINS_GROUP_NAME)."' AND `id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'");
										$admins_group_id = $babDB->db_fetch_array($res);
										$admins_group_id = $admins_group_id["id"];
										$iduser = $id_user;
										$idgroup = $admins_group_id;
										bab_attachUserToGroup($iduser, $idgroup);
										// Cration de la dlgation
										$res = $babDB->db_query("SELECT `id` FROM `bab_dg_groups`WHERE `name` = '".$babDB->db_escape_string($this->deleg_name)."'");
										if ($babDB->db_num_rows($res) == 0)
										{
											$name = $this->deleg_name;
											$description = bab_translate("Delegation linked to the inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->deleg_group_name;
											$battach = "N";    
											$users = "N";   
											$groups = "Y";   
											$sections = "Y";     
											$articles = "Y";    
											$faqs = "Y";    
											$forums = "Y";    
											$calendars = "Y";    
											$mails = "Y";    
											$directories = "Y";    
											$approbations = "Y";    
											$filemanager = "Y";    
											$orgchart = "Y";    
											$taskmanager = "Y";    
											$id_group  = $id_deleg_group;  
											$iIdCategory = 0;
											$res = $babDB->db_query("
											INSERT INTO `bab_dg_groups`
											(`name`, `description`, `battach`, `users`, `groups`, `sections`, `articles`, `faqs`, `forums`, `calendars`, `mails`, `directories`, `approbations`, `filemanager`, `orgchart`, `taskmanager`, `id_group`, `iIdCategory`)
											VALUES
											('".$name."', '".$description."', '".$battach."', '".$users."', '".$groups."', '".$sections."', '".$articles."', '".$faqs."', '".$forums."', '".$calendars."', '".$mails."', '".$directories."', '".$approbations."', '".$filemanager."', '".$orgchart."', '".$taskmanager."', ".$id_group.", ".$iIdCategory.")
											");
											$id_deleg = $babDB->db_insert_id($res);
										}
										else
										{
											$id_deleg = $babDB->db_fetch_array($res);
											$id_deleg = $id_deleg["id"];
										}
										// Gestion des ACL pour la dlgation cre (groupe des utilisateurs - enregistrs et non enregistrs - d'Ovidentia )
										$res = $babDB->db_query("DELETE FROM `bab_dg_acl_groups` WHERE `id_object` = ".$id_deleg);
										$res = $babDB->db_query("INSERT INTO `bab_dg_acl_groups`(`id_object`, `id_group`) VALUES (".$id_deleg.", 0)");
										// Nomination de l'administrateur dlgu
										$res = $babDB->db_query("SELECT `id_dg` FROM `bab_dg_admin` WHERE `id_dg` = ".$id_deleg." AND `id_user` = ".$id_user);
										if ($babDB->db_num_rows($res) == 0)
										{
											$res = $babDB->db_query("INSERT INTO `bab_dg_admin` (`id_user`, `id_dg`) VALUES (".$id_user.", ".$id_deleg.")");
										}
										// Mise  jour de la table sad_created_group_deleg de la base de donnes avec le nom de la dlgation
										$res = $babDB->db_query("UPDATE `sad_created_group_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
									}
								}
							}
						}
						else
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$arr_deleg = unserialize($arr_deleg);
							$group_name = $arr_deleg[0];
							$deleg_name = $arr_deleg[0];
							$deleg_group_name = $arr_deleg[0];
							$manager_dn = $arr_deleg[1];
							$res = $babDB->db_query("SELECT `id` FROM `bab_dg_groups`WHERE `name` = '".$babDB->db_escape_string($deleg_name)."'");
							// Suppression de la dlgation
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_deleg = $babDB->db_fetch_array($res);
								$id_deleg = $id_deleg[0];
								delete_delegation($id_deleg);
							}
							// Recherche du groupe dlgu
							$res = $babDB->db_query("SELECT `id`FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(GIC_GROUP_NAME)."' AND `id_parent`= '".BAB_REGISTERED_GROUP."'");
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_gic = $babDB->db_fetch_array($res);
								$id_gic = $id_gic["id"];
							}
							$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($deleg_group_name)."' AND `id_parent` = ".$id_gic);
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_deleg_group = $babDB->db_fetch_array($res);
								$id_deleg_group = $id_deleg_group["id"];
								// Suppression du groupe dlgu et des sous groupes  du groupe dlgu 
								remove_group_and_all_children($id_deleg_group);
								// Suppression de l'enregistrement dans sad_created_group_deleg
								$res = $babDB->db_query("SELECT `id`FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
								$id_site = $babDB->db_fetch_array($res);
								$id_site = $id_site[0];
								$res = $babDB->db_query("DELETE FROM `sad_created_group_deleg` WHERE `group_name` = '".$babDB->db_escape_string($group_name)."' AND `id_site` = ".$id_site);
								// Suppression de l'enregistrement dans la table de correspondance entre groupes Ovidentia et groupes Active Directory d'ORPEO
								$res= $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
							}
						}
					}
					$this->res = $babDB->db_query("SELECT `group_name`, `manager_dn`FROM `sad_created_group_deleg`, `bab_sites` WHERE `id_site`= `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
				}
				else
				{
					$this->exist_selected_groups = false;
					$j = 0;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						$arr_deleg = bab_pp("arr_deleg", array());
						$arr_deleg = $arr_deleg[$i];
						$arr_deleg = unserialize($arr_deleg);
						$this->group_name = $arr_deleg[0];
						$this->deleg_name = $arr_deleg[0];
						$this->deleg_group_name = $arr_deleg[0];
						$manager_dn = $arr_deleg[1];
						$res = $babDB->db_query("SELECT `id` FROM `bab_dg_groups`WHERE `name` = '".$babDB->db_escape_string($this->deleg_name)."'");
						// Suppression de la dlgation
						if ($babDB->db_num_rows($res) > 0)
						{
							$id_deleg = $babDB->db_fetch_array($res);
							$id_deleg = $id_deleg[0];
							delete_delegation($id_deleg);
							// Recherche du groupe dlgu
							$res = $babDB->db_query("SELECT `id`FROM `bab_groups` WHERE `name` = '".GIC_GROUP_NAME."' AND `id_parent`= 1");
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_gic = $babDB->db_fetch_array($res);
								$id_gic = $id_gic["id"];
							}
							$res = $babDB->db_query("SELECT `id`FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($this->deleg_group_name)."' AND `id_parent` = ".$id_gic);
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_deleg_group = $babDB->db_fetch_array($res);
								$id_deleg_group = $id_deleg_group[0];
								// Suppression du groupe dlgu et des sous groupes  du groupe dlgu 
								remove_group_and_all_children($id_deleg_group);
							}
							// Suppression de l'enregistrement dans sad_created_group_deleg
							$res = $babDB->db_query("SELECT `id`FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
							$id_site = $babDB->db_fetch_array($res);
							$id_site = $id_site[0];
							$res = $babDB->db_query("DELETE FROM `sad_created_group_deleg` WHERE `group_name` = '".$babDB->db_escape_string($this->group_name)."' AND `id_site` = ".$id_site);
							// Suppression de l'enregistrement dans la table de correspondance entre groupes Ovidentia et groupes Active Directory d'ORPEO
							$res= $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						}
					}
				}
			}
		}
		////////////////////////////////////////////////////
		function getnext()
		{
			global $babBody;
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{
				$this->bg = !$this->bg;
				$temp = $babDB->db_fetch_array($this->res);
				$this->group_name = $temp["group_name"];
				$this->deleg_name = $temp["group_name"];
				$this->deleg_group_name = $temp["group_name"];
				$manager_dn = $temp["manager_dn"];
				$login = ldap_explode_dn($manager_dn, 1);
				$login = $login[0];
				$this->manager_login = $login;
				$base_dn = "OU=prof, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(cn=".$login.")";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				if (ldap_count_entries($this->ds, $sr) > 0)
				{
					$entry = ldap_first_entry($this->ds, $sr);
					$attributes = ldap_get_attributes($this->ds, $entry);
					if (in_array("sn", $attributes))
					{
						$temp = ldap_get_values($this->ds, $entry, "sn");
						$this->manager_lastname = $temp[0];
					}
					else
					{
						$this->manager_lastname = "";
					}
					if (in_array("givenName", $attributes))
					{
						$temp = ldap_get_values($this->ds, $entry, "givenName");
						$this->manager_firstname = $temp[0];
					}
					else
					{
						$this->manager_firstname = "";
					}
				}
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
	}
	$obj= new actionCreateGroupsDelegFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "create_group_deleg_action"));
} 

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes interclasses
function displayCreateGroupsDelegForm()
{
	global $babBody;
	class displayCreateGroupsDelegFormClass
	{
		function displayCreateGroupsDelegFormClass()
		{
			global $babDB;
			
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$base_dn = "OU=groupe, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(cn=gp_eleve*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$this->arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					$temp = explode("gp_eleve", $temp[0]);
					$temp = $temp[1];
					$attributes = ldap_get_attributes($this->ds, $entry);
					if (in_array("managedBy", $attributes))
					{
						$manager_dn = ldap_get_values($this->ds, $entry, "managedBy");
						$manager_dn = $manager_dn[0];
					}
					else
					{
						$manager_dn = NULL;
					}
					$this->arr[] = array($temp, $manager_dn);
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($this->arr);
				$this->exist_interclasses_groups = false;
				if (count($this->arr) > 0)
				{
					$this->exist_interclasses_groups = true;
					$this->group_label = bab_translate("Inter-classes group", $GLOBALS["babAddonFolder"]);
					$this->admin_label = bab_translate("Managed by", $GLOBALS["babAddonFolder"]);
					$this->admin_lastname_label = bab_translate("Lastname", $GLOBALS["babAddonFolder"]);
					$this->admin_firstname_label = bab_translate("Firstname", $GLOBALS["babAddonFolder"]);
					$this->admin_login_label = bab_translate("Login", $GLOBALS["babAddonFolder"]);
					$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
					$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
					$this->count = count($this->arr);
					$this->validate = bab_translate("Validate", $GLOBALS["babAddonFolder"]);
					$this->bg = true;
					
					$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
					$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
					$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
					$this->info_part_2 = bab_translate(" will be deleted after the 5th step.", $GLOBALS["babAddonFolder"]);
					$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->warning = bab_translate("Error ! No interclasses groups in the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]);
				}
			}
		}
		////////////////////////////////////////////////////
		function getnext()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{
				$this->bg = !$this->bg;
				$this->disabled_flag = "";
				$this->title = "";
				
				$this->created_flag = "";
				
				$this->group = $this->arr[$k][0];
				$res = $babDB->db_query("SELECT `sad_created_group_deleg`.`id` FROM `sad_created_group_deleg`, `bab_sites` WHERE (`group_name` = '".$babDB->db_escape_string($this->group)."') AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->created_flag = " checked=\"checked\"";
				}
				$admin_dn = $this->arr[$k][1];
				if (is_null($admin_dn))
				{
					$this->arr_deleg = serialize($this->arr[$k]);
					$this->admin_login = "";
					$this->admin_lastname = "";
					$this->admin_firstname = "";
					$this->disabled_flag = " disabled=\"disabled\"";
					$this->title = bab_translate("Disabled : no responsible for this group", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->arr_deleg = serialize($this->arr[$k]);
					$login = ldap_explode_dn($admin_dn, 1);
					$login = $login[0];
					$this->admin_login = $login;
					$base_dn = "OU=prof, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
					$filter = "(cn=".$login.")";
					$sr = ldap_search($this->ds, $base_dn, $filter);
					if (ldap_count_entries($this->ds, $sr) > 0)
					{
						$entry = ldap_first_entry($this->ds, $sr);
						$attributes = ldap_get_attributes($this->ds, $entry);
						if (in_array("sn", $attributes))
						{
							$temp = ldap_get_values($this->ds, $entry, "sn");
							$this->admin_lastname = $temp[0];
						}
						else
						{
							$this->admin_lastname = "";
						}
						if (in_array("givenName", $attributes))
						{
							$temp = ldap_get_values($this->ds, $entry, "givenName");
							$this->admin_firstname = $temp[0];
						}
						else
						{
							$this->admin_firstname = "";
						}
						
					}
				}
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////		
	}
	$obj= new displayCreateGroupsDelegFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "create_group_deleg_form"));
}

// Action de cration/suprresion de dlgations bases sur les groupes classes
function actionCreateClassDelegForm()
{
	global $babBody;
	class actionCreateClassDelegFormClass
	{
		function actionCreateClassDelegFormClass()
		{
			global $babDB;
			
			$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(ADMINS_GROUP_NAME)."' AND `id_parent` = ".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."");
			$arr = $babDB->db_fetch_array($res);
			$this->id_admins_group = $arr["id"];
			$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
			$this->cycle_label = bab_translate("Cycle", $GLOBALS["babAddonFolder"]);
			$this->level_label = bab_translate("Level", $GLOBALS["babAddonFolder"]);
			$this->speciality_label = bab_translate("Speciality", $GLOBALS["babAddonFolder"]);
			$this->iclass_label = bab_translate("Class", $GLOBALS["babAddonFolder"]);
			$this->deleg_label = bab_translate("Delegation", $GLOBALS["babAddonFolder"]);
			$this->group_label = bab_translate("Delegated group", $GLOBALS["babAddonFolder"]);
			$this->admin_label = bab_translate("Delegated administrator", $GLOBALS["babAddonFolder"]);
			$this->login_label = bab_translate("Login", $GLOBALS["babAddonFolder"]);
			$this->password_label = bab_translate("Password", $GLOBALS["babAddonFolder"]);
			$this->bg = true;
			if (count(bab_pp("del_deleg", array())) > 0)
			{
				$del_deleg = bab_pp("del_deleg", array());
				for ($i = 0; $i < count($del_deleg); $i++)
				{
					$id_deleg = $del_deleg[$i];
					// Suppression du groupe dlgu et de tous ses sous-groupes
					$res = $babDB->db_query("SELECT `id_group` FROM `bab_dg_groups` WHERE `id` = '".$babDB->db_escape_string($id_deleg)."'");
					$temp = $babDB->db_fetch_array($res);
					$id_group = $temp["id_group"];
					remove_group_and_all_children($id_group);
					// Suppression de la dlgation
					delete_delegation($id_deleg);
					// Suppression de l'enregistrement dans la table de suivi
					$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`id_deleg` = '".$babDB->db_escape_string($id_deleg)."') AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
					// Suppression de l'enregistrement dans la table de correspondance entre groupes Ovidentia et groupes Active Directory d'ORPEO
					$res= $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
				}
			}
			if (count(bab_pp("create_deleg", array())) == 0)
			{
				$this->exist_selected_levels = false;
				if (count(bab_pp("arr_deleg", array())) > 0)
				{
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						$arr_deleg = bab_pp("arr_deleg", array());
						$arr_deleg = $arr_deleg[$i];
						$temp = unserialize($arr_deleg);
						$ens = array_shift($temp);
						$cycle = array_shift($temp);
						$level = array_shift($temp);
						$speciality = array_shift($temp);
						$iclass = array_shift($temp);
						// Suppression des dlgations non slectionnes et ventuellement existantes
						$res = $babDB->db_query("SELECT `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` = '".$iclass."') AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
						if ($babDB->db_num_rows($res) > 0)
						{
							$temp = $babDB->db_fetch_array($res);
							$id_deleg = $temp["id_deleg"];
							$id_deleg_group = $temp["id_group"];
							delete_delegation($id_deleg);
							// Suppression du groupe dlgu et des sous groupes  du groupe dlgu 
							remove_group_and_all_children($id_deleg_group);
							// Suppression de l'enregistrement dans la table de suivi
							$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` = '".$iclass."') AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							// Suppression de l'enregistrement dans la table de correspondance entre groupes Ovidentia et groupes Active Directory d'ORPEO
							$res= $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						}
					}
				}
			}
			else
			{
				$this->exist_selected_levels = true;
				for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
				{
					if (in_array($i, bab_pp("create_deleg", array())))
					{
						for ($j = 0; $j < count(bab_pp("create_deleg", array())); $j++)
						{
							$create_deleg = bab_pp("create_deleg", array());
							$create_deleg = $create_deleg[$j];
							if ($create_deleg == $i)
							{
								$arr_deleg = bab_pp("arr_deleg", array());
								$arr_deleg = $arr_deleg[$create_deleg];
								$table_delegations[] = $arr_deleg;
								$temp = unserialize($arr_deleg);
								$ens = array_shift($temp);
								$cycle = array_shift($temp);
								$level = array_shift($temp);
								$speciality = array_shift($temp);
								$iclass = array_shift($temp);
								$codeGEP = array_shift($temp);
								$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` ='".$level."') AND (`s` = '".$speciality."') AND (`i` = '".$iclass."') AND (`g` = '".$codeGEP."')AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
								if ($babDB->db_num_rows($res) == 0)
								{
									$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
									$insert_id = $babDB->db_insert_id($res);
									$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."', `c` = '".$cycle."', `n` = '".$level."', `s` = '".$speciality."', `i` = '".$iclass."', `g` = '".$codeGEP."' WHERE `id` = ".$insert_id);
								}
							}
						}
					}
					else
					{
						$arr_deleg = bab_pp("arr_deleg", array());
						$arr_deleg = $arr_deleg[$i];
						$temp = unserialize($arr_deleg);
						$ens = array_shift($temp);
						$cycle = array_shift($temp);
						$level = array_shift($temp);
						$speciality = array_shift($temp);
						$iclass = array_shift($temp);
						$codeGEP = array_shift($temp);
						// Suppression des dlgations non slectionnes et ventuellement existantes
						$res = $babDB->db_query("SELECT `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` = '".$iclass."') AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
						if ($babDB->db_num_rows($res) > 0)
						{
							$temp = $babDB->db_fetch_array($res);
							$id_deleg = $temp["id_deleg"];
							$id_deleg_group = $temp["id_group"];
							delete_delegation($id_deleg);
							// Suppression du groupe dlgu et des sous groupes  du groupe dlgu 
							remove_group_and_all_children($id_deleg_group);
							// Suppression de l'enregistrement dans la table de suivi
							$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` = '".$iclass."') AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							// Suppression de l'enregistrement dans la table de correspondance entre groupes Ovidentia et groupes Active Directory d'ORPEO
							$res= $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($id_deleg)."'");
						}
					}
				}
			}
			$res = $babDB->db_query("TRUNCATE TABLE `sad_created_class_deleg`");
			$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg` SELECT * FROM `sad_created_class_deleg_temp`") ;
			$this->res = $babDB->db_query("SELECT `e`, `c`, `n`, `s`, `i`, `g` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`id_site` = `bab_sites`.`id`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."' ) ORDER BY `e` , `c` , `n` , `s` , `i` ");
			
			$this->count = $babDB->db_num_rows($this->res);
			
		}
		////////////////////////////////////////////////////
		function getnext()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{
				$this->bg = !$this->bg;
				$arr_deleg = $babDB->db_fetch_array($this->res);
				$ens = $arr_deleg["e"];
				$cycle = $arr_deleg["c"];
				$level = $arr_deleg["n"];
				$speciality = $arr_deleg["s"];
				$iclass = $arr_deleg["i"];
				$codeGEP = $arr_deleg["g"];
				$this->ens = $ens;
				// Gnration du nom de la dlgation
				if (is_null($cycle))
				{
					$this->cycle = "/";
				}
				else
				{
					$this->cycle = $cycle;
				}
				if (is_null($level))
				{
					$this->level = "/";
				}
				else
				{
					$this->level = $level;
				}
				if (is_null($speciality))
				{
					$this->speciality = "/";
				}
				else
				{
					$this->speciality = $speciality;
				}
				if (is_null($iclass))
				{
					$this->iclass = "/";
				}
				else
				{
					$this->iclass = $iclass;
				}
				if (empty($codeGEP))
				{
					$this->codeGEP = "";
				}
				else
				{
					$this->codeGEP = "(".$codeGEP.")";
				}
				if (is_null($cycle))
				{
					$this->deleg = $ens;
				}
				else
				{
					if (is_null($level) && is_null($speciality))
					{
						$this->deleg = $cycle;
					}
					else
					{
						if (is_null($speciality))
						{
							$this->deleg = $level.$cycle;
						}
						else
						{
							if (is_null($level) && !is_null($speciality))
							{
								$this->deleg = $cycle.$speciality;
							}
							else
							{
								if (is_null($iclass))
								{
									$this->deleg = $cycle.$speciality;
								}
								else
								{
									$this->deleg = $level.$cycle.$speciality.$iclass;
									/*
									if (empty($codeGEP))
									{
										$this->deleg = $level.$cycle.$speciality.$iclass;
									}
									else
									{
										$this->deleg = $codeGEP;
									}
									*/
								}
								
							}
						}
					}
				}
				// Cration ventuelle du compte de l'administrateur dlgu
				$firstname = "Admin";
				$lastname= $this->deleg;
				$middlename = "";
				$email = "a_saisir@serveur.ext";
				$nickname = $lastname.$firstname;
				$password = random_password(LENGTH);
				$password1 = $password;
				$password2 = $password;
				$confirmed = true;
				$error = "";
				$res = $babDB->db_query("SELECT `id`FROM `bab_users` WHERE `nickname` = '".$babDB->db_escape_string($nickname)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup = true);
					$res = $babDB->db_query("UPDATE `bab_users` SET `db_authentification` = 'Y' WHERE `id`=".$id_user);
				}
				else
				{
					$password = str_pad("*", LENGTH, "*");
					$id_user = $babDB->db_fetch_array($res);
					$id_user = $id_user[0];
				}
				$this->login = $nickname;
				$this->password = $password;
				// Gnration du nom du groupe dlgu et dtermination du groupe parent
				if (is_null($cycle))
				{
					$group_name = $this->deleg;
					$name = $group_name;
					$description = bab_translate("Delegated group for", $GLOBALS["babAddonFolder"])." ".$group_name;
					$managerid = $id_user;
					$parent = 1;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".BAB_REGISTERED_GROUP);
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_deleg_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_deleg_group = $temp["id"];
					}
					$this->group = bab_translate("Registered users", $GLOBALS["babAddonFolder"])." > ".$group_name;					
				}
				else
				{
					$name = $this->ens;
					$description = bab_translate("Global group for", $GLOBALS["babAddonFolder"])." ".$name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = 1;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_parent_group = bab_createGroup( $name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_parent_group = $temp["id"];
					}
					$name = $this->deleg;
					$description = bab_translate("Delegated group for", $GLOBALS["babAddonFolder"])." ".$name;
					$managerid = $id_user;
					$parent = $id_parent_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$id_parent_group);
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_deleg_group = bab_createGroup( $name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_deleg_group = $temp["id"];
					}
					$this->group = bab_translate("Registered users", $GLOBALS["babAddonFolder"])." > ".$this->ens." > ".$this->deleg;
				}				
				// Insertion de l'administrateur dlgu dans le groupe des administrateurs dlgus
				$iduser = $id_user;
				$idgroup = $this->id_admins_group;
				bab_attachUserToGroup($iduser, $idgroup);
				// Insertion de l'administrateur dlgu dans le groupe dlgu
				$iduser = $id_user;
				$idgroup = $id_deleg_group;
				bab_attachUserToGroup($iduser, $idgroup);
				// Cration de la dlgation
				$res = $babDB->db_query("SELECT `id` FROM `bab_dg_groups`WHERE `name` = '".$babDB->db_escape_string($this->deleg)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$name = $this->deleg;
					$description = bab_translate("Delegation linked to the group", $GLOBALS["babAddonFolder"])." ".$this->deleg;
					$battach = "N";    
					$users = "N";   
					$groups = "Y";   
					$sections = "Y";     
					$articles = "Y";    
					$faqs = "Y";    
					$forums = "Y";    
					$calendars = "Y";    
					$mails = "Y";    
					$directories = "Y";    
					$approbations = "Y";    
					$filemanager = "Y";    
					$orgchart = "Y";    
					$taskmanager = "Y";    
					$id_group  = $id_deleg_group;  
					$iIdCategory = 0;
					$res = $babDB->db_query("
					INSERT INTO `bab_dg_groups`
					(`name`, `description`, `battach`, `users`, `groups`, `sections`, `articles`, `faqs`, `forums`, `calendars`, `mails`, `directories`, `approbations`, `filemanager`, `orgchart`, `taskmanager`, `id_group`, `iIdCategory`)
					VALUES
					('".$name."', '".$description."', '".$battach."', '".$users."', '".$groups."', '".$sections."', '".$articles."', '".$faqs."', '".$forums."', '".$calendars."', '".$mails."', '".$directories."', '".$approbations."', '".$filemanager."', '".$orgchart."', '".$taskmanager."', ".$id_group.", ".$iIdCategory.")
					");
					$id_deleg = $babDB->db_insert_id($res);
				}
				else
				{
					$id_deleg = $babDB->db_fetch_array($res);
					$id_deleg = $id_deleg["id"];
				}
				// Gestion des ACL pour la dlgation cre
				$res = $babDB->db_query("DELETE FROM `bab_dg_acl_groups` WHERE `id_object` = ".$id_deleg);
				$res = $babDB->db_query("INSERT INTO `bab_dg_acl_groups`(`id_object`, `id_group`) VALUES (".$id_deleg.", 0)");
				// Nomination de l'administrateur dlgu
				$res = $babDB->db_query("SELECT `id_dg` FROM `bab_dg_admin` WHERE `id_dg` = ".$id_deleg." AND `id_user` = ".$id_user);
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_dg_admin` (`id_user`, `id_dg`) VALUES (".$id_user.", ".$id_deleg.")");
				}
				// Mise  jour de la table sad_created_class_deleg de la base de donnes avec le nom de la dlgation
				if (is_null($cycle))
				{
					$res = $babDB->db_query("SELECT `id` FROM `sad_created_class_deleg` WHERE `e` = '".$babDB->db_escape_string($ens)."' AND `c` IS NULL AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL");
					if ($babDB->db_num_rows($res) > 0)
					{
						$id_record = $babDB->db_fetch_array($res);
						$id_record = $id_record["id"];
						$res = $babDB->db_query("UPDATE `sad_created_class_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
					}
				}
				else
				{
					if (is_null($level) && is_null($speciality))
					{
						$res = $babDB->db_query("SELECT `id` FROM `sad_created_class_deleg` WHERE `e` = '".$babDB->db_escape_string($ens)."' AND `c` = '".$babDB->db_escape_string($cycle)."' AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL");
						if ($babDB->db_num_rows($res) > 0)
						{
							$id_record = $babDB->db_fetch_array($res);
							$id_record = $id_record["id"];
							$res = $babDB->db_query("UPDATE `sad_created_class_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
						}
					}
					else
					{
						if (is_null($speciality))
						{
							$res = $babDB->db_query("SELECT `id` FROM `sad_created_class_deleg` WHERE `e` = '".$babDB->db_escape_string($ens)."' AND `c` = '".$babDB->db_escape_string($cycle)."' AND `n` = '".$babDB->db_escape_string($level)."' AND `s` IS NULL AND `i` IS NULL");
							if ($babDB->db_num_rows($res) > 0)
							{
								$id_record = $babDB->db_fetch_array($res);
								$id_record = $id_record["id"];
								$res = $babDB->db_query("UPDATE `sad_created_class_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
							}
						}
						else
						{
							if (is_null($level) && !is_null($speciality))
							{
								$res = $babDB->db_query("SELECT `id` FROM `sad_created_class_deleg` WHERE `e` = '".$babDB->db_escape_string($ens)."' AND `c` = '".$babDB->db_escape_string($cycle)."' AND `n` IS NULL AND `s` = '".$babDB->db_escape_string($speciality)."'  AND `i` IS NULL");
								if ($babDB->db_num_rows($res) > 0)
								{
									$id_record = $babDB->db_fetch_array($res);
									$id_record = $id_record["id"];
									$res = $babDB->db_query("UPDATE `sad_created_class_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
								}
							}
							else
							{
								if (!is_null($iclass))
								{
									$res = $babDB->db_query("SELECT `id` FROM `sad_created_class_deleg` WHERE `e` = '".$babDB->db_escape_string($ens)."' AND `c` = '".$babDB->db_escape_string($cycle)."' AND `n` = '".$babDB->db_escape_string($level)."' AND `s` = '".$babDB->db_escape_string($speciality)."'  AND `i` = '".$babDB->db_escape_string($iclass)."'");
									if ($babDB->db_num_rows($res) > 0)
									{
										$id_record = $babDB->db_fetch_array($res);
										$id_record = $id_record["id"];
										$res = $babDB->db_query("UPDATE `sad_created_class_deleg` SET `id_deleg` = ".$id_deleg." WHERE `id` = ".$id_record);
									}
								}
							}
						}
					}
				}
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new actionCreateClassDelegFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "create_class_deleg_action"));
}

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes classes (tape 5)
function displayCreateClassesStep5Form()
{
	global $babBody;
	class displayCreateClassesStep5FormClass
	{
		function displayCreateClassesStep5FormClass()
		{
			global $babDB;
			
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->deleted_delegations = array();
				
				$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
				$this->cycle_label = bab_translate("Cycle", $GLOBALS["babAddonFolder"]);
				$this->level_label = bab_translate("Level", $GLOBALS["babAddonFolder"]);
				$this->speciality_label = bab_translate("Speciality", $GLOBALS["babAddonFolder"]);
				$this->iclass_label = bab_translate("Class", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->validate = bab_translate("Validate all five steps", $GLOBALS["babAddonFolder"]);
				$this->bg = true;
				if (count(bab_pp("previous_create_deleg", array())) == 0)
				{
					$this->exist_previous_selected_levels = false;
				}
				else
				{
						$this->exist_previous_selected_levels = true;
				}
				$this->count1 = count(bab_pp("previous_create_deleg", array()));
				if (count(bab_pp("create_deleg", array())) == 0)
				{
					$this->exist_selected_levels = false;
					if (count(bab_pp("arr_deleg", array())) > 0)
					{
						for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							$level = array_shift($temp);
							$speciality = array_shift($temp);
							if (is_null($level))
							{
								
								$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id`, `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_dg_groups`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`id_deleg` = `bab_dg_groups`.`id`) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
							else
							{
								$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id`, `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_dg_groups`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`id_deleg` = `bab_dg_groups`.`id`) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
							// Marquage de la suppression de la dlgation
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_record = $temp["id"];
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`id_deleg` = '".$babDB->db_escape_string($id_deleg)."') AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}							
						}
					}
				}
				else
				{
					$this->exist_selected_levels = true;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						if (in_array($i, bab_pp("create_deleg", array())))
						{
							for ($j = 0; $j < count(bab_pp("create_deleg", array())); $j++)
							{
								$create_deleg = bab_pp("create_deleg", array());
								$create_deleg = $create_deleg[$j];
								if ($create_deleg == $i)
								{
									$arr_deleg = bab_pp("arr_deleg", array());
									$arr_deleg = $arr_deleg[$create_deleg];
									$temp = unserialize($arr_deleg);
									$ens = array_shift($temp);
									$cycle = array_shift($temp);
									$level = array_shift($temp);
									$speciality = array_shift($temp);
									if (is_null($level))
									{
										$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
										if ($babDB->db_num_rows($res) == 0)
										{
											$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
											$insert_id = $babDB->db_insert_id($res);
											$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."', `c` = '".$cycle."', `n` = NULL, `s` = '".$speciality."' WHERE `id` = ".$insert_id);
										}
									}
									else
									{
										$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` ='".$level."') AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
										if ($babDB->db_num_rows($res) == 0)
										{
											$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
											$insert_id = $babDB->db_insert_id($res);
											$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."', `c` = '".$cycle."', `n` = '".$level."', `s` = '".$speciality."' WHERE `id` = ".$insert_id);
										}
									}
								}
							}
						}
						else
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							$level = array_shift($temp);
							$speciality = array_shift($temp);
							if (is_null($level))
							{
								
								$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id`, `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_dg_groups`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`id_deleg` = `bab_dg_groups`.`id`) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
							else
							{
								$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id`, `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_dg_groups`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` = '".$speciality."') AND (`i` IS NULL) AND (`id_deleg` = `bab_dg_groups`.`id`) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
							// Marquage de la suppression de la dlgation
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_record = $temp["id"];
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								$id_deleg_group = $temp["id_group"];
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query ("DELETE FROM `sad_created_class_deleg_temp` WHERE `id` = '".$babDB->db_escape_string($id_record)."'");
							}
						}
					}
				}
				$this->count2 = count(bab_pp("create_deleg", array()));
				$base_dn = "OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(OU=*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					if (count($temp) == 11)
					{
						$iclass = explode($temp[1], $temp[0]);
						$iclass = $iclass[1];
						$speciality = explode($temp[2], $temp[1]);
						$speciality = $speciality[1];
						$level = explode($temp[3], $temp[2]);
						$level = $level[0];
						$cycle = $temp[3];
						$ens = $temp[4];
						$attr = ldap_get_attributes($this->ds, $entry);
						if (in_array("postalCode", $attr))
						{
							$codeGEP = ldap_get_values($this->ds, $entry, "postalCode");
							$codeGEP = $codeGEP[0];
						}
						else
						{
							$codeGEP = "";
						}
						$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE ((`e` = '".$ens."' AND `c` IS NULL AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL) OR (`e` = '".$ens."' AND `c` = '".$cycle."' AND (`n` IS NULL OR `n` = '".$level."') AND `s` IS NULL AND `i` IS NULL) OR (`e` = '".$ens."' AND `c` = '".$cycle."' AND  `s` = '".$speciality."' AND `i` IS NULL)) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
						if ($babDB->db_num_rows($res) === 0)
						{
							$arr[] = array($ens, $cycle, $level, $speciality, $iclass, $codeGEP);
						}
					}
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($arr);
				$this->deleg = array();
				if (count($arr) > 0)
				{
					$this->deleg[0] = $arr[0];
					for ($i = 1; $i < count($arr); $i++)
					{
						if ($arr[$i] != $arr[$i - 1])
						{
							$this->deleg[] = $arr[$i];
						}
					}
				}
				$this->count3 = count($this->deleg);
				
				$del_deleg = bab_pp("del_deleg", array());
				if (count($del_deleg) > 0)
				{
					for ($i = 0; $i < count($del_deleg); $i++)
					{
						$this->deleted_delegations[] = $del_deleg[$i];
					}
				}
				$this->count4 = count($this->deleted_delegations);

				$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
				$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
				$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
				$this->info_part_2 = bab_translate(" will be deleted.", $GLOBALS["babAddonFolder"]);
				$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);
			}
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			static $k=0;
			if ( $k < $this->count1 )
			{
				$this->bg = !$this->bg;
				$previous_create_deleg = bab_pp("previous_create_deleg", array());
				$previous_create_deleg = $previous_create_deleg[$k];
				$temp = unserialize($previous_create_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					$selected_level = $deleg_element;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							if (is_null($deleg_element))
							{
								$this->level = "/";
							}
							else
							{
								$this->level = $deleg_element;
							}
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->selected_level = $selected_level;
				$this->arr_deleg = $previous_create_deleg;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext2()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$this->bg = !$this->bg;
				$create_deleg = bab_pp("create_deleg", array());
				$create_deleg = $create_deleg[$k];
				$arr_deleg = bab_pp("arr_deleg", array());
				$arr_deleg = $arr_deleg[$create_deleg];
				$temp = unserialize($arr_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							if (is_null($deleg_element))
							{
								$this->level = "/";
							}
							else
							{
								$this->level = $deleg_element;
							}
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->arr_deleg = $arr_deleg;
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext3()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count3 )
			{
				$this->checked_flag = "";
				$this->disabled_flag = "";
				$this->title = "";
				$this->deleg_name = "";
				
				$this->bg = !$this->bg;
				$temp = array_shift($this->deleg);
				$this->ens = $temp[0];
				$this->cycle = $temp[1];
				$this->level = $temp[2];
				$this->speciality = $temp[3];
				$this->iclass = $temp[4];
				$this->codeGEP = $temp[5];
				if (empty($this->codeGEP))
				{
					$this->notempty_codeGEP = false;
				}
				else
				{
					$this->notempty_codeGEP = true;
				}
				$this->arr_deleg = serialize($temp);
				$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` FROM `bab_dg_groups`, `sad_created_class_deleg_temp`, `bab_sites` WHERE (`bab_dg_groups`.`id` = `id_deleg`) AND(`e` = '".$this->ens."') AND (`c` = '".$this->cycle."') AND (`n` = '".$this->level."') AND (`s` ='".$this->speciality."') AND (`i` = '".$this->iclass."') AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->checked_flag = " checked";
					$temp = $babDB->db_fetch_array($res);
					$this->deleg_name = $temp["name"];
				}
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext4()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count4 )
			{
				$this->del_deleg = $this->deleted_delegations[$k];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////		
	}
	$obj= new displayCreateClassesStep5FormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "createadminsstep5form"));
}

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes classes (tape 4)
function displayCreateClassesStep4Form()
{
	global $babBody;
	class displayCreateClassesStep4FormClass
	{
		function displayCreateClassesStep4FormClass()
		{
			global $babDB;
			
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->deleted_delegations = array();
				
				$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
				$this->cycle_label = bab_translate("Cycle", $GLOBALS["babAddonFolder"]);
				$this->level_label = bab_translate("Level", $GLOBALS["babAddonFolder"]);
				$this->speciality_label = bab_translate("Speciality", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->validate = bab_translate("Next", $GLOBALS["babAddonFolder"]);
				$this->bg = true;
				if (count(bab_pp("previous_create_deleg", array())) == 0)
				{
					$this->exist_previous_selected_levels = false;
				}
				else
				{
						$this->exist_previous_selected_levels = true;
				}
				$this->count1 = count(bab_pp("previous_create_deleg", array()));
				if (count(bab_pp("create_deleg", array())) == 0)
				{
					$this->exist_selected_levels = false;
					if (count(bab_pp("arr_deleg", array())) > 0)
					{
						for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							$level = array_shift($temp);
							// Suppression des dlgations non slectionnes et ventuellement existantes
							$res = $babDB->db_query("SELECT `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				else
				{
					$this->exist_selected_levels = true;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						if (in_array($i, bab_pp("create_deleg", array())))
						{
							for ($j = 0; $j < count(bab_pp("create_deleg", array())); $j++)
							{
								$create_deleg = bab_pp("create_deleg", array());
								$create_deleg = $create_deleg[$j];
								if ($create_deleg == $i)
								{
									$arr_deleg = bab_pp("arr_deleg", array());
									$arr_deleg = $arr_deleg[$create_deleg];
									$temp = unserialize($arr_deleg);
									$ens = array_shift($temp);
									$cycle = array_shift($temp);
									$level = array_shift($temp);
									$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
									if ($babDB->db_num_rows($res) == 0)
									{
										$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
										$insert_id = $babDB->db_insert_id($res);
										$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."', `c` = '".$cycle."', `n` = '".$level."' WHERE `id` = ".$insert_id);
									}
								}
							}
						}
						else
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							$level = array_shift($temp);
							// Suppression des dlgations non slectionnes et ventuellement existantes
							$res = $babDB->db_query("SELECT `id_deleg`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` = '".$level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				$this->count2 = count(bab_pp("create_deleg", array()));
				$base_dn = "OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(OU=*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					if (count($temp) == 10)
					{
						$speciality = explode($temp[1], $temp[0]);
						$speciality = $speciality[1];
						$level = explode($temp[2], $temp[1]);
						// $level = $level[0]; Le niveau n'est pas considr au moment du choix de la spcialit
						$level = null;
						$cycle = $temp[2];
						$ens = $temp[3];
						$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE ((`e` = '".$ens."' AND `c` IS NULL AND `s` IS NULL AND `i` IS NULL) OR (`e` = '".$ens."' AND `c` = '".$cycle."' AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL) OR (`e` = '".$ens."' AND `c` = '".$cycle."' AND  `s` IS NULL AND `i` IS NULL)) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
						if ($babDB->db_num_rows($res) === 0)
						{
							$arr[] = array($ens, $cycle, $level, $speciality);
						}
					}
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($arr);
				$this->deleg = array();
				if (count($arr) > 0)
				{
					$this->deleg[0] = $arr[0];
					for ($i = 1; $i < count($arr); $i++)
					{
						if ($arr[$i] != $arr[$i - 1])
						{
							$this->deleg[] = $arr[$i];
						}
					}
				}
				$this->count3 = count($this->deleg);
				
				$del_deleg = bab_pp("del_deleg", array());
				if (count($del_deleg) > 0)
				{
					for ($i = 0; $i < count($del_deleg); $i++)
					{
						$this->deleted_delegations[] = $del_deleg[$i];
					}
				}
				$this->count4 = count($this->deleted_delegations);
				
				$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
				$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
				$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
				$this->info_part_2 = bab_translate(" will be deleted.", $GLOBALS["babAddonFolder"]);
				$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);
			}
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			static $k=0;
			if ( $k < $this->count1 )
			{
				$this->bg = !$this->bg;
				$previous_create_deleg = bab_pp("previous_create_deleg", array());
				$previous_create_deleg = $previous_create_deleg[$k];
				$temp = unserialize($previous_create_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					$selected_level = $deleg_element;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							$this->level = $deleg_element;
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->selected_level = $selected_level;
				$this->arr_deleg = $previous_create_deleg;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext2()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$create_deleg = bab_pp("create_deleg", array());
				$create_deleg = $create_deleg[$k];
				$arr_deleg = bab_pp("arr_deleg", array());
				$arr_deleg = $arr_deleg[$create_deleg];
				$this->bg = !$this->bg;
				$temp = unserialize($arr_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							$this->level = $deleg_element;
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->arr_deleg = $arr_deleg;
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext3()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count3 )
			{
				$this->checked_flag = "";
				$this->disabled_flag = "";
				$this->title = "";
				$this->deleg_name = "";
				
				$this->bg = !$this->bg;
				$temp = array_shift($this->deleg);
				$this->ens = $temp[0];
				$this->cycle = $temp[1];
				$this->level = "/";
				$this->speciality = $temp[3];
				$this->arr_deleg = serialize($temp);
				$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` FROM `bab_dg_groups`, `sad_created_class_deleg_temp`, `bab_sites` WHERE (`bab_dg_groups`.`id` = `id_deleg`) AND (`e` = '".$this->ens."') AND (`c` = '".$this->cycle."') AND (`s` ='".$this->speciality."') AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->checkbox_name = "create_deleg";
					$this->checked_flag = " checked";
					$temp = $babDB->db_fetch_array($res);
					$this->deleg_name = $temp["name"];
				}
				else
				{
					$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$this->ens."') AND ((`c` = '".$this->cycle."') OR (`c` IS NULL)) AND (`s` = '".$this->speciality."') AND (`i` IS NOT NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
					if ($babDB->db_num_rows($res) > 0)
					{
						$this->checkbox_name = "do_not_create_deleg";
						$this->disabled_flag = " disabled";
						$this->title = bab_translate("Disabled : existing sub-levels delegations", $GLOBALS["babAddonFolder"]);
					}
					else
					{
						$this->checkbox_name = "create_deleg";
					}
				}
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext4()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count4 )
			{
				$this->del_deleg = $this->deleted_delegations[$k];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
	}
	$obj= new displayCreateClassesStep4FormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "createadminsstep4form"));
}

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes classes (tape 3)
function displayCreateClassesStep3Form()
{
	global $babBody;
	class displayCreateClassesStep3FormClass
	{
		function displayCreateClassesStep3FormClass()
		{
			global $babDB;
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->deleted_delegations = array();
				
				$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
				$this->cycle_label = bab_translate("Cycle", $GLOBALS["babAddonFolder"]);
				$this->level_label = bab_translate("Level", $GLOBALS["babAddonFolder"]);
				$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->validate = bab_translate("Next", $GLOBALS["babAddonFolder"]);
				$this->bg = true;
				if (count(bab_pp("previous_create_deleg", array())) == 0)
				{
					$this->exist_previous_selected_levels = false;
				}
				else
				{
					$this->exist_previous_selected_levels = true;
				}
				$this->count1 = count(bab_pp("previous_create_deleg", array()));
				if (count(bab_pp("create_deleg", array())) == 0)
				{
					$this->exist_selected_levels = false;
					if (count(bab_pp("arr_deleg", array())) > 0)
					{
						for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							// Suppression des dlgations non slectionnes et ventuellement existantes
							$res = $babDB->db_query("SELECT `id_deleg`, `id_group`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				else
				{
					$this->exist_selected_levels = true;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						if (in_array($i, bab_pp("create_deleg", array())))
						{
							for ($j = 0; $j < count(bab_pp("create_deleg", array())); $j++)
							{
								$create_deleg = bab_pp("create_deleg", array());
								$create_deleg = $create_deleg[$j];
								if ($create_deleg == $i)
								{
									$arr_deleg = bab_pp("arr_deleg", array());
									$arr_deleg = $arr_deleg[$create_deleg];
									$temp = unserialize($arr_deleg);
									$ens = array_shift($temp);
									$cycle = array_shift($temp);
									$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
									if ($babDB->db_num_rows($res) == 0)
									{
										$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
										$insert_id = $babDB->db_insert_id($res);
										$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."', `c` = '".$cycle."' WHERE `id` = ".$insert_id);
									}
								}
							}
						}
						else
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$cycle = array_shift($temp);
							// Suppression des dlgations non slectionnes et ventuellement existantes
							$res = $babDB->db_query("SELECT `id_deleg`, `id_group`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` = '".$cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				$this->count2 = count(bab_pp("create_deleg", array()));
				$base_dn = "OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(OU=*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					if (count($temp) == 9)
					{
						$level = explode($temp[1], $temp[0]);
						$level = $level[0];
						$cycle = $temp[1];
						$ens = $temp[2];
						$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE ((`e` = '".$ens."' AND `c` IS NULL and `n` IS NULL AND `s` IS NULL AND `i` IS NULL ) OR (`e` = '".$ens."' AND `c` = '".$cycle."' AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL)) AND (`id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
						if ($babDB->db_num_rows($res) === 0)
						{
							$arr[] = array($ens, $cycle, $level);
						} 
					}
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($arr);
				$this->deleg = array();
				if (count($arr) > 0)
				{
					$this->deleg[0] = $arr[0];
					for ($i = 1; $i < count($arr); $i++)
					{
						if ($arr[$i] != $arr[$i - 1])
						{
							$this->deleg[] = $arr[$i];
						}
					}
				}
				$this->count3 = count($this->deleg);

				$del_deleg = bab_pp("del_deleg", array());
				if (count($del_deleg) > 0)
				{
					for ($i = 0; $i < count($del_deleg); $i++)
					{
						$this->deleted_delegations[] = $del_deleg[$i];
					}
				}
				$this->count4 = count($this->deleted_delegations);
				
				$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
				$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
				$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
				$this->info_part_2 = bab_translate(" will be deleted.", $GLOBALS["babAddonFolder"]);
				$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);

			}
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			static $k=0;
			if ( $k < $this->count1 )
			{
				$this->bg = !$this->bg;
				$previous_create_deleg = bab_pp("previous_create_deleg", array());
				$previous_create_deleg = $previous_create_deleg[$k];
				$temp = unserialize($previous_create_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					$selected_level = $deleg_element;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							$this->level = $deleg_element;
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->arr_deleg = $previous_create_deleg;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext2()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$this->bg = !$this->bg;
				$create_deleg = bab_pp("create_deleg", array());
				$create_deleg = $create_deleg[$k];
				$arr_deleg = bab_pp("arr_deleg", array());
				$arr_deleg = $arr_deleg[$create_deleg];
				$temp = unserialize($arr_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					$selected_level = $deleg_element;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							$this->level = $deleg_element;
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->arr_deleg = $arr_deleg;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext3()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count3 )
			{
				$this->checked_flag = "";
				$this->disabled_flag = "";
				$this->title = "";
				$this->deleg_name = "";
				
				$this->bg = !$this->bg;
				$temp = array_shift($this->deleg);
				$this->ens = $temp[0];
				$this->cycle = $temp[1];
				$this->level = $temp[2];
				$this->arr_deleg = serialize($temp);
				$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` FROM `bab_dg_groups`, `sad_created_class_deleg_temp`, `bab_sites` WHERE ((`bab_dg_groups`.`id` = `id_deleg`)) AND (`e` = '".$this->ens."') AND (`c` = '".$this->cycle."') AND (`n` ='".$this->level."') AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) == 0)
				{
					$this->checkbox_name = "create_deleg";
				}
				else
				{
					$this->checkbox_name = "create_deleg";
					$this->checked_flag = " checked";
					$temp = $babDB->db_fetch_array($res);
					$this->deleg_name = $temp["name"];
				}
				$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$this->ens."') AND ((`c` = '".$this->cycle."') OR (`c` IS NULL)) AND ((`s` IS NOT NULL) OR (`i` IS NOT NULL)) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->checkbox_name = "do_not_create_deleg";
					$this->disabled_flag = " disabled";
					$this->title = bab_translate("Disabled : existing sub-levels delegations", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->checkbox_name = "create_deleg";
				}
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext4()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count4 )
			{
				$this->del_deleg = $this->deleted_delegations[$k];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		
	}
	$obj= new displayCreateClassesStep3FormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "createadminsstep3form"));
}

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes classes (tape 2)
function displayCreateClassesStep2Form()
{
	global $babBody;
	class displayCreateClassesStep2FormClass
	{
		function displayCreateClassesStep2FormClass()
		{
			global $babDB;
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->deleted_delegations = array();
				
				$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
				$this->cycle_label = bab_translate("Cycle", $GLOBALS["babAddonFolder"]);
				$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
				$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
				$this->validate = bab_translate("Next", $GLOBALS["babAddonFolder"]);
				$this->bg = true;
				if (count(bab_pp("create_deleg","")) == 0)
				{
					$this->exist_selected_levels = false;
					if (count(bab_pp("arr_deleg", array())) > 0)
					{
						for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
						{
							// Marquage  la suppression des dlgations non slectionnes et ventuellement existantes
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							$res = $babDB->db_query("SELECT `id_deleg` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				else
				{
					$this->exist_selected_levels = true;
					for ($i = 0; $i < count(bab_pp("arr_deleg", array())); $i++)
					{
						if (in_array($i, bab_pp("create_deleg", array())))
						{
							for ($j = 0; $j < count(bab_pp("create_deleg", array())); $j++)
							{
								$create_deleg = bab_pp("create_deleg", array());
								$create_deleg = $create_deleg[$j];
								if ($create_deleg == $i)
								{
									$arr_deleg = bab_pp("arr_deleg", array());
									$arr_deleg = $arr_deleg[$create_deleg];
									$temp = unserialize($arr_deleg);
									$ens = array_shift($temp);
									$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
									if ($babDB->db_num_rows($res) == 0)
									{
										$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` (`id_site`) SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
										$insert_id = $babDB->db_insert_id($res);
										$res = $babDB->db_query("UPDATE `sad_created_class_deleg_temp` SET `e` = '".$ens."' WHERE `id` = ".$insert_id);
									}
								}
							}
						}
						else
						{
							$arr_deleg = bab_pp("arr_deleg", array());
							$arr_deleg = $arr_deleg[$i];
							$temp = unserialize($arr_deleg);
							$ens = array_shift($temp);
							// Marquage  la suppression des dlgations non slectionnes et ventuellement existantes
							$res = $babDB->db_query("SELECT `id_deleg`, `id_group`, `id_group` FROM `sad_created_class_deleg_temp`, `bab_sites`, `bab_dg_groups` WHERE (`e` = '".$ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."') AND (`id_deleg` = `bab_dg_groups`. `id`)");
							if ($babDB->db_num_rows($res) > 0)
							{
								$temp = $babDB->db_fetch_array($res);
								$id_deleg = $temp["id_deleg"];
								$this->deleted_delegations[] = $id_deleg;
								// Suppression de l'enregistrement dans la table de suivi
								$res = $babDB->db_query("DELETE `sad_created_class_deleg_temp`.* FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
							}
						}
					}
				}
				$this->count1 = count(bab_pp("create_deleg", array()));
				if ($this->count1 == 0)
				{
					$this->exist_selected_levels = false;
				}
				else
				{
					$this->exist_selected_levels = true;
				}
				$this->bg = true;
				$base_dn = "OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(OU=*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					if (count($temp) == 8)
					{
						$cycle = $temp[0];
						$ens = $temp[1];
						$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$ens."' AND `c` IS NULL AND `n` IS NULL AND `s` IS NULL AND `i` IS NULL) AND (`id_site` = `bab_sites`.`id`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
						if ($babDB->db_num_rows($res) == 0)
						{
							$arr[] = array($ens, $cycle);
						}
					}
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($arr);
				$this->deleg = array();
				if (count($arr) > 0)
				{
					$this->deleg[0] = $arr[0];
					for ($i = 1; $i < count($arr); $i++)
					{
						if ($arr[$i] != $arr[$i - 1])
						{
							$this->deleg[] = $arr[$i];
						}
					}
					if (count(bab_pp("create_deleg","")) == 0)
					{
						$this->exist_selected_levels = false;
					}
					else
					{
						$this->exist_selected_levels = true;
					}	
				}
				$this->count2 = count($this->deleg);
				
				$this->count3 = count($this->deleted_delegations);
				
				$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
				$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
				$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
				$this->info_part_2 = bab_translate(" will be deleted.", $GLOBALS["babAddonFolder"]);
				$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);
			}
		}
		////////////////////////////////////////////////////
		function getnext1()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count1 )
			{
				$create_deleg = bab_pp("create_deleg", array());
				$create_deleg = $create_deleg[$k];
				$arr_deleg = bab_pp("arr_deleg", array());
				$arr_deleg = $arr_deleg[$create_deleg];
				$this->bg = !$this->bg;
				$temp = unserialize($arr_deleg);
				$this->ens = "/";
				$this->cycle = "/";
				$this->level = "/";
				$this->speciality = "/";
				$this->iclass = "/";
				$l = 0;
				while ($temp)
				{
					$deleg_element = array_shift($temp);
					$l++;
					switch($l)
					{
						case 1:
							$this->ens = $deleg_element;
							break;
						case 2:
							$this->cycle = $deleg_element;
							break;
						case 3:
							$this->level = $deleg_element;
							break;
						case 4:
							$this->speciality = $deleg_element;
							break;
						case 5:
							$this->iclass = $deleg_element;
							break;
					}
				}
				$this->arr_deleg = $arr_deleg;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////	
		function getnext2()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$this->title = "";
				$this->checked_flag = "";
				$this->disabled_flag = "";
				$this->deleg_name = "";
				
				$this->bg = !$this->bg;
				$temp = array_shift($this->deleg);
				$this->ens = $temp[0];
				$this->cycle = $temp[1];
				$this->arr_deleg = serialize($temp);
				$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` FROM `bab_dg_groups`,`sad_created_class_deleg_temp`, `bab_sites` WHERE (`bab_dg_groups`.`id` = `id_deleg`) AND (`e` = '".$this->ens."') AND (`c` = '".$this->cycle."') AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) == 0)
				{
					$this->checkbox_name = "create_deleg";
				}
				else
				{
					$this->checkbox_name = "create_deleg";
					$this->checked_flag = " checked";
					$temp = $babDB->db_fetch_array($res);
					$this->deleg_name = $temp["name"];
				}
				$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$this->ens."') AND (`c` = '".$this->cycle."') AND ((`n` IS NOT NULL) OR (`s` IS NOT NULL) OR (`i` IS NOT NULL)) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->checkbox_name = "do_not_create_deleg";
					$this->disabled_flag = " disabled";
					$this->title = bab_translate("Disabled : existing sub-levels delegations", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->checkbox_name = "create_deleg";
				}
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
		function getnext3()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count3 )
			{
				$this->del_deleg = $this->deleted_delegations[$k];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////
	}
	$obj= new displayCreateClassesStep2FormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "createadminsstep2form"));
}

// Affichage du formulaire de cration/suppression des dlgations bases sur les groupes classes (tape 1)
function displayCreateClassesStep1Form()
{
	global $babBody;
	class displayCreateClassesStep1FormClass
	{
		function displayCreateClassesStep1FormClass()
		{
			global $babDB;
			list($this->r, $this->ds, $this->etab, $this->domain, $this->suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$this->ErrorMessage = bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				
				// Ralisation d'une copie de la table `sad_created_class_deleg` dans `sad_created_class_deleg_temp`
				$res = $babDB->db_query("TRUNCATE TABLE `sad_created_class_deleg_temp`");
				$res = $babDB->db_query("INSERT INTO `sad_created_class_deleg_temp` SELECT * FROM `sad_created_class_deleg`") ;
				
				$base_dn = "OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				$filter = "(OU=*)";
				$sr = ldap_search($this->ds, $base_dn, $filter);
				$entry = ldap_first_entry($this->ds, $sr);
				$arr = array();
				while ($entry)
				{
					$dn = ldap_get_dn($this->ds, $entry);
					$temp = ldap_explode_dn($dn, 1);
					if (count($temp) == 7)
					{
						$ens = $temp[0];
						$arr[] = array($ens);
					}
					$entry = ldap_next_entry($this->ds, $entry);
				}
				array_multisort($arr);
				if (count($arr) > 0)
				{
					$this->deleg = array();
					$this->deleg[0] = $arr[0];
					for ($i = 1; $i < count($arr); $i++)
					{
						if ($arr[$i] != $arr[$i - 1])
						{
							$this->deleg[] = $arr[$i];
						}
					}
					$this->ens_label = bab_translate("Enseignement", $GLOBALS["babAddonFolder"]);
					$this->select_all = bab_translate("Select all", $GLOBALS["babAddonFolder"]);
					$this->unselect_all = bab_translate("Unselect all", $GLOBALS["babAddonFolder"]);
					$this->count = count($this->deleg);
					$this->validate = bab_translate("Next", $GLOBALS["babAddonFolder"]);
					$this->bg = true;
					
					$this->warning_part_1 = bab_translate("Warning ! you will delete the delegation ", $GLOBALS["babAddonFolder"]);
					$this->warning_part_2 = bab_translate("Do you want to continue?", $GLOBALS["babAddonFolder"]);
					$this->info_part_1 = bab_translate("The delegation ", $GLOBALS["babAddonFolder"]);
					$this->info_part_2 = bab_translate(" will be deleted.", $GLOBALS["babAddonFolder"]);
					$this->info_part_3 = bab_translate(" will NOT be deleted.", $GLOBALS["babAddonFolder"]);

				}
			}
		}
		////////////////////////////////////////////////////
		function getnext()
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count )
			{

				$this->checked_flag = "";
				$this->disabled_flag = "";
				$this->title = "";
				$this->deleg_name = "";

				$this->bg = !$this->bg;
				$temp = array_shift($this->deleg);
				$this->ens = $temp[0];
				$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` FROM `bab_dg_groups`, `sad_created_class_deleg_temp`, `bab_sites` WHERE (`bab_dg_groups`.`id` = `id_deleg`) AND (`e` = '".$this->ens."') AND (`c` IS NULL) AND (`n` IS NULL) AND (`s` IS NULL) AND (`i` IS NULL) AND (`bab_sites`.`id` = `id_site`) AND (`bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) == 0)
				{
					$this->checkbox_name = "create_deleg";
				}
				else
				{
					$this->checkbox_name = "create_deleg";
					$this->checked_flag = " checked";
					$temp = $babDB->db_fetch_array($res);
					$this->deleg_name = $temp["name"];
				}
				$res = $babDB->db_query("SELECT `sad_created_class_deleg_temp`.`id` FROM `sad_created_class_deleg_temp`, `bab_sites` WHERE (`e` = '".$this->ens."') AND ((`c` IS NOT NULL) OR (`n` IS NOT NULL) OR (`s` IS NOT NULL) OR (`i` IS NOT NULL)) AND (`bab_sites`.`id` = `id_site`) AND (`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."')");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->checkbox_name = "do_not_create_deleg";
					$this->disabled_flag = " disabled";
					$this->title = bab_translate("Disabled : existing sub-levels delegations", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->checkbox_name = "create_deleg";
				}
				$this->arr_deleg = serialize($temp);
				$this->row = $k;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		////////////////////////////////////////////////////		
	}
	$obj= new displayCreateClassesStep1FormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_delegs.html", "createadminsstep1form"));
}

$idx = bab_rp('idx', 'classes');

switch($idx)
{
	case 'groups':
		if (bab_isAccessValid('sad_create_admins_groups', 1000))
		{
			$babBody->addItemMenu("classes", bab_translate("Creation of delegations", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."sync_delegs&idx=classes");
		}
		if (bab_isAccessValid('sad_create_admins_groups', 1000))
		{
			$babBody->addItemMenu("groups", bab_translate("Creation of groups", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."sync_delegs&idx=groups");
			$create = bab_pp('create','');
			if (empty($create))
			{
				$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
					$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
				}
				else
				{
					list($r, $ds, $etab, $domain, $suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
					if ($r === false)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]));
					}
					else
					{					
						$test = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
						if (count($test) > 0)
						{
							$del = bab_pp("del", "");
							if (empty ($del))
							{
								$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
								$babBody->addError(bab_translate("Warning ! You must remove the delegations which do not correspond to any group in ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
								displayDeleteFormerDelegationsForm();
							}
							else
							{
								actionDeleteDeleg();
								$test = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
								if (count($test) === 0)
								{
									$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
									$babBody->addError(bab_translate("Please, select the groups for witch delegations must be created!", $GLOBALS["babAddonFolder"]));
									displayCreateGroupsDelegForm();
								}
								else
								{
									$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
									$babBody->addError(bab_translate("Warning ! You must remove the delegations which do not correspond to any group in ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
									displayDeleteFormerDelegationsForm();
								}
							}
						}
						else
						{
							$base_dn = "OU=groupe, OU=".$etab.", DC=".$domain.", DC=".$suffix;
							$filter = "(cn=gp_eleve*)";
							$sr = ldap_search($ds, $base_dn, $filter);
							if (ldap_count_entries($ds, $sr) == 0)
							{
								$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
								$babBody->addError(bab_translate("Error ! No interclasses group in the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
							}
							else
							{
								$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
								$babBody->addError(bab_translate("Please, select the groups for witch delegations must be created!", $GLOBALS["babAddonFolder"]));
								displayCreateGroupsDelegForm();
							}
						}
					}
				}
			}
			else
			{
				$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
				$babBody->addError(bab_translate("The delegations and the accounts of the delegated administrators have been created.", $GLOBALS["babAddonFolder"]));
				$babBody->addError(bab_translate("Please, conserve this page!", $GLOBALS["babAddonFolder"]));
				actionCreateGroupsDelegForm();
			}
		}
		break;
	case 'classes':
	default:
		if (bab_isAccessValid('sad_create_admins_groups', 1000))
		{
			$babBody->addItemMenu("classes", bab_translate("Creation of delegations", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."sync_delegs&idx=classes");
			$step = bab_pp('step','0');
			switch($step)
			{
				case 6:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("The delegations and the accounts of the delegated administrators have been created.", $GLOBALS["babAddonFolder"]));
						$babBody->addError(bab_translate("Please, print this page!", $GLOBALS["babAddonFolder"]));
						actionCreateClassDelegForm();
					}
					break;
				case 5:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Fifth step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
						displayCreateClassesStep5Form();
					}
					break;
				case 4:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Fourth step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
						displayCreateClassesStep4Form();
					}
					break;
				case 3:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Third step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
						displayCreateClassesStep3Form();
					}
					break;
				case 2:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Second step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
						displayCreateClassesStep2Form();
					}
					break;
				case 1:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
						$babBody->addError(bab_translate("First step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
						displayCreateClassesStep1Form();
					}
					break;
				case 0:
				default:
					$res = $babDB->db_query("SELECT `id_site`, `host`, `port` , `dn`, `password`, `etab`, `domaine`, `suffixe`, `bab_sites`.`id` FROM `sad_params`, `bab_sites` WHERE `id_site` = `bab_sites`.`id` AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$babBody->addError(bab_translate("Please, set the parameters of the synchronisation between the Ovidentia application and the ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
					}
					else
					{
						list($id_site, $host, $port , $dn, $password, $etab, $domain, $suffix) = $babDB->db_fetch_row($res); 
						list($r, $ds, $etab, $domain, $suffix) = parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
						if ($r === false)
						{
							$babBody->title = bab_translate("Creation of the the delegations based on the inter-classes groups", $GLOBALS["babAddonFolder"]);
							$babBody->addError(bab_translate("Error ! No connexion to ORPEO server.", $GLOBALS["babAddonFolder"]));
						}
						else
						{
							$test = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
							if (count($test) > 0)
							{
								$del = bab_pp("del", "");
								if (empty ($del))
								{
									$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
									$babBody->addError(bab_translate("Warning ! You must remove the delegations which do not correspond to any group in ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
									displayDeleteFormerDelegationsForm();
								}
								else
								{
									actionDeleteDeleg();
									$test = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
									if (count($test) === 0)
									{
										$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
										$babBody->addError(bab_translate("First step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
										displayCreateClassesStep1Form();
									}
									else
									{
										$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
										$babBody->addError(bab_translate("Warning ! You must remove the delegations which do not correspond to any group in ORPEO Active Directory.", $GLOBALS["babAddonFolder"]));
										displayDeleteFormerDelegationsForm();
									}
								}
							}	
							else
							{
								$babBody->title = bab_translate("Creation of the the delegations based on the classes structure", $GLOBALS["babAddonFolder"]);
								$babBody->addError(bab_translate("First step : select the level where must be created the delegations!", $GLOBALS["babAddonFolder"]));
								displayCreateClassesStep1Form();
							}
						}
					}
					break;
			}
		}
		if (bab_isAccessValid('sad_create_admins_groups', 1000))
		{
			$babBody->addItemMenu("groups", bab_translate("Creation of groups", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."sync_delegs&idx=groups");
		}
		break;
}

$babBody->setCurrentItemMenu($idx);

?>