<?php
require_once 'base.php';

require_once($babAddonPhpPath.'sad_ini.php');

if (!bab_isUserAdministrator())
{
	$babBody->addError( bab_translate("Access denied", $GLOBALS['babAddonFolder']));
	return;
}

$idx = bab_rp('idx', 'private_home_pages');

switch($idx)
{
	case 'directories':
		require_once($babAddonPhpPath.'user.directories.inc.php');
		$babBody->addItemMenu("private_home_pages", bab_translate("Private home page", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=private_home_pages");
		$babBody->addItemMenu("messaging", bab_translate("Messaging features", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=messaging");
		$babBody->addItemMenu("directories", bab_translate("Directories", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=directories");
		$flag = bab_pp('flag', '');
		if (empty($flag))
		{
			$babBody->title = bab_translate("Display of the nicknames in directories", $GLOBALS['babAddonFolder']);
			$babBody->addError(bab_translate("Choice if you want to enable ou disable the display of nicknames in directories", $GLOBALS['babAddonFolder']));
			displayNicknameInDirectoriesDisplayForm();
		}
		else
		{
			$babBody->title = bab_translate("Display of the nicknames in directories", $GLOBALS['babAddonFolder']);
			actionNicknameInDirectoriesDisplayForm();
		}
		break;	
	
	case 'messaging':
		require_once($babAddonPhpPath.'user.messaging.inc.php');
		$babBody->addItemMenu("private_home_pages", bab_translate("Private home page", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=private_home_pages");
		$babBody->addItemMenu("messaging", bab_translate("Messaging features", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=messaging");
		$babBody->title = bab_translate("Enabling/disabling of messaging features for users", $GLOBALS['babAddonFolder']);
		$flag = bab_pp('flag', '');
		if (empty($flag))
		{
			$babBody->title = bab_translate("Enabling/disabling of messaging features for users", $GLOBALS['babAddonFolder']);
			displayMessagingForm();
		}
		else
		{
			$babBody->title = bab_translate("Enabling/disabling of messaging features for users", $GLOBALS['babAddonFolder']);
			actionMessagingForm();
		}
		$babBody->addItemMenu("directories", bab_translate("Directories", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=directories");
		break;
	
	case 'private_home_pages':
	default:
		require_once($babAddonPhpPath.'user.private_home_pages.inc.php');
		$babBody->addItemMenu("private_home_pages", bab_translate("Private home page", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=private_home_pages");
		$code_op = bab_pp('code_op', '1');
		switch ($code_op)
		{
			case '4':
				$babBody->title = bab_translate("Personnalization of the private home page", $GLOBALS['babAddonFolder']);
				displayStep4Form();
				break;
			
			case '3':
				$babBody->title = bab_translate("Personnalization of the private home page", $GLOBALS['babAddonFolder']);
				displayStep3Form();
				break;
			
			case '2':
				$babBody->title = bab_translate("Personnalization of the private home page", $GLOBALS['babAddonFolder']);
				displayStep2Form();
				break;
			
			case '1':
			default :
				$babBody->addError(bab_translate("Click on the Next step button", $GLOBALS['babAddonFolder']));
				$babBody->title = bab_translate("Personnalization of the private home page", $GLOBALS['babAddonFolder']);
				displayStep1Form();
				break;				
		}
		$babBody->addItemMenu("messaging", bab_translate("Messaging features", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=messaging");
		$babBody->addItemMenu("directories", bab_translate("Directories", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=directories");
		break;
}
$babBody->setCurrentItemMenu($idx);
?>