<?php
require_once 'base.php';
require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";

// Action de mise  jour des objets Ovidentia  l'intrieur des dlgations (cration/suppression de classes)
function actionUpdateObjectsForm()
{
	global $babBody;
	class actionUpdateObjectsFormClass 
	{
		function actionUpdateObjectsFormClass()
		{
			require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";
			require_once $GLOBALS['babAddonPhpPath']."functions.php";
			require_once $GLOBALS['babInstallPath'].'admin/register.php';
			require_once $GLOBALS['babInstallPath'].'utilit/userincl.php';
			require_once $GLOBALS['babInstallPath'].'utilit/artapi.php';
			require_once $GLOBALS['babInstallPath'].'admin/acl.php';
			
			global $babDB;
			global $babBody;
			// Rcupration des paramtres de synchronisation
			list ($this->r, $this->ds, $this->etab, $this->domain, $this->suffix)= parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$babBody->addError(bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS['babAddonFolder']));
			}
			else
			{
				// Rcupration des paramtres de la dlgation
				$this->id_dg = bab_getCurrentAdmGroup();
				$res = $babDB->db_query("
				SELECT
				`name`,
				`id_group`
				FROM
				`bab_dg_groups`
				WHERE
				`id` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				$arr = $babDB->db_fetch_array($res);
				$this->name = $arr['name'];
				$this->id_group = $arr['id_group'];
				
				$error_context = false;
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_groups`
				WHERE 
				`name` = '".$babDB->db_escape_string($this->name.STUDENTS_GROUP_SUFFIX)."'
				AND
				`id_parent` = '".$babDB->db_escape_string($this->id_group)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
						$error_context = true;
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$this->id_elv_group = $temp["id"];
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_groups` 
					WHERE 
					`name` = '".$babDB->db_escape_string($this->name.TEACHERS_GROUP_SUFFIX)."' 
					AND 
					`id_parent` = '".$babDB->db_escape_string($this->id_group)."'
					");
					if ($babDB->db_num_rows($res) == 0)
					{
						$error_context = true;
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_prof_group = $temp["id"];
						$res = $babDB->db_query("
						SELECT 
						`id` 
						FROM 
						`bab_groups` 
						WHERE 
						`name` = '".$babDB->db_escape_string($this->name.MANAGERS_GROUP_SUFFIX)."' 
						AND 
						`id_parent` = '".$babDB->db_escape_string($this->id_group)."
						'");
						if ($babDB->db_num_rows($res) == 0)
						{
							$error_context = true;
						}
						else
						{
							$temp = $babDB->db_fetch_array($res);
							$this->id_gest_group = $temp["id"];
							$res = $babDB->db_query("
							SELECT 
							`id` 
							FROM 
							`bab_topics_categories` 
							WHERE 
							`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' 
							AND 
							`id_parent` = '0'
							");
							if ($babDB->db_num_rows($res) == 0)
							{
								$error_context = true;
							}
							else
							{
								$temp = $babDB->db_fetch_array($res);
								$this->id_topcat = $temp["id"];
							}
						}
					}
				}
				if ($error_context)
				{
					$this->error_context = true;
					$this->warning = bab_translate("Error!", $GLOBALS["babAddonFolder"]);
					$this->warning_info = bab_translate("Error : you must proceed first to the 'Initial creation'!", $GLOBALS["babAddonFolder"]);
				}
				else
				{
					$this->error_context = false;
					$res = $babDB->db_query("
					SELECT
					`e`,
					`c`,
					`n`, 
					`s`,
					`i`, 
					`g` 
					FROM 
					`sad_created_class_deleg`,
					`bab_sites` 
					WHERE 
					`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."' 
					AND 
					`bab_sites`.`id` = `id_site` 
					AND
					`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'
					");
					// Traitement des dlgations bases sur les structures des classes
					if ($babDB->db_num_rows($res) > 0)
					{
						$this->class_deleg = true;
						
						// tablissement de la liste des anciennes classes ( supprimer du groupe dlgu)
						$this->arr1 = array();
						
						$res1 = $babDB->db_query("
						SELECT 
						`dn` 
						FROM 
						`sad_groups_tree` 
						WHERE 
						`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."' 
						AND
						`dn` LIKE 'CN=l_eleve%'");
						while ($temp = $babDB->db_fetch_array($res1))
						{
							$base_dn = "OU=groupe, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
							$dn = $temp["dn"];
							$cn = ldap_explode_dn($dn, 1);
							$cn = $cn[0];
							$filter = "(CN=".$cn.")";
							$sr = ldap_search($this->ds, $base_dn, $filter);
							if ( ldap_count_entries($this->ds, $sr) == 0 )
							{
								$res2 = $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."' AND `dn` = '".$babDB->db_escape_string($dn)."'");
								$iclass_name = explode("l_eleve", $cn);
								$iclass_name = $iclass_name[1];
								$this->arr1[] = $iclass_name;
								$dn = "CN=l_prof".$iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix;
								$res2 = $babDB->db_query("
								DELETE 
								FROM 
								`sad_groups_tree` 
								WHERE 
								`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."' 
								AND 
								`dn` = '".$babDB->db_escape_string($dn)."'
								");
							}
						}
						$this->count1 = count($this->arr1);
						$this->delete_title = bab_translate("Removing former classes", $GLOBALS["babAddonFolder"]);
						if ($this->count1 > 0)
						{
							$this->class_label = bab_translate("Class", $GLOBALS["babAddonFolder"]);
						}
						else
						{
							$this->delete_info = bab_translate("No classes removing", $GLOBALS["babAddonFolder"]);
						}
						
						// tablissement de la liste des nouvelles classes ( introduire dans le groupe dlgu)
						$this->arr2 = array();
						$temp = $babDB->db_fetch_array($res);
						$ens = $temp["e"];
						$cycle = $temp["c"];
						$level = $temp["n"];
						$speciality = $temp["s"];
						$iclass = $temp["i"];
						if (!is_null($ens) && is_null($cycle) && is_null($level) && is_null($speciality) && is_null($iclass))
						{
							// Dlgation au niveau Enseignement
							$base_dn= "OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
						}
						else
						{
							if (!is_null($ens) && !is_null($cycle) && is_null($level) && is_null($speciality )&& is_null($iclass))
							{
								// Dlgation au niveau Cycle
								$base_dn= "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
							}
							else
							{
								if (!is_null($ens) && !is_null($cycle) && !is_null($level) && is_null($speciality )&& is_null($iclass))
								{
									// Dlgation au niveau Niveau
									$base_dn= "OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
								}
								else
								{
									if (!is_null($ens) && !is_null($cycle) && !is_null($speciality )&& is_null($iclass))
									{
										// Dlgation au niveau Spcialit : voir traitement particulier repris plus loin
										unset($base_dn);
									}
									else
									{
										if (!is_null($ens) && !is_null($cycle) && !is_null($level) && !is_null($speciality )&& !is_null($iclass))
										{
											// Dlgation au niveau classe
											$base_dn= "OU=".$level.$cycle.$speciality.$iclass.", OU=".$level.$cycle.$speciality. ",OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
										}
									}
								}
							}
						}
						if (isset ($base_dn))
						{	
							$filter = "(OU=*)";
							$sr = ldap_search($this->ds, $base_dn, $filter);
							$entry = ldap_first_entry($this->ds, $sr);
							while ($entry)
							{
								$dn = ldap_get_dn($this->ds, $entry);
								$temp = ldap_explode_dn($dn, 1);
								if (count($temp) == 11)
								{
									/*
									Si le nom de la classe  est initialis avec son code GEP
									$attr = ldap_get_attributes($this->ds, $entry);
									if (in_array("postalCode", $attr))
									{
										$temp = ldap_get_values($this->ds, $entry, "postalCode");
										$iclass = $temp[0];
									}
									else
									{
										$iclass = $temp[0];
									}
									*/
									$iclass_name = $temp[0];
									$iclass_elv_group_name = $iclass_name.STUDENTS_GROUP_SUFFIX;
									$res = $babDB->db_query("SELECT `id` FROM `sad_groups_tree` WHERE `dn` = '".$babDB->db_escape_string("CN=l_eleve".$iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix)."' AND `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'");
									if ($babDB->db_num_rows($res) == 0)
									{
										$this->arr2[] = $iclass_name;
									}
								}
								$entry = ldap_next_entry($this->ds, $entry);
							}
						}
						else // Traitement du cas o la dlgation est pose au niveau Spcialit
						{
							if (!is_null($ens) && !is_null($cycle) && is_null($level) && !is_null($speciality) && is_null($iclass))
							{
								$base_dn = "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
								$filter = "(OU=*)";
								$sr = ldap_search($this->ds, $base_dn, $filter);
								$entry = ldap_first_entry($this->ds, $sr);
								$this->arr = array();
								while ($entry)
								{
									$dn = ldap_get_dn($this->ds, $entry);
									$temp = ldap_explode_dn($dn, 1);
									if (count($temp) == 11)
									{
										$e = $temp[4];
										$c = $temp[3];
										$l = explode($temp[3], $temp[2]);
										$l = $l[0];
										$s = explode($temp[2], $temp[1]);
										$s = $s[1];
										$iclass_name = $temp[0];
										if (($ens == $e) && ($cycle == $c) && ($speciality == $s))
										{
											$res = $babDB->db_query("SELECT `id` FROM `sad_groups_tree` WHERE `dn` = '".$babDB->db_escape_string("CN=l_eleve".$iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix)."' AND `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'");
											if ($babDB->db_num_rows($res) == 0)
											{
												$this->arr2[] = $iclass_name;
											}
										}
									}
									$entry = ldap_next_entry($this->ds, $entry);
								}
							}
						}
						$this->count2 = count($this->arr2);
						$this->create_title = bab_translate("Creating new classes", $GLOBALS["babAddonFolder"]);

						if ($this->count2 > 0)
						{
							$this->class_label = bab_translate("Class", $GLOBALS["babAddonFolder"]);
						}
						else
						{
							$this->create_info = bab_translate("No classes creating", $GLOBALS["babAddonFolder"]);
						}
						
						$this->warning = bab_translate("Warning!", $GLOBALS["babAddonFolder"]);
						$this->warning_info = bab_translate("You need to process to the synchronization of the accounts in order to attach users to the created classes", $GLOBALS["babAddonFolder"]);

					}
					else
					{
						// Traitement du cas o la dlgation est base sur les groupes interclasses
						$res = $babDB->db_query("
						SELECT 
						`group_name` 
						FROM 
						`sad_created_group_deleg`, 
						`bab_sites` 
						WHERE 
						`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."' 
						AND 
						`bab_sites`.`id` = `id_site` 
						AND 
						`name` = '".db_escape_string($GLOBALS["babSiteName"])."'
						");
						if ($babDB->db_num_rows($res) > 0)
						{
							$babBody->addError(bab_translate("Error : this item is not valid for the inter-classes groups!", $GLOBALS["babAddonFolder"]));
						}
					}
				}
				$this->print_label = bab_translate("Print", $GLOBALS["babAddonFolder"]);
			}
		}
		
		function getnext1() // Suppression des classes n'existant plus au sein de la dlgation et des objets associs
		{
			global $babDB;
			require_once $GLOBALS['babInstallPath'].'utilit/delincl.php';
			require_once $GLOBALS['babInstallPath'].'utilit/tmIncl.php';
			include_once $GLOBALS['babInstallPath']."utilit/calincl.php";
			static $k=0;
			if ( $k < $this->count1 )
			{
				$this->iclass_name = $this->arr1[$k];
				// Suppression de la catgorie de thmes associe  la classe
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_topics_categories` 
				WHERE 
				`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' 
				AND 
				`id_parent` = '0'
				");
				if ($babDB->db_num_rows($res) > 0)
				{
					$temp = $babDB->db_fetch_array($res);
					$id_parent = $temp["id"];
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_topics_categories` 
					WHERE 
					`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' 
					AND 
					`id_parent` = '".$babDB->db_escape_string($id_parent)."' 
					AND 
					`title` = '".$babDB->db_escape_string($this->iclass_name)."'
					");
					while($arr = $babDB->db_fetch_array($res))
					{
						bab_deleteTopicCategory($arr['id']);
					}
				}
				$this->sub_category_info = bab_translate("Removing sub-category and topics", $GLOBALS["babAddonFolder"]);
				// Suppression du rpertoire partag associ  la classe
				$substitution_pattern = array_keys($GLOBALS["babFileNameTranslation"]);
				$folder_name = $this->iclass_name;
				for ($i = 0; $i < count($GLOBALS["babFileNameTranslation"]); $i++)
				{
					$search	= $substitution_pattern[$i];
					$replace = $GLOBALS["babFileNameTranslation"][$search];
					$folder_name = str_replace($search, $replace, $folder_name); 
				}
				$res = $babDB->db_query("SELECT `id` FROM ".BAB_FILES_TBL." WHERE `iIdDgOwner` = '".$babDB->db_escape_string($this->id_dg)."' AND `path` LIKE '".$babDB->db_escape_string($folder_name)."/%'");
				while($arr = $babDB->db_fetch_array($res))
				{
					$babDB->db_query("DELETE FROM ".BAB_FILES_TAGS_TBL." WHERE `id_file` = '".$babDB->db_escape_string($arr['id'])."'");
					$babDB->db_query("DELETE FROM ".BAB_FILES_TBL." WHERE `id` = '".$babDB->db_escape_string($arr['id'])."'");	
				} 
				$res = $babDB->db_query("SELECT `id` FROM `bab_fm_folders` WHERE `id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' AND `folder` = '".$babDB->db_escape_string($folder_name)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					bab_deleteFolder($arr['id']);
				}
				$this->folder_info = bab_translate("Removing shared folder", $GLOBALS["babAddonFolder"]);
				// Suppression du forum associ  la classe
				$res = $babDB->db_query("SELECT `id` FROM `bab_forums` WHERE `id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' AND `name` = '".$babDB->db_escape_string($this->iclass_name)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					bab_deleteForum($arr['id']);
				}
				$this->forum_info = bab_translate("Removing forum", $GLOBALS["babAddonFolder"]);
				// Suppression de l'espace projet associ  la classe
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_projects_spaces` WHERE `idDelegation` ='".$babDB->db_escape_string($this->id_dg)."' AND `name` = '".$babDB->db_escape_string($this->iclass_name)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					bab_deleteProjectSpace($arr['id']);
				}
				$this->project_space_info = bab_translate("Removing project space", $GLOBALS["babAddonFolder"]);
				// Suppression des agendas collectifs associs  la classe
				$res = $babDB->db_query("SELECT `bab_cal_public`.`id`, `bab_calendar`.`id` AS `idcal` FROM `bab_cal_public`, `bab_calendar` WHERE ((`name` = '".$babDB->db_escape_string($this->iclass_name.STUDENTS_GROUP_SUFFIX)."') OR (`name` = '".$babDB->db_escape_string($this->iclass_name.TEACHERS_GROUP_SUFFIX)."')) AND `id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' AND `bab_cal_public`.`id` = `owner` AND `type` = '".$babDB->db_escape_string(BAB_CAL_PUB_TYPE)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					bab_deleteCalendar($arr['idcal']);
					$babDB->db_query("DELETE FROM `bab_cal_public` WHERE `id` = '".$arr['id']."'");	
				}
				$this->students_calendar_info = bab_translate("Removing students collective calendar", $GLOBALS["babAddonFolder"]);
				$this->teachers_calendar_info = bab_translate("Removing teachers collective calendar", $GLOBALS["babAddonFolder"]);
				// Suppression du schma d'approbation de la classe
				$res = $babDB->db_query("SELECT `id` FROM `bab_flow_approvers` WHERE `name` = '".$babDB->db_escape_string($this->iclass_name.FLOW_APPROVERS_SUFFIX)."' AND `id_dgowner` = ".$babDB->db_escape_string($this->id_dg)." AND `satype` = 2");
				while($arr = $babDB->db_fetch_array($res))
				{
					bab_deleteApprobationSchema($arr['id']);	
				}
				$this->flow_approvers_info = bab_translate("Removing approvers flow", $GLOBALS["babAddonFolder"]);
				// Suppression du groupe des lves et tudiants de la classe
				$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($this->iclass_name.STUDENTS_GROUP_SUFFIX)."' AND `id_parent` = '".$babDB->db_escape_string($this->id_elv_group)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					remove_group_and_all_children($arr['id']);	
				}
				$this->students_group_info = bab_translate("Removing students group and its directory", $GLOBALS["babAddonFolder"]);
				// Suppression du groupe des enseignants de la classe aprs modification du schma d'approbation de la dlgation
				$res = $babDB->db_query("SELECT `id`, `formula` FROM `bab_flow_approvers` WHERE `id_dgowner` = ".$babDB->db_escape_string($this->id_dg)." AND `satype` = 2 AND `name` = '".$babDB->db_escape_string($this->name.FLOW_APPROVERS_SUFFIX)."'");
				$temp = $babDB->db_fetch_array($res);
				$deleg_flow_aprovers_id = $temp["id"];
				$deleg_flow_approvers_formula = $temp["formula"];
				$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($this->iclass_name.TEACHERS_GROUP_SUFFIX)."' AND `id_parent` = '".$babDB->db_escape_string($this->id_prof_group)."'");
				while($arr = $babDB->db_fetch_array($res))
				{
					remove_group_and_all_children($arr['id']);
					$deleg_flow_approvers_formula = str_replace("|".$arr['id'], "", $deleg_flow_approvers_formula);
				}
				$res = $babDB->db_query("UPDATE `bab_flow_approvers` SET `formula` = '".$babDB->db_escape_string($deleg_flow_approvers_formula)."' WHERE `id` = '".$babDB->db_escape_string($deleg_flow_aprovers_id)."'");
				$this->teachers_group_info = bab_translate("Removing teachers group and its directory", $GLOBALS["babAddonFolder"]);
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		
		function getnext2() // Cration des classes nouvelles au sein de la dlgation et des objets associs
		{
			global $babDB;
			static $k=0;
			if ( $k < $this->count2 )
			{
				$this->iclass_name = $this->arr2[$k];
				// Cration du groupe des lves et tudiants de la classe
				$name = $this->iclass_name.STUDENTS_GROUP_SUFFIX;
				$description = bab_translate("Group of students of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
				$managerid = $GLOBALS["BAB_SESS_USERID"];
				$parent = $this->id_elv_group;
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_groups` 
				WHERE 
				`name` = '".$babDB->db_escape_string($name)."' 
				AND 
				`id_parent` = '".$babDB->db_escape_string($parent)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$id_elv_group = bab_createGroup($name, $description, $managerid, $parent);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_elv_group = $temp["id"];
				}
				// Inscription du groupe dans la table de l'arborescence de l'Active Directory d'ORPEO
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`sad_groups_tree` 
				WHERE 
				`id_group` = '".$babDB->db_escape_string($id_elv_group)."' 
				AND 
				`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$dn = "CN=l_eleve".$this->iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix;
					$res = $babDB->db_query("
					INSERT INTO `sad_groups_tree`
					(
						`id_deleg`,
						`id_group`,
						`dn`
					)
					VALUES
					(
						'".$babDB->db_escape_string($this->id_dg)."',
						'".$babDB->db_escape_string($id_elv_group)."',
						'".$babDB->db_escape_string($dn)."'
					)
					");
				}
				$this->students_group_info = bab_translate("Creating students group", $GLOBALS["babAddonFolder"]);
				// Cration de l'annuaire des lves et tudiants de la classe
				$id_group = $id_elv_group;
				$group_name = $this->iclass_name.STUDENTS_GROUP_SUFFIX;
				$description = bab_translate("Directory of students of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;;
				$id_dgowner = $this->id_dg;
				$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
				set_right_on_directory($id_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
				$this->students_directory_info = bab_translate("Creating students directory", $GLOBALS["babAddonFolder"]);
				
				// Cration du groupe d'enseignants de la classe
				$name = $this->iclass_name.TEACHERS_GROUP_SUFFIX;
				$description = bab_translate("Group of teachers of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
				$managerid = $GLOBALS["BAB_SESS_USERID"];
				$parent = $this->id_prof_group;
				$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
				if ($babDB->db_num_rows($res) == 0)
				{
					$id_prof_group = bab_createGroup($name, $description, $managerid, $parent);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_prof_group = $temp["id"];
				}
				// Inscription du groupe dans la table de l'arborescence de l'Active Directory d'ORPEO
				$res = $babDB->db_query("SELECT `id` FROM `sad_groups_tree` WHERE `id_group` = '".$babDB->db_escape_string($id_prof_group)."' AND `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$dn = "CN=l_prof".$this->iclass_name.",OU=groupe,OU=".$this->etab.",DC=".$this->domain.",DC=".$this->suffix;
					$res = $babDB->db_query("
					INSERT INTO `sad_groups_tree`
					(
						`id_deleg`,
						`id_group`,
						`dn`
					)
					VALUES
					(
						'".$babDB->db_escape_string($this->id_dg)."',
						'".$babDB->db_escape_string($id_prof_group)."',
						'".$babDB->db_escape_string($dn)."'
					)
					");
				}
				$this->teachers_group_info = bab_translate("Creating teachers group", $GLOBALS["babAddonFolder"]);
				// Cration de l'annuaire des enseignants de la classe
				$id_group = $id_prof_group;
				$group_name = $this->iclass_name.TEACHERS_GROUP_SUFFIX;
				$description = bab_translate("Directory of teachers of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;;
				$id_dgowner = $this->id_dg;
				$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
				set_right_on_directory($id_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
				$this->teachers_directory_info = bab_translate("Creating teachers directory", $GLOBALS["babAddonFolder"]);
				
				// Cration du schma d'approbation de la classe
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_flow_approvers` 
				WHERE 
				`name` = '".$babDB->db_escape_string($this->iclass_name.FLOW_APPROVERS_SUFFIX)."' 
				AND 
				`id_dgowner` = ".$id_dgowner." 
				AND 
				`satype` = '2'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$name = $this->iclass_name.FLOW_APPROVERS_SUFFIX;
					$description = bab_translate("Flow approvers for the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
					$formula = $this->id_gest_group."|".$id_prof_group;
					$forder = "N";
					$refcount = 0; 
					$satype = 2;
					$id_oc  = 0;
					$res = $babDB->db_query("
					INSERT INTO `bab_flow_approvers`
					(
						`name` ,
						`description` ,
						`formula` ,
						`forder` ,
						`refcount` ,
						`id_dgowner` ,
						`satype` ,
						`id_oc`
					)
					VALUES 
					(
						'".$babDB->db_escape_string($name)."',
						'".$babDB->db_escape_string($description)."',
						'".$babDB->db_escape_string($formula)."',
						'".$babDB->db_escape_string($forder)."',
						'".$babDB->db_escape_string($refcount)."',
						'".$babDB->db_escape_string($id_dgowner)."',
						'".$babDB->db_escape_string($satype)."',
						'".$babDB->db_escape_string($id_oc)."'
					)
					");
					$id_flow_approvers = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_flow_approvers = $temp["id"];
				}
				$this->flow_approvers_info = bab_translate("Creating flow approvers", $GLOBALS["babAddonFolder"]);

				// Cration de la catgorie de thmes de la classe
				$res = $babDB->db_query("SELECT `id` FROM `bab_topics_categories` WHERE `id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."' AND `id_parent` = '".$babDB->db_escape_string($this->id_topcat)."' AND `title` = '".$babDB->db_escape_string($this->iclass_name)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$name = $this->iclass_name;
					$description = "";
					$benabled = "N";
					$template = "template";
					$disptmpl = "default";
					$topcatid = $this->id_topcat;
					$dgowner = $this->id_dg;
					$id_topcat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_topcat = $temp["id"];
				}
				// Placement des droits par dfaut sur la catgorie de thme cre
				unset_def_right_on_topics_category($id_topcat,"view");				
				set_def_right_on_topics_category($id_topcat, "view", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				set_def_right_on_topics_category($id_topcat, "view", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_def_right_on_topics_category($id_topcat, "view", $id_prof_group + BAB_ACL_GROUP_TREE);
				unset_def_right_on_topics_category($id_topcat,"submit");				
				set_def_right_on_topics_category($id_topcat, "submit", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_def_right_on_topics_category($id_topcat, "submit", $id_prof_group + BAB_ACL_GROUP_TREE);
				unset_def_right_on_topics_category($id_topcat,"comment");				
				set_def_right_on_topics_category($id_topcat, "comment", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_def_right_on_topics_category($id_topcat, "comment", $id_prof_group + BAB_ACL_GROUP_TREE);
				unset_def_right_on_topics_category($id_topcat,"modify");				
				set_def_right_on_topics_category($id_topcat, "modify", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_def_right_on_topics_category($id_topcat, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				
				// Cration des thmes gnriques pour la classe (6 par defaut)
				for ($i = 1; $i < TOPICS_DEFAULT_NUMBER + 1; $i++)
				{
					$name = bab_translate("Topic", $GLOBALS["babAddonFolder"])." ".$i;
					$idCategory = $id_topcat;
					$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE `category` = '".$babDB->db_escape_string($name)."' AND `id_cat` = ".$id_topcat);
					if ($babDB->db_num_rows($res) == 0)
					{
						$description = "";
						$topicArr = array();
						$topicArr["idsaart"] = $id_flow_approvers;
						$topicArr["idsacom"] = $id_flow_approvers;
						$topicArr["idsa_update"] = $id_flow_approvers;
						$topicArr["notify"] = "N";
						$topicArr["lang"] = "fr";
						$topicArr["article_tmpl"] = "";
						$topicArr["display_tmpl"] = "";
						$topicArr["restrict_access"] = "N";
						$topicArr["allow_hpages"] = "N"; 
						$topicArr["allow_pubdates"] = "N"; 
						$topicArr["allow_attachments"] = "N"; 
						$topicArr["allow_update"] = "1"; 
						$topicArr["allow_manupdate"] = "1"; 
						$topicArr["max_articles"] = 10;
						$topicArr["auto_approbation"] = "Y"; 
						$topicArr["busetags"] = "N";
						$topicArr["allow_unsubscribe"] = "1";
						$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
					}
				}
				$this->sub_category_info = bab_translate("Creating sub-category and topics", $GLOBALS["babAddonFolder"]);
				
				// Cration du rpertoire partag de la classe (si la dlgation n'est pas faite au niveau classe)
				$folder = $this->iclass_name;
				$id_dgowner = $this->id_dg;
				$relative_path = "";
				$bhide = "N";
				$idsa = $id_flow_approvers;
				$filenotify = "N";
				$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
				// Mise en place des droits sur le rpertoire partag
				set_right_on_folder($id_folder, "upload", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_right_on_folder($id_folder, "upload", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_folder($id_folder, "download", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_right_on_folder($id_folder, "download", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_folder($id_folder, "update", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_folder($id_folder, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				// set_right_on_folder($id_folder, "notify", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
				// set_right_on_folder($id_folder, "unzip", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
				
				$this->folder_info = bab_translate("Creating shared folder", $GLOBALS["babAddonFolder"]);
				
				// Cration du forum de la classe
				$name = $this->iclass_name;
				$description = bab_translate("Forum for the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
				$moderation = "Y";
				$notification = "Y";
				$active = "Y";
				$id_forum = create_forum($name, $description, $id_dgowner, $moderation, $notification, $active);
				if (!is_null($id_forum))
				{
					// Mise en place des droits sur le forum
					set_right_on_forum($id_forum, "view", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "view", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "post", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "post", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "reply", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "reply", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "files", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "files", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "manage", $id_prof_group + BAB_ACL_GROUP_TREE );
					set_right_on_forum($id_forum, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE );
					set_right_on_forum($id_forum, "notify", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_forum($id_forum, "notify", $id_prof_group + BAB_ACL_GROUP_TREE);
				}
				$this->forum_info = bab_translate("Creating forum", $GLOBALS["babAddonFolder"]);
				
				// Cration des lments du gestionnaire de projets
				// Cration de l'espace de projets <classe> 
				$res = $babDB->db_query("
				SELECT
				`id` 
				FROM 
				`bab_tskmgr_projects_spaces` 
				WHERE 
				`name` = '".$babDB->db_escape_string($this->iclass_name)."' 
				AND 
				`idDelegation` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_projects_spaces` (`idDelegation`, `name`, `description`, `idUserCreated`) VALUES ('".$babDB->db_escape_string($this->id_dg)."', '".$babDB->db_escape_string($this->iclass_name)."', '', '".$GLOBALS["BAB_SESS_USERID"]."')");
					$id_project_space = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_project_space = $temp["id"];
				}
				// Mise en place des droits sur l'espace projet
				// Utilisateurs autoriss  crer des projets : enseignants de la classe bab_tskmgr_project_creator_groups 
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_project_creator_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_prof_group + BAB_ACL_GROUP_TREE)."'");
				if (mysql_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_project_creator_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_prof_group + BAB_ACL_GROUP_TREE)."')");
				}
				// Utilisateurs gestionnaires par dfaut : enseignants de la classe	bab_tskmgr_default_projects_managers_groups 
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_projects_managers_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_prof_group + BAB_ACL_GROUP_TREE)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_projects_managers_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_prof_group + BAB_ACL_GROUP_TREE)."')");
				}
				// Superviseurs de projets par dfaut : enseignants de la classe  bab_tskmgr_default_projects_supervisors_groups
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_projects_supervisors_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_prof_group + BAB_ACL_GROUP_TREE)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_projects_supervisors_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_prof_group + BAB_ACL_GROUP_TREE)."')");
				}
				// Visualiseurs de projet par dfaut : lves et enseignants de la classe  bab_tskmgr_default_projects_visualizers_groups
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_projects_visualizers_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_elv_group + BAB_ACL_GROUP_TREE)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_projects_visualizers_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_elv_group + BAB_ACL_GROUP_TREE)."')");
				}
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_projects_visualizers_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_prof_group + BAB_ACL_GROUP_TREE)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_projects_visualizers_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_prof_group + BAB_ACL_GROUP_TREE)."')");
				}
				// Responsables de tche par dfaut : enseignants de la classe	 bab_tskmgr_default_task_responsible_groups 
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_task_responsible_groups` WHERE `id_object` = '".$id_project_space."' AND `id_group` = '".($id_prof_group + BAB_ACL_GROUP_TREE)."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_task_responsible_groups` (`id_object`, `id_group`) VALUES ('".$id_project_space."', '".($id_prof_group + BAB_ACL_GROUP_TREE)."')");
				}
				// Configuration par dfaut des projets :	 bab_tskmgr_default_projects_configuration (id  idProjectSpace  tskUpdateByMgr  endTaskReminder  tasksNumerotation  emailNotice  faqUrl) 
				// Dlgation de mise  jour des tches aux responsables : oui
				// Dlai d'alerte : 5 jours
				// Numrotation des tches : squentiel (automatique)
				// Notification email : Non <!>
				// Lien pour l'aide : <vide>
				$res = $babDB->db_query("SELECT `id` FROM `bab_tskmgr_default_projects_configuration` WHERE `idProjectSpace` = '".$id_project_space."'");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT INTO `bab_tskmgr_default_projects_configuration` (`idProjectSpace`, `tskUpdateByMgr`, `endTaskReminder`, `tasksNumerotation`, `emailNotice`, `faqUrl`) VALUES ('".$id_project_space."', '1', '5', '1', '0', '')");
				}
				// Dfinition des vnments de notifications : bab_tskmgr_notice (idProjectSpace idProject profil idEvent )
				// Projet cr	: Superviseur
				// Projet supprim : Superviseur
				// Tche cre	: Responsable
				// Tche mise  jour par le gestionnaire : Responsable
				// Tche mise  jour par le responsable : Gestionnaire
				// Tche supprime : Responsable
				// Alerte par notifications : Responsable      
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_tskmgr_notice` 
				WHERE 
				`idProjectSpace` = '".$babDB->db_escape_string($id_project_space)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					)
					VALUES 
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0', 
						'0', 
						'0'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					) 
					VALUES
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0',
						'0',
						'1'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					)
					VALUES 
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0', 
						'2', 
						'2'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					) 
					VALUES 
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0',
						'2',
						'3'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					)
					VALUES
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0',
						'1',
						'4'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`,
						`profil`, 
						`idEvent`
					) 
					VALUES 
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0',
						'2',
						'5'
					)
					");
					$babDB->db_query("
					INSERT 
					INTO 
					`bab_tskmgr_notice` 
					(
						`idProjectSpace`, 
						`idProject`, 
						`profil`, 
						`idEvent`
					) 
					VALUES 
					(
						'".$babDB->db_escape_string($id_project_space)."',
						'0',
						'2',
						'6'
					)
					");
				}
				$this->project_space_info = bab_translate("Creating project space", $GLOBALS["babAddonFolder"]);
				
				// Cration des agendas collectifs
				// Agendas collectifs des lves ou tudiants de la classe
				$name = $this->iclass_name.STUDENTS_GROUP_SUFFIX;
				$id_dgowner = $this->id_dg;
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_cal_public`
				WHERE 
				`name` = '".$babDB->db_escape_string($name)."' 
				AND
				`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$description = bab_translate("Public calendar for the the students of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
					$idsa = $id_flow_approvers;
					$res = $babDB->db_query("
					INSERT 
					INTO 
					`bab_cal_public` 
					(
						`name`, 
						`description`, 
						`id_dgowner`, 
						`idsa`
					) 
					VALUES 
					(
						'".$babDB->db_escape_string($name)."',
						'".$babDB->db_escape_string($description)."',
						'".$babDB->db_escape_string($id_dgowner)."',
						'".$babDB->db_escape_string($idsa)."'
					)
					");
					$id_public_calendar = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_public_calendar = $temp["id"];
				}
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_calendar` 
				WHERE 
				`owner` = '".$babDB->db_escape_string($id_public_calendar)."'
				AND 
				`type` = '2'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("
					INSERT 
					INTO
					`bab_calendar` 
					(
						`owner`, 
						`actif`, 
						`type`
					)
					VALUES 
					(
						'".$babDB->db_escape_string($id_public_calendar)."',
						'Y',
						'2'
					)
					");
					$id_calendar = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_calendar = $temp["id"];
				}
				// Mise en place des droits sur l'agenda collectif
				// Droit pour le groupe des lves ou tudiants de la classe : Consulter, Groupe, Notifier 
				set_right_on_public_calendar($id_calendar, "view", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "groups", $id_elv_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "notify", $id_elv_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.5.0
				// Droit pour le groupe des enseignants de la classe : Consulter, Grer , Notifier
				set_right_on_public_calendar($id_calendar, "view", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "manage", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "notify", $id_prof_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.5.0
				// Droit pour les gestionnaires du niveau : Consulter, Grer, Notifier 
				set_right_on_public_calendar($id_calendar, "view", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				$this->students_calendar_info = bab_translate("Creating students public calendar", $GLOBALS["babAddonFolder"]);
				
				// Agendas collectifs des enseignants de la classe
				$name = $this->iclass_name.TEACHERS_GROUP_SUFFIX;
				$id_dgowner = $this->id_dg;
				$res = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_cal_public` 
				WHERE 
				`name` = '".$babDB->db_escape_string($name)."' 
				AND 
				`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$description = bab_translate("Public calendar for the the teachers of the class", $GLOBALS["babAddonFolder"])." ".$this->iclass_name;
					$idsa = 0;
					$res = $babDB->db_query("
					INSERT 
					INTO 
					`bab_cal_public` 
					(
						name, 
						description, 
						id_dgowner, 
						idsa
					) 
					VALUES 
					(
						'".$babDB->db_escape_string($name)."',
						'".$babDB->db_escape_string($description)."' ,
						'".$babDB->db_escape_string($id_dgowner)."',
						'".$babDB->db_escape_string($idsa)."'
					)
					");
					$id_public_calendar = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_public_calendar = $temp["id"];
				}
				$res = $babDB->db_query("
				SELECT 
				`id`
				FROM 
				`bab_calendar` 
				WHERE 
				`owner` = '".$id_public_calendar."'
				AND
				`type` = '2'
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$res = $babDB->db_query("INSERT 
					INTO 
					`bab_calendar` 
					(
						`owner`, 
						`actif`, 
						`type`
					)
					VALUES 
					(
						'".$babDB->db_escape_string($id_public_calendar)."',
						'Y',
						'2'
					)
					");
					$id_calendar = $babDB->db_insert_id($res);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_calendar = $temp['id'];
				}
				// Mise en place des droits sur l'agenda collectif
				// Droit pour le groupe des enseignants de la classe : Consulter, Notifier, Grer , Groupe
				set_right_on_public_calendar($id_calendar, "view", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "manage", $id_prof_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "notify", $id_prof_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.5.0
				set_right_on_public_calendar($id_calendar, "groups", $id_prof_group + BAB_ACL_GROUP_TREE);
				// Droit pour les gestionnaires du niveau : Consulter, Grer 
				set_right_on_public_calendar($id_calendar, "view", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				set_right_on_public_calendar($id_calendar, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
				$this->teachers_calendar_info = bab_translate("Creating teachers public calendar", $GLOBALS["babAddonFolder"]);
				
				// Modification du schma d'approbation de la dlgation
				$res = $babDB->db_query("SELECT `id`, `formula` FROM `bab_flow_approvers` WHERE `id_dgowner` = ".$babDB->db_escape_string($this->id_dg)." AND `satype` = 2 AND `name` = '".$babDB->db_escape_string($this->name.FLOW_APPROVERS_SUFFIX)."'");
				$temp = $babDB->db_fetch_array($res);
				$deleg_flow_aprovers_id = $temp["id"];
				$deleg_flow_approvers_formula = $temp["formula"];
				$deleg_flow_approvers_formula = $deleg_flow_approvers_formula."|".$id_prof_group;
				$res = $babDB->db_query("
				UPDATE 
				`bab_flow_approvers` 
				SET 
				`formula` = '".$babDB->db_escape_string($deleg_flow_approvers_formula)."' 
				WHERE 
				`id` = '".$babDB->db_escape_string($deleg_flow_aprovers_id)."'
				");
				
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new actionUpdateObjectsFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."create_objects.html", "update_objects"));
}


// Action de cration des objets Ovidentia  l'intrieur des dlgations (cration des dlgations)
function actionCreateObjectsForm()
{
	global $babBody;
	class actionCreateObjectsFormClass 
	{
		function actionCreateObjectsFormClass()
		{
			require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";
			require_once $GLOBALS['babAddonPhpPath']."functions.php";
			require_once $GLOBALS['babInstallPath'].'admin/register.php';
			require_once $GLOBALS['babInstallPath'].'utilit/userincl.php';
			require_once $GLOBALS['babInstallPath'].'utilit/artapi.php';
			require_once $GLOBALS['babInstallPath'].'admin/acl.php';
			
			global $babDB;
			global $babBody;
	
			// Rcupration des paramtres de synchronisation
			list ($this->r, $this->ds, $this->etab, $this->domain, $this->suffix)= parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($this->r === false)
			{
				$babBody->addError(bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS['babAddonFolder']));
			}
			else
			{
				$this->base_dn = "OU=groupe, OU=".$this->etab.", DC=".$this->domain.", DC=".$this->suffix;
				
				// Rcupration des paramtres de la dlgation
				$this->id_dg = bab_getCurrentAdmGroup();
				$res = $babDB->db_query("
				SELECT
				`name`,
				`id_group`
				FROM
				`bab_dg_groups`
				WHERE
				`id` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				$arr = $babDB->db_fetch_array($res);
				$this->name = $arr['name'];
				$this->id_group = $arr['id_group'];
				$id_group = $this->id_group;
				$name_group = $this->name;
				$id_dgowner = $this->id_dg;
				
				/*
				// Cration de l'annuaire du groupe dlgu et attribution des droits au groupe des administrateurs du site
				$description = bab_translate("Directory of the delegated group", $GLOBALS["babAddonFolder"])." ".$this->name;
				$id_directory = create_directory($id_group, $name_group, $description, $id_dgowner);
				set_right_on_directory($id_directory, "view", BAB_ADMINISTRATOR_GROUP + BAB_ACL_GROUP_TREE);
				*/
				
				// Cas de la dlgation constitue  partir des groupes inter-classes /////////////////////////////////////////////
				$res = $babDB->db_query("
				SELECT 
				`manager_dn`,
				`id_group` 
				FROM 
				`sad_created_group_deleg`, 
				`bab_dg_groups` 
				WHERE 
				`id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'
				AND
				`bab_dg_groups`.`id` = `id_deleg`
				");
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->interclass_deleg = true;
					$this->class_deleg = false;
					
					$babBody->addError(bab_translate("Objects for the delegation based on the inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->name);

					$temp = $babDB->db_fetch_array($res);
					$manager_dn = $temp["manager_dn"];
					$id_group = $temp["id_group"];
					// Cration du groupe des gestionnaires de la dlgation
					$name = $this->name.MANAGERS_GROUP_SUFFIX;
					$description = bab_translate("All the managers of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("
					SELECT 
					`id`
					FROM 
					`bab_groups`
					WHERE 
					`name` = '".$babDB->db_escape_string($name)."' 
					AND
					`id_parent` = '".$babDB->db_escape_string($parent)."'
					");
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_gest_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_gest_group = $temp["id"];
					}
					if (!isset($babBody->ovgroups[$id_gest_group])) $babBody->ovgroups[$id_gest_group] = array();
					if (!isset($babBody->ovgroups[$id_gest_group]['lf'])) $babBody->ovgroups[$id_gest_group]['lf'] = 0;
					if (!isset($babBody->ovgroups[$id_gest_group]['lr'])) $babBody->ovgroups[$id_gest_group]['lr'] = 0;
					// Inscription du responsable du groupe dans le groupe des gestionnaires dlgus
					$temp = ldap_explode_dn($manager_dn, 1);
					$nickname = $temp[0];
					// $res = $babDB->db_query("SELECT `id` FROM `bab_users` WHERE `nickname` = '".$babDB->db_escape_string($nickname)."'");
					// if ($babDB->db_num_rows($res) > 0)
					$id_user = bab_getUserIdByNickname($nickname);
					if ($id_user > 0)
					{
						// $temp = $babDB->db_fetch_array($res);
						// $iduser = $temp["id"];
						$idgroup = $id_gest_group;
						bab_attachUserToGroup($id_user, $idgroup);	
					}				
					$this->managers_group_info = bab_translate("Creating managers group", $GLOBALS["babAddonFolder"]);
					
					// Cration de l'annuaire des gestionnaires de la  dlgation
					$description = bab_translate("Directory of the managers of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$id_gest_directory = create_directory($id_gest_group, $name, $description, $id_dgowner);
					set_right_on_directory($id_gest_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					$this->managers_directory_info = bab_translate("Creating managers directory", $GLOBALS["babAddonFolder"]);
					
					// Cration du groupe des lves et tudiants de la dlgation
					$name = $this->name.STUDENTS_GROUP_SUFFIX;
					$description = bab_translate("All the students of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_elv_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_elv_group = $temp["id"];
					}
					// Inscription du groupe dans la table de l'arborescence de l'Active Directory d'ORPEO
					$res = $babDB->db_query("SELECT `id` FROM `sad_groups_tree` WHERE `id_group` = '".$babDB->db_escape_string($id_elv_group)."' AND `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$filter = "(CN=gp_eleve".$this->name.")";
						$sr = ldap_search($this->ds, $this->base_dn, $filter);
						if (ldap_count_entries($this->ds, $sr) > 0)
						{
							$entry = ldap_first_entry($this->ds, $sr);
							$dn = ldap_get_dn($this->ds, $entry);
						}
						$res = $babDB->db_query("
						INSERT INTO `sad_groups_tree`
						(
						`id_deleg`,
						`id_group`,
						`dn`
						)
						VALUES
						(
						'".$babDB->db_escape_string($this->id_dg)."',
						'".$babDB->db_escape_string($id_elv_group)."',
						'".$babDB->db_escape_string($dn)."'
						)
						");
					}
					$this->students_group_info = bab_translate("Creating students group", $GLOBALS["babAddonFolder"]);
					// Cration de l'annuaire des lves et tudiants de la  dlgation
					$description = bab_translate("Directory of the students of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$id_elv_directory = create_directory($id_elv_group, $name, $description, $id_dgowner);
					set_right_on_directory($id_elv_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					$this->students_directory_info = bab_translate("Creating students directory", $GLOBALS["babAddonFolder"]);
					
					// Cration du groupe des enseignants de la dlgation
					$name = $this->name.TEACHERS_GROUP_SUFFIX;
					$description = bab_translate("All the teachers of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_prof_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_prof_group = $temp["id"];
					}
					// Inscription du groupe dans la table de l'arborescence de l'Active Directory d'ORPEO
					$res = $babDB->db_query("SELECT `id` FROM `sad_groups_tree` WHERE `id_group` = '".$babDB->db_escape_string($id_prof_group)."' AND `id_deleg` = '".$babDB->db_escape_string($this->id_dg)."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$filter = "(CN=gp_prof".$this->name.")";
						$sr = ldap_search($this->ds, $this->base_dn, $filter);
						if (ldap_count_entries($this->ds, $sr) > 0)
						{
							$entry = ldap_first_entry($this->ds, $sr);
							$dn = ldap_get_dn($this->ds, $entry);
						}
						$res = $babDB->db_query("
						INSERT INTO `sad_groups_tree`
						(
						`id_deleg`,
						`id_group`,
						`dn`
						)
						VALUES
						(
						'".$babDB->db_escape_string($this->id_dg)."',
						'".$babDB->db_escape_string($id_prof_group)."',
						'".$babDB->db_escape_string($dn)."'
						)
						");
					}
					$this->teachers_group_info = bab_translate("Creating teachers group", $GLOBALS["babAddonFolder"]);
					// Cration de l'annuaire des enseignants de la  dlgation
					$description = bab_translate("Directory of the teachers of the group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$id_prof_directory = create_directory($id_prof_group, $name, $description, $id_dgowner);
					set_right_on_directory($id_prof_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					$this->teachers_directory_info = bab_translate("Creating teachers directory", $GLOBALS["babAddonFolder"]);
					
					// Cration du schma de modration de la dlgation
					$name = $this->name;
					$res = $babDB->db_query("SELECT `id` FROM `bab_flow_approvers` WHERE `name` = '".$babDB->db_escape_string($this->name.FLOW_APPROVERS_SUFFIX)."' AND `id_dgowner` = ".$id_dgowner." AND `satype` = 2");
					if ($babDB->db_num_rows($res) == 0)
					{
						$name = $this->name.FLOW_APPROVERS_SUFFIX;
						$description = bab_translate("Flow approvers for the inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->name;
						$formula = $id_gest_group."|".$id_prof_group;
						$forder = "N";
						$refcount = 0; 
						$satype = 2;
						$id_oc  = 0;
						$res = $babDB->db_query("
						INSERT INTO `bab_flow_approvers` (
						`name` ,
						`description` ,
						`formula` ,
						`forder` ,
						`refcount` ,
						`id_dgowner` ,
						`satype` ,
						`id_oc`)
						VALUES (
						'".$babDB->db_escape_string($name)."',
						'".$babDB->db_escape_string($description)."',
						'".$babDB->db_escape_string($formula)."',
						'".$babDB->db_escape_string($forder)."',
						'".$babDB->db_escape_string($refcount)."',
						'".$babDB->db_escape_string($id_dgowner)."',
						'".$babDB->db_escape_string($satype)."',
						'".$babDB->db_escape_string($id_oc)."')
						");
						$id_flow_approvers = $babDB->db_insert_id($res);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_flow_approvers = $temp["id"];
					}
					$this->flow_approvers_info = bab_translate("Creating flow approvers", $GLOBALS["babAddonFolder"]);
					
					// Cration de la catgorie de thmes
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_topics_categories` 
					WHERE 
					`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."' 
					AND 
					`id_parent` = '0'
					");
					if ($babDB->db_num_rows($res) == 0)
					{
						$name = $this->name;
						$description = "";
						$benabled = "Y";
						$template = "template";
						$disptmpl = "default";
						$topcatid = 0;
						$dgowner = $this->id_dg;
						$id_topcat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_topcat = $temp["id"];
					}
					// Placement des droits par dfaut sur la catgorie de thmes cre
					set_def_right_on_topics_category($id_topcat, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($id_topcat, "submit", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($id_topcat, "comment", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($id_topcat, "modify", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($id_topcat, "manage", $id_gest_group + BAB_ACL_GROUP_TREE);
					// Cration des thmes  l'intrieur de la catgorie de thmes
					for ($i = 1; $i < TOPICS_DEFAULT_NUMBER + 1; $i++)
					{
						$name = bab_translate("Topic", $GLOBALS["babAddonFolder"])." ".$i;
						$idCategory = $id_topcat;
						$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE `category` = '".$babDB->db_escape_string($name)."' AND `id_cat` = ".$id_topcat);
						if ($babDB->db_num_rows($res) == 0)
						{
							$description = "";
							$topicArr = array();
							$topicArr["idsaart"] = $id_flow_approvers;
							$topicArr["idsacom"] = $id_flow_approvers;
							$topicArr["idsa_update"] = $id_flow_approvers;
							$topicArr["notify"] = "N";
							$topicArr["lang"] = "fr";
							$topicArr["article_tmpl"] = "";
							$topicArr["display_tmpl"] = "";
							$topicArr["restrict_access"] = "N";
							$topicArr["allow_hpages"] = "N"; 
							$topicArr["allow_pubdates"] = "N"; 
							$topicArr["allow_attachments"] = "N"; 
							$topicArr["allow_update"] = "1"; 
							$topicArr["allow_manupdate"] = "1"; 
							$topicArr["max_articles"] = 10;
							$topicArr["auto_approbation"] = "Y"; 
							$topicArr["busetags"] = "N";
							$topicArr["allow_unsubscribe"] = "1";
							$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
						}
					}
					$this->category_info = bab_translate("Creating category and topics", $GLOBALS["babAddonFolder"]);
					
					// Cration du rpertoire partag
					$folder = $this->name;
					$id_dgowner = $this->id_dg;
					$relative_path = "";
					$bhide = 'N';
					$idsa = $id_flow_approvers;
					$filenotify = "N";
					$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
					// Mise en place des droits sur le dossier partag
					set_right_on_folder($id_folder, "upload", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "download", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "update", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "manage", $id_gest_group + BAB_ACL_GROUP_TREE);
					// set_right_on_folder($id_folder, "notify", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
					// set_right_on_folder($id_folder, "unzip", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0	
					
					$this->folder_info = bab_translate("Creating shared folder", $GLOBALS["babAddonFolder"]);
					
					// Cration du forum du groupe
					$name = $this->name;
					$description = bab_translate("Forum for the inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->name;
					$moderation = "Y";
					$notification = "Y";
					$active = "Y";
					$id_forum = create_forum($name, $description, $id_dgowner, $moderation, $notification, $active);
					if (!is_null($id_forum))
					{
						// Mise en place des droits sur le forum
						set_right_on_forum($id_forum, "view", $this->id_group + BAB_ACL_GROUP_TREE);
						set_right_on_forum($id_forum, "post", $this->id_group + BAB_ACL_GROUP_TREE);
						set_right_on_forum($id_forum, "reply", $this->id_group + BAB_ACL_GROUP_TREE);
						set_right_on_forum($id_forum, "files", $this->id_group + BAB_ACL_GROUP_TREE);
						set_right_on_forum($id_forum, "manage", $id_prof_group + BAB_ACL_GROUP_TREE );
						set_right_on_forum($id_forum, "manage", $id_gest_group + BAB_ACL_GROUP_TREE );
						set_right_on_forum($id_forum, "notify", $this->id_group + BAB_ACL_GROUP_TREE);
					}
					$this->forum_info = bab_translate("Creating forum", $GLOBALS["babAddonFolder"]);
					
					// Cration de l'agenda collectif du groupe
					$name = $this->name;
					$id_dgowner = $this->id_dg;
					$res = $babDB->db_query("SELECT `id` FROM `bab_cal_public` WHERE `name` = '".$babDB->db_escape_string($name)."' AND (`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."')");
					if ($babDB->db_num_rows($res) == 0)
					{
						$description = bab_translate("Public calendar for the the inter-classes group", $GLOBALS["babAddonFolder"])." ".$this->name;
						$idsa = $id_flow_approvers;
						$res = $babDB->db_query("INSERT INTO bab_cal_public (name, description, id_dgowner, idsa) VALUES ('".$babDB->db_escape_string($name)."', '".$description."' , '".$babDB->db_escape_string($id_dgowner)."', '".$babDB->db_escape_string($idsa)."')");
						$id_public_calendar = $babDB->db_insert_id($res);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_public_calendar = $temp["id"];
					}
					$res = $babDB->db_query("SELECT `id` FROM `bab_calendar` WHERE (`owner` = '".$id_public_calendar."') AND (`type` = '2')");
					if ($babDB->db_num_rows($res) == 0)
					{
						$res = $babDB->db_query("INSERT INTO `bab_calendar` (`owner`, `actif`, `type`) VALUES ('".$id_public_calendar."','Y', '2')");
						$id_calendar = $babDB->db_insert_id($res);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_calendar = $temp["id"];
					}
					// Mise en place des droits sur l'agenda collectif
					// Droit pour le groupe des lves ou tudiants de la classe : Consulter, Groupe, Notifier 
					set_right_on_public_calendar($id_calendar, "view", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "groups", $id_elv_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "notify", $id_elv_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.5.0
					// Droit pour le groupe des enseignants de la classe : Consulter, Grer, Groupe, Notifier
					set_right_on_public_calendar($id_calendar, "view", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "manage", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "groups", $id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "notify", $id_prof_group + BAB_ACL_GROUP_TREE);// Nouveauts 7.5.0
					// Droit pour les gestionnaires du niveau : Consulter, Grer, Notifier
					set_right_on_public_calendar($id_calendar, "view", $id_gest_group + BAB_ACL_GROUP_TREE);
					set_right_on_public_calendar($id_calendar, "manage", $id_gest_group + BAB_ACL_GROUP_TREE);
					$this->calendar_info = bab_translate("Creating public calendar", $GLOBALS["babAddonFolder"]);
					
					$this->warning = bab_translate("Warning!", $GLOBALS["babAddonFolder"]);
					$this->warning_info = bab_translate("You need to process to the synchronization of the accounts in order to attach users to the created group", $GLOBALS["babAddonFolder"]);
				}
			
				$res = $babDB->db_query("SELECT `e`, `c`, `n`, `s`, `i` FROM `sad_created_class_deleg`, `bab_dg_groups` WHERE `id_deleg` = ".$this->id_dg);
				if ($babDB->db_num_rows($res) > 0)
				{
					// Cas de la dlgation constitue  partir des groupes issus des classes //////////////////////////////////////////////
					$this->interclass_deleg = false;
					$this->class_deleg = true;
					$this->deleg_level_is_class = false;
					
					list ($e, $c, $n, $s, $i) = $babDB->db_fetch_row($res);
					
					if (!is_null($e) && is_null($c))
					{
						$this->deleg_level = bab_translate("the enseignement", $GLOBALS["babAddonFolder"]);
					}
					else
					{
						if (!is_null($e) && !is_null($c) && is_null($n) && is_null($s))
						{
							$this->deleg_level = bab_translate("the cycle", $GLOBALS["babAddonFolder"]);
						}
						else
						{
							if (!is_null($e) && !is_null($c) && !is_null($n) && is_null($s))
							{
								$this->deleg_level = bab_translate("the level", $GLOBALS["babAddonFolder"]);
							}
							else
							{
								if (!is_null($e) && !is_null($c) && !is_null($s) && is_null($i))
								{
									$this->deleg_level = bab_translate("the speciality", $GLOBALS["babAddonFolder"]);
								}
								else
								{
									if (!is_null($e) && !is_null($c) && !is_null ($n) && !is_null($s) && !is_null($i))
									{
										$this->deleg_level = bab_translate("the class", $GLOBALS["babAddonFolder"]);
										$this->deleg_level_is_class = true;
									}
									else
									{
										$this->deleg_level = "";
									}
								}
							}
						}
					}
					
					$babBody->addError(bab_translate("Basic objects for the delegation based on", $GLOBALS["babAddonFolder"])." ".bab_translate($this->deleg_level, $GLOBALS["babAddonFolder"])." ".$this->name);

					// Reprage du groupe des lves et tudiants de l'tablissement
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."' AND `id_parent`= '".BAB_REGISTERED_GROUP."'");
					if ($babDB->db_num_rows($res) > 0)
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_etabelv_group = $temp["id"];
					}
					// Reprage du groupe des enseignants de l'tablissement
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(TEACHERS_GROUP_NAME)."' AND `id_parent`= '".BAB_REGISTERED_GROUP."'");
					if ($babDB->db_num_rows($res) > 0)
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_etabprof_group = $temp["id"];
					}
					
					// Cration du compte du gestionnaire de la dlgation
					$firstname = MANAGERS_GROUP_SUFFIX;
					$lastname = $this->name;
					$middlename = "";
					$email = "a_saisir@serveur.ext";
					$nickname = $lastname.$firstname;
					$password = random_password(LENGTH);
					$password1 = $password;
					$password2 = $password;
					$confirmed = true;
					$error = "";
					$res = $babDB->db_query("SELECT `id`FROM `bab_users` WHERE `nickname` = '".$babDB->db_escape_string($nickname)."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						//$id_user = registerUser( $firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $badmin);
						$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup = true);
						$res = $babDB->db_query("UPDATE `bab_users` SET `db_authentification` = 'Y' WHERE `id`=".$id_user);
					}
					else
					{
						$password = str_pad("*", LENGTH, "*");
						$id_user = $babDB->db_fetch_array($res);
						$id_user = $id_user[0];
					}
					$this->manager_label = bab_translate("Delegated manager", $GLOBALS["babAddonFolder"]);
					$this->password_label = bab_translate("Password", $GLOBALS["babAddonFolder"]);
					$this->login = $nickname;
					$this->password = $password;
					// Inscription du gestionnaire dlgu dans le groupe dlgu
					$iduser = $id_user;
					$idgroup = $this->id_group;
					bab_attachUserToGroup($iduser, $idgroup); 
					// Inscription du gestionnaire dans le groupe des gestionnnaires dlgus
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string(GESTS_GROUP_NAME)."' AND `id_parent` = '".BAB_REGISTERED_GROUP."'");
					$gests_group_id = $babDB->db_fetch_array($res);
					$gests_group_id = $gests_group_id["id"];
					$iduser = $id_user;
					$idgroup = $gests_group_id;
					bab_attachUserToGroup($iduser, $idgroup); 
					// Cration du groupe des gestionnaires de la dlgation
					$name = $this->name.MANAGERS_GROUP_SUFFIX;
					$description = bab_translate("Group of managers of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
					if ($babDB->db_num_rows($res) == 0)
					{
						$this->id_gest_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_gest_group = $temp["id"];
					}
					$this->managers_group_info = bab_translate("Creating managers group", $GLOBALS["babAddonFolder"]);
					// Inscription du gestionnaire dlgu dans le groupe des gestionnaires de la dlgation
					$iduser = $id_user;
					$idgroup = $this->id_gest_group;
					bab_attachUserToGroup($iduser, $idgroup);
					// Cration de l'annuaire du groupe gestionnaire de la dlgation
					$id_group = $this->id_gest_group;
					$group_name = $this->name.MANAGERS_GROUP_SUFFIX;
					$description = bab_translate("Directory of managers of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;;
					$id_dgowner = $this->id_dg;
					$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
					set_right_on_directory($id_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					$this->managers_directory_info = bab_translate("Creating managers directory", $GLOBALS["babAddonFolder"]);
					
					// Cration des objets au sommet de la dlgation
					
					// Cration du groupe d'lves et tudiants
					$name = $this->name.STUDENTS_GROUP_SUFFIX;
					$description = bab_translate("Group of students of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
					if ($babDB->db_num_rows($res) == 0)
					{
						$this->id_elv_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_elv_group = $temp["id"];
					}
					$this->students_group_info = bab_translate("Creating students group", $GLOBALS["babAddonFolder"]);

					/*
					// Cration de l'annuaire des lves et tudiants de la dlgation
					$id_group = $this->id_elv_group;
					$group_name = $this->name.STUDENTS_GROUP_SUFFIX;
					$description = bab_translate("Directory of students of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;;
					$id_dgowner = $this->id_dg;
					$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
					set_right_on_directory($id_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					*/
					
					// Cration du groupe d'enseignants de la dlgation
					$name = $this->name.TEACHERS_GROUP_SUFFIX;
					$description = bab_translate("Group of teachers of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;
					$managerid = $GLOBALS["BAB_SESS_USERID"];
					$parent = $this->id_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".$babDB->db_escape_string($name)."' AND `id_parent` = ".$parent);
					if ($babDB->db_num_rows($res) == 0)
					{
						$this->id_prof_group = bab_createGroup($name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_prof_group = $temp["id"];
					}
					$this->teachers_group_info = bab_translate("Creating teachers group", $GLOBALS["babAddonFolder"]);
					
					/*
					// Cration de l'annuaire des enseignants de la dlgation
					$id_group = $this->id_prof_group;
					$group_name = $this->name.TEACHERS_GROUP_SUFFIX;
					$description = bab_translate("Directory of teachers of the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;;
					$id_dgowner = $this->id_dg;
					$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
					set_right_on_directory($id_directory, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					*/
					
					// Cration du schma d'approbation de la dlgation
					$res = $babDB->db_query("SELECT `id` FROM `bab_flow_approvers` WHERE `name` = '".$babDB->db_escape_string($this->name.FLOW_APPROVERS_SUFFIX)."' AND `id_dgowner` = ".$id_dgowner." AND `satype` = 2");
					if ($babDB->db_num_rows($res) == 0)
					{
						$name = $this->name.FLOW_APPROVERS_SUFFIX;
						$description = bab_translate("Flow approvers for the delegation", $GLOBALS["babAddonFolder"])." ".$this->name;
						$formula = $this->id_gest_group."|".$this->id_prof_group;
						$forder = "N";
						$refcount = 0; 
						$satype = 2;
						$id_oc  = 0;
						$res = $babDB->db_query("
						INSERT INTO `bab_flow_approvers` (
						`name` ,
						`description` ,
						`formula` ,
						`forder` ,
						`refcount` ,
						`id_dgowner` ,
						`satype` ,
						`id_oc`)
						VALUES (
						'".$babDB->db_escape_string($name)."',
						'".$babDB->db_escape_string($description)."',
						'".$babDB->db_escape_string($formula)."',
						'".$babDB->db_escape_string($forder)."',
						'".$babDB->db_escape_string($refcount)."',
						'".$babDB->db_escape_string($id_dgowner)."',
						'".$babDB->db_escape_string($satype)."',
						'".$babDB->db_escape_string($id_oc)."')
						");
						$id_flow_approvers = $babDB->db_insert_id($res);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_flow_approvers = $temp["id"];
					}
					$this->flow_approvers_info = bab_translate("Creating flow approvers", $GLOBALS["babAddonFolder"]);
					
					// Cration de la catgorie de thmes
					$res = $babDB->db_query("SELECT `id` FROM `bab_topics_categories` WHERE `id_dgowner` = ".$id_dgowner." AND `id_parent` = 0");
					if ($babDB->db_num_rows($res) == 0)
					{
						$name = $this->name;
						$description = "";
						$benabled = "Y";
						$template = "template";
						$disptmpl = "default";
						$topcatid = 0;
						$dgowner = $this->id_dg;
						$this->id_topcat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$this->id_topcat = $temp["id"];
					}					
					// Cration du thme Espace ...
					$name = bab_translate("Space", $GLOBALS["babAddonFolder"])." ".$this->name;
					$idCategory = $this->id_topcat;
					$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE `category` = '".$babDB->db_escape_string($name)."' AND `id_cat` = ".$idCategory);
					if ($babDB->db_num_rows($res) == 0)
					{
						$description = "";
						$topicArr = array();
						$topicArr["idsaart"] = $id_flow_approvers;
						$topicArr["idsacom"] = $id_flow_approvers;
						$topicArr["idsa_update"] = $id_flow_approvers;
						$topicArr["notify"] = "N";
						$topicArr["lang"] = "fr";
						$topicArr["article_tmpl"] = "";
						$topicArr["display_tmpl"] = "";
						$topicArr["restrict_access"] = "N";
						$topicArr["allow_hpages"] = "N"; 
						$topicArr["allow_pubdates"] = "N"; 
						$topicArr["allow_attachments"] = "N"; 
						$topicArr["allow_update"] = "1"; 
						$topicArr["allow_manupdate"] = "1"; 
						$topicArr["max_articles"] = 10;
						$topicArr["auto_approbation"] = "Y"; 
						$topicArr["busetags"] = "N";
						$topicArr["allow_unsubscribe"] = "1";
						$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_topic = $temp["id"];
					}
					set_right_on_topic($id_topic, "view", BAB_REGISTERED_GROUP);
					set_right_on_topic($id_topic, "submit", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "comment", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "modify", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					// Cration du thme Stages et projets
					$name = bab_translate("Stages and projects", $GLOBALS["babAddonFolder"]);
					$idCategory = $this->id_topcat;
					$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE `category` = '".$babDB->db_escape_string($name)."' AND `id_cat` = ".$idCategory);
					if ($babDB->db_num_rows($res) == 0)
					{
						$description = "";
						$topicArr = array();
						$topicArr["idsaart"] = $id_flow_approvers;
						$topicArr["idsacom"] = $id_flow_approvers;
						$topicArr["idsa_update"] = $id_flow_approvers;
						$topicArr["notify"] = "N";
						$topicArr["lang"] = "fr";
						$topicArr["article_tmpl"] = "";
						$topicArr["display_tmpl"] = "";
						$topicArr["restrict_access"] = "N";
						$topicArr["allow_hpages"] = "N"; 
						$topicArr["allow_pubdates"] = "N"; 
						$topicArr["allow_attachments"] = "N"; 
						$topicArr["allow_update"] = "1"; 
						$topicArr["allow_manupdate"] = "1"; 
						$topicArr["max_articles"] = 10;
						$topicArr["auto_approbation"] = "Y"; 
						$topicArr["busetags"] = "N";
						$topicArr["allow_unsubscribe"] = "1";
						$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_topic = $temp["id"];
					}
					set_right_on_topic($id_topic, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "submit", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "comment", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "modify", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_topic($id_topic, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					
					// Placement des droits par dfaut sur la catgorie de thmes cre
					set_def_right_on_topics_category($this->id_topcat, "view", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "view", $this->id_etabprof_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "submit", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "comment", $this->id_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "comment", $this->id_etabprof_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "modify", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_def_right_on_topics_category($this->id_topcat, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					// Cration des thmes  l'intrieur de la catgorie de thmes
					for ($i = 1; $i < TOPICS_DEFAULT_NUMBER + 1; $i++)
					{
						$name = bab_translate("Topic", $GLOBALS["babAddonFolder"])." ".$i;
						$idCategory = $this->id_topcat;
						$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE `category` = '".$babDB->db_escape_string($name)."' AND `id_cat` = ".$this->id_topcat);
						if ($babDB->db_num_rows($res) == 0)
						{
							$description = "";
							$topicArr = array();
							$topicArr["idsaart"] = $id_flow_approvers;
							$topicArr["idsacom"] = $id_flow_approvers;
							$topicArr["idsa_update"] = $id_flow_approvers;
							$topicArr["notify"] = "N";
							$topicArr["lang"] = "fr";
							$topicArr["article_tmpl"] = "";
							$topicArr["display_tmpl"] = "";
							$topicArr["restrict_access"] = "N";
							$topicArr["allow_hpages"] = "N"; 
							$topicArr["allow_pubdates"] = "N"; 
							$topicArr["allow_attachments"] = "N"; 
							$topicArr["allow_update"] = "1"; 
							$topicArr["allow_manupdate"] = "1"; 
							$topicArr["max_articles"] = 10;
							$topicArr["auto_approbation"] = "Y"; 
							$topicArr["busetags"] = "N";
							$topicArr["allow_unsubscribe"] = "1";
							$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
						}
					}
					$this->category_info = bab_translate("Creating category and topics", $GLOBALS["babAddonFolder"]);
					
					// Cration des rpertoires partags
					// Cration du rpertoire Espace...
					$folder = bab_translate("Space", $GLOBALS["babAddonFolder"])." ".$this->name;
					$id_dgowner = $this->id_dg;
					$relative_path = "";
					$bhide = 'N';
					$idsa = $id_flow_approvers;
					$filenotify = "N";
					$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
					// Mise en place des droits sur le rpertoire partag
					set_right_on_folder($id_folder, "upload", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "download", BAB_REGISTERED_GROUP);
					set_right_on_folder($id_folder, "update", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					// set_right_on_folder($id_folder, "notify", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
					// set_right_on_folder($id_folder, "unzip", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0	
					
					// Cration du rpertoire Stages et projets
					$folder = bab_translate("Stages and projects", $GLOBALS["babAddonFolder"]);
					$id_dgowner = $this->id_dg;
					$relative_path = "";
					$bhide = 'N';
					$idsa = $id_flow_approvers;
					$filenotify = "N";
					$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
					// Mise en place des droits sur le rpertoire partag
					set_right_on_folder($id_folder, "upload", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "download", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "update", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					// set_right_on_folder($id_folder, "notify", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
					// set_right_on_folder($id_folder, "unzip", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0	
					
					// Cration du rpertoire Enseignements
					$folder = bab_translate("Enseignements", $GLOBALS["babAddonFolder"]);
					$id_dgowner = $this->id_dg;
					$relative_path = "";
					$bhide = 'N';
					$idsa = $id_flow_approvers;
					$filenotify = "N";
					$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify);
					// Mise en place des droits sur le rpertoire partag
					set_right_on_folder($id_folder, "upload", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "download", $this->id_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "download", $this->id_etabprof_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "update", $this->id_prof_group + BAB_ACL_GROUP_TREE);
					set_right_on_folder($id_folder, "manage", $this->id_gest_group + BAB_ACL_GROUP_TREE);
					// set_right_on_folder($id_folder, "notify", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0
					// set_right_on_folder($id_folder, "unzip", $nobody_group + BAB_ACL_GROUP_TREE); // Nouveauts 7.6.0	
					
					$this->folders_info = bab_translate("Creating shared folders", $GLOBALS["babAddonFolder"]);
					
					$this->warning = bab_translate("Warning!", $GLOBALS["babAddonFolder"]);
					$this->warning_info = bab_translate("You need to process to the update in order to include classes inside the delegation", $GLOBALS["babAddonFolder"]);
				}
				$this->print_label = bab_translate("Print", $GLOBALS["babAddonFolder"]);
			}
		}
	}
	$obj= new actionCreateObjectsFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."create_objects.html", "create_objects_deleg_init"));
}

// Demande de confirmation pour la mise  jour des objets  l'intrieur de la dlgation
function displayUpdateObjectsForm()
{
	global $babBody;
	class displayUpdateObjectsFormClass 
	{
		function displayUpdateObjectsFormClass()
		{
			global $babBody;
			global $babDB;
			
			$this->idx = bab_rp('idx', 'update');
			$this->id_dg = bab_getCurrentAdmGroup();
			$this->info_label = bab_translate("Information", $GLOBALS["babAddonFolder"]);
			$this->validate = bab_translate("Validate", $GLOBALS["babAddonFolder"]);
			$this->info_message = bab_translate("You will take in consideration the delete of former classes and the creation of new classes inside the delegation : the structure of the delegated objets will be update.", $GLOBALS["babAddonFolder"]);
			$this->complementary_message = bab_translate("This item must be called at all new school year beginning.", $GLOBALS["babAddonFolder"]);
			$this->confirm_message = bab_translate("Do you confirm the update of the objects in the delegation?", $GLOBALS["babAddonFolder"]);
			$this->yes_label = bab_translate("Yes", $GLOBALS["babAddonFolder"]);
			$this->no_label = bab_translate("No", $GLOBALS["babAddonFolder"]);	
		}
	}
	$obj= new displayUpdateObjectsFormClass();
	$babBody->babecho( bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."create_objects.html", "confirm_action"));
}

// Demande de confirmation pour la cration ou la recration des objets initiaux de la dlgation
function displayCreateObjectsForm()
{
	global $babBody;
	class displayCreateObjectsFormClass 
	{
		function displayCreateObjectsFormClass()
		{
			global $babBody;
			global $babDB;
			$this->idx = bab_rp('idx', 'first');
			
			$this->yes_label = bab_translate("Yes", $GLOBALS["babAddonFolder"]);
			$this->no_label = bab_translate("No", $GLOBALS["babAddonFolder"]);
			
			if ($this->idx == "first") // Cration initiale dans le cas d'une dlgation base sur un groupe interclasse
			{
				$res = $babDB->db_query("
				SELECT
				`id`,
				`name`,
				`id_group`
				FROM
				`bab_dg_groups`
				WHERE
				`id` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
				AND
				`id` IN (SELECT `id_deleg` FROM `sad_created_group_deleg`)
				");
				if ($babDB->db_num_rows($res) > 0) // Cas des dlgations bases sur les groupe interclasses d'ORPO
				{
					$arr = $babDB->db_fetch_array($res);
					$this->id_dg = $arr['id'];
					$dg_name = $arr['name'];
					$delegated_group = $arr['id_group'];
					
					$res = $babDB->db_query("
					SELECT
					`id`
					FROM
					`bab_topics_categories`
					WHERE
					`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."'
					AND
					`id_parent` = 0
					");
					if ($babDB->db_num_rows($res) === 0)
					{
						$this->info_message = bab_translate("No objects are created inside this delegation. You must create them.", $GLOBALS["babAddonFolder"]);
						$this->complementary_message = bab_translate("This item should be called only one time after the delegation create.", $GLOBALS["babAddonFolder"]);
						$this->confirm_message = bab_translate("Do you confirm the create of the objects inside this interclasses delegation?", $GLOBALS["babAddonFolder"]);
					}
					else
					{
						$this->info_message = bab_translate("The objects in the delegation are existing. You can generate them again.", $GLOBALS["babAddonFolder"]);
						$this->complementary_message = bab_translate("This item should be called only one time after the delegation create.", $GLOBALS["babAddonFolder"]);
						$this->confirm_message = bab_translate("Do you confirm the new create of the objects in the interclasses delegation?", $GLOBALS["babAddonFolder"]);
					}
				}
				else
				{
					$res = $babDB->db_query("
					SELECT
					`id`,
					`name`,
					`id_group`
					FROM
					`bab_dg_groups`
					WHERE
					`id` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
					AND
					`id` IN (SELECT `id_deleg` FROM `sad_created_class_deleg`)
					"); 
					if ($babDB->db_num_rows($res) > 0) // Cas des dlgations bases sur les stuctures classes d'ORPO
					{
						$arr = $babDB->db_fetch_array($res);
						$this->id_dg = $arr['id'];
						$dg_name = $arr['name'];
						$delegated_group = $arr['id_group'];
						
						$this->alert = false;
						$this->info_label = bab_translate("Information", $GLOBALS["babAddonFolder"]);
						
						$res = $babDB->db_query("
						SELECT
						`id`
						FROM
						`bab_topics_categories`
						WHERE
						`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."'
						AND
						`id_parent` = 0
						");
						if ($babDB->db_num_rows($res) > 0)
						{
							$this->alert = true;
							$this->info_label = bab_translate("Warning!", $GLOBALS["babAddonFolder"]);
							$this->info_message = bab_translate("The basic objects in the delegation are existing. You can generate them again.", $GLOBALS["babAddonFolder"]);
							$this->complementary_message = bab_translate("This item should be called only one time after the delegation create.", $GLOBALS["babAddonFolder"]);
							$this->confirm_message = bab_translate("Do you confirm the new create of the basic objects in the delegation?", $GLOBALS["babAddonFolder"]);
						}
						else
						{
							$this->info_message = bab_translate("No objects are built in the delegation. You must create the basic objects in the delegation. After that, you will be able to build by the Update operation all the objects inside the the delegation.", $GLOBALS["babAddonFolder"]);
							$this->complementary_message = bab_translate("This item should be called only one time after the delegation create.", $GLOBALS["babAddonFolder"]);
							$this->confirm_message = bab_translate("Do you confirm the create of the basic objects in the delegation?", $GLOBALS["babAddonFolder"]);
						}
					}
				}
			}
		}
	}
	$obj= new displayCreateObjectsFormClass();
	$babBody->babecho( bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."create_objects.html", "confirm_action"));
}


if (bab_isAccessValid('sad_create_objects_groups', 1000))
{
	global $babBody;
	
	$res = $babDB->db_query("
	SELECT
	`id`,
	`name`,
	`id_group`
	FROM
	`bab_dg_groups`
	WHERE
	`id` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
	AND
	`id` IN (SELECT `id_deleg` FROM `sad_created_group_deleg`)
	");
	if ($babDB->db_num_rows($res) > 0)
	{
			$arr = $babDB->db_fetch_array($res);
			$id_dg = $arr['id'];
			$dg_name = $arr['name'];
			$babBody->addItemMenu("first", bab_translate("Initial creation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."create_objects&idx=first");
			$babBody->title = bab_translate("Creation of the objects inside the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
			$submission = bab_pp('submission','');
			if (empty($submission))
			{
				$babBody->title = bab_translate("Creation of the objects inside the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
				displayCreateObjectsForm();
			}
			else
			{
				$babBody->title = bab_translate("Report of creation of the objects inside the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
				actionCreateObjectsForm();
			}
			$idx = bab_rp('idx', 'first');
	}
	else
	{
		$res = $babDB->db_query("
		SELECT
		`id`,
		`name`,
		`id_group`
		FROM
		`bab_dg_groups`
		WHERE
		`id` = '".$babDB->db_escape_string(bab_getCurrentAdmGroup())."'
		AND
		`id` IN (SELECT `id_deleg` FROM `sad_created_class_deleg`)
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$arr = $babDB->db_fetch_array($res);
			$id_dg = $arr['id'];
			$dg_name = $arr['name'];
			
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_topics_categories`
			WHERE
			`id_dgowner` = '".$babDB->db_escape_string($id_dg)."'
			AND
			`id_parent` = 0
			");
			
			if ($babDB->db_num_rows($res) === 0)
			{
				$idx = bab_rp('idx', 'first');
				$babBody->addItemMenu("first", bab_translate("Initial creation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."create_objects&idx=first");
			}
			else
			{
				$idx = bab_rp('idx', 'update');
				$babBody->addItemMenu("first", bab_translate("Initial creation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."create_objects&idx=first");
				$babBody->addItemMenu("update", bab_translate("Update", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."create_objects&idx=update");
			}
			
			
			switch($idx)
			{
				case 'first':
					$babBody->title = bab_translate("Initial creation of the objects in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
					$submission = bab_pp('submission','');
					if (empty($submission))
					{
						$babBody->title = bab_translate("Initial creation of the objects in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
						displayCreateObjectsForm();
					}
					else
					{
						$babBody->title = bab_translate("Report of initial creation of the objects inside the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
						actionCreateObjectsForm();
					}
					break;
				case 'update':
					$res = 
					$babBody->title = bab_translate("Update of the objects created in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
					$submission = bab_pp('submission','');
					if (empty($submission))
					{
						$babBody->title = bab_translate("Update of the objects created in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
						displayUpdateObjectsForm();
					}
					else
					{
						$babBody->title = bab_translate("Report of update of the objects created in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
						actionUpdateObjectsForm();
					}
					break;
			}
		}
		else
		{
			$babBody->addItemMenu("first", bab_translate("Initial creation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."create_objects&idx=first");
			$submission = bab_pp('submission','');
			if (empty($submission))
			{
				$babBody->title = bab_translate("Creation of the objects in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
				displayCreateObjectsForm();
			}
			else
			{
				$babBody->title = bab_translate("Report of creation of the objects in the delegation", $GLOBALS['babAddonFolder']).' "'.$dg_name.'"';
				actionCreateObjectsForm();
			}
			$this->idx = bab_rp('idx', 'first');
		}
	}
	$babBody->setCurrentItemMenu($idx);
}
?>