<?php
require_once 'base.php';
require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";
require_once $GLOBALS['babAddonPhpPath']."functions.php";
require_once $GLOBALS['babInstallPath']."admin/register.php";
require_once $GLOBALS['babInstallPath']."utilit/userincl.php";

function displayUnsetSynchroForm()
{
	global $babBody;
	class displayUnsetSynchroFormClass
	{
		function displayUnsetSynchroFormClass()
		{
			global $babDB;
			$this->home_message = bab_translate("Caution : you will delete the synchronization beetween Ovidentia and ORPEO Active Directory!", $GLOBALS['babAddonFolder']);
			$this->confirm_message = bab_translate("Do you want to continue?", $GLOBALS['babAddonFolder']);
			$this->yes = bab_translate("Yes", $GLOBALS['babAddonFolder']);
			$this->no = bab_translate("No", $GLOBALS['babAddonFolder']);
			$res = $babDB->db_query("SELECT `id` FROM `bab_sites` WHERE `name`= '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
			list($this->id_site) = $babDB->db_fetch_row($res);
		}
	}
	$obj= new displayUnsetSynchroFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."set_params.html", "unsetsynchroform"));
}

function actionUnsetSynchroForm()
{
	global $babBody;
	class actionUnsetSynchroFormClass 
	{
		function actionUnsetSynchroFormClass()
		{
			global $babDB;
			$id_site = bab_gp("id_site", "");
			if (!empty($id_site))
			{
				$res = $babDB->db_query("UPDATE `bab_sites` SET `authentification` = 0, `ldap_host` = '', `ldap_domainname` = '', ldap_searchdn ='' WHERE `id`= '".$babDB->db_escape_string($id_site)."'");
				$res = $babDB->db_query("DELETE FROM `bab_ldap_sites_fields` WHERE `id_site` = '".$babDB->db_escape_string($id_site)."'");
				$res = $babDB->db_query("DELETE FROM `sad_params` WHERE `id_site`= '".$babDB->db_escape_string($id_site)."'");
				$res = $babDB->db_query("SELECT `id_deleg` FROM `sad_created_class_deleg_temp` WHERE `id_site`= '".$babDB->db_escape_string($id_site)."'");
				while ($arr = $babDB->db_fetch_array($res))
				{
					$res1 = $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg`= '".$babDB->db_escape_string($arr["id_deleg"])."'");
				}
				$res = $babDB->db_query("DELETE FROM `sad_created_class_deleg_temp` WHERE `id_site` = '".$babDB->db_escape_string($id_site)."'");
				$res = $babDB->db_query("SELECT `id_deleg` FROM `sad_created_group_deleg` WHERE `id_site`= '".$babDB->db_escape_string($id_site)."'");
				while ($arr = $babDB->db_fetch_array($res))
				{
					$res1 = $babDB->db_query("DELETE FROM `sad_groups_tree` WHERE `id_deleg`= '".$babDB->db_escape_string($arr["id_deleg"])."'");
				}
				$res = $babDB->db_query("DELETE FROM `sad_created_group_deleg` WHERE `id_site` = '".$babDB->db_escape_string($id_site)."'");
				$this->action_report = bab_translate("The synchronization beetween Ovidentia and ORPEO Active Directory has been deleted.", $GLOBALS["babAddonFolder"]);
			}
		}
	}
	$obj= new actionUnsetSynchroFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."set_params.html", "actionunsetsynchro"));
}

function displaySetSynchroForm()
{
	global $babBody;
	class displaySetSynchroFormClass 
	{
		function displaySetSynchroFormClass()
		{
			global $babDB;
			global $authentification_method;
			$this->required = bab_translate("All fields are required!", $GLOBALS["babAddonFolder"]);
			$this->ovidentia_site_parameters= bab_translate("Parameters of the application Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name_label= bab_translate("Name of the site Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name_default = $GLOBALS["babSiteName"];
			$submission = bab_pp("submission","");
			if (empty($submission))
			{
				$this->site_name_default = $GLOBALS["babSiteName"];
				$this->res = $babDB->db_query("SELECT `id`, `authentification`, `ldap_host`, `ldap_domainname`, `ldap_searchdn` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
				list($site_id, $current_authentification_mode, $ldap_host, $ldap_domain_name, $ldap_searchdn) = $babDB->db_fetch_row($this->res);
				$this->site_id = $site_id;
				$ldap_host = explode(":", $ldap_host);
				$host = $ldap_host[0];
				if (count($ldap_host) > 1)
				{
					$port = $ldap_host[1];
				}
				else
				{
					$port = "";
				}
				$this->port = $port;
				$host_short_name = explode(".".$ldap_domain_name, $host);
				$host = $host_short_name[0];
				if (strpos($ldap_domain_name, ".") > 0)
				{
					$ldap_domain_name = explode(".",$ldap_domain_name);
					$this->domain_name = $ldap_domain_name[0];
					$this->domain_suffix = $ldap_domain_name[1];
				}
				if (!empty($ldap_searchdn))
				{
					$ldap_searchdn = ldap_explode_dn($ldap_searchdn , 1);
					$establishment = $ldap_searchdn[0];
					if (!isset($this->domain_name))
					{
						$this->domain_name = $ldap_searchdn[1];
					}
					if (!isset($this->domain_suffix))
					{
						$this->domain_suffix = $ldap_searchdn[2];
					}
				}
				else
				{
					if (!isset($this->domain_name))
					{
						$this->domain_name = "";
					}
					if (!isset($this->domain_suffix))
					{
						$this->domain_suffix = "";
					}					
				}
				$this->res = $babDB->db_query("SELECT `etab`, `dn` FROM `bab_sites`, `sad_params` WHERE `id_site` = `bab_sites`.`id` AND`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
				if ($babDB->db_num_rows($this->res) > 0)
				{
					list($establishment, $dn) = $babDB->db_fetch_row($this->res);
					$dn = ldap_explode_dn($dn, 1);
					$administrator_name = $dn[0];
				}
				else
				{
					$establishment = "";
					$administrator_name = "";
				}
			}
			else
			{
				$site_name = bab_pp("babSiteName", "");
				$res = $babDB->db_query("SELECT `id` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
				$arr = $babDB->db_fetch_array($res);
				$site_id = $arr["id"];
				$establishment = bab_pp("establishment", "");
				$host = bab_pp("host_short_name", "");
				$port = bab_pp("port", "");
				$administrator_name = bab_pp("administrator_name", "");
				$password = "";
				$this->domain_name = bab_pp("domain_name", "");
				$this->domain_suffix = bab_pp("domain_suffix", "");
			}
			$this->ovidentia_site_parameters= bab_translate("Parameters of the application Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name_label= bab_translate("Name of the site Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name = $GLOBALS["babSiteName"];
			$this->orpeo_ad_parameters= bab_translate("Parameters of the ORPEO Active Directory", $GLOBALS["babAddonFolder"]);
			$this->host_label= bab_translate("Host", $GLOBALS["babAddonFolder"]);
			$this->host_default = $host;
			$this->port_label= bab_translate("Port", $GLOBALS["babAddonFolder"]);
			$this->email_mode= bab_translate("Synchronization of the email addresses", $GLOBALS["babAddonFolder"]);
			if (empty($port))
			{
				$this->port_default = 389;
			}
			else
			{
				$this->port_default = $port;
			}
			$this->administrator_name_label= bab_translate("Name of the administrator", $GLOBALS["babAddonFolder"]);
			if (empty($administrator_name))
			{
				$this->administrator_name_default = "ldapreader";
			}
			else
			{
				$this->administrator_name_default = $administrator_name;
			}
			$this->administrator_password_label= bab_translate("Associated password", $GLOBALS["babAddonFolder"]);
			$this->establishment_label= bab_translate("Establishment name", $GLOBALS["babAddonFolder"]);
			$this->establishment_default= $establishment;
			$this->domain_label= bab_translate("DNS Domain name", $GLOBALS["babAddonFolder"]);
			$this->domain_default= $this->domain_name;
			$this->suffix_label= bab_translate("DNS Suffix", $GLOBALS["babAddonFolder"]);
			if (empty($this->domain_suffix))
			{
				$this->suffix_default = "local";
			}
			else
			{
				$this->suffix_default = $this->domain_suffix;
			}
			$this->yes_label = bab_translate("Enabled", $GLOBALS["babAddonFolder"]);
			$this->no_label = bab_translate("Disabled", $GLOBALS["babAddonFolder"]);
			
			$res = $babDB->db_query("SELECT `bab_ldap_sites_fields`.`id` FROM `bab_ldap_sites_fields`, `bab_dbdir_fields` WHERE `id_site` = ".$site_id." AND `id_field` = `bab_dbdir_fields`.`id` AND `bab_dbdir_fields`.`x_name` = 'mail' AND `bab_ldap_sites_fields`.`x_name` = 'mail'");
			if ($babDB->db_num_rows($res) > 0)
			{
				$this->synchro_mail_flag = " selected";
				$this->unsynchro_mail_flag = "";
			}
			else
			{
				$this->synchro_mail_flag = "";
				$this->unsynchro_mail_flag = " selected";
			}
			
			$this->ovidentia = bab_translate("Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->ldap = bab_translate("LDAP", $GLOBALS["babAddonFolder"]);
			$this->ad = bab_translate("ORPEO Active Directory", $GLOBALS["babAddonFolder"]);
			$this->validate = bab_translate("Validate", $GLOBALS["babAddonFolder"]);
		}
	}
	$obj= new displaySetSynchroFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."set_params.html", "choiceparams"));
}

function test_ldap_connexion()
{
	$host_short_name = bab_pp("host_short_name", "");
	$domain_name = bab_pp("domain_name", "");
	$domain_suffix = bab_pp("domain_suffix", "");
	$port = bab_pp("port", "389");
	// Le numro de port est-il numrique ?
	if (!is_numeric($port))
	{
		return (array(false, "Please, check the port (must be numeric)!"));
	}
	$host = $host_short_name;
	if (!is_ipv4_address($host_short_name))
	{
		if (!empty($domain_name)) $host = $host.".".$domain_name;
		if (!empty($domain_suffix)) $host = $host.".".$domain_suffix; 
	}
	$ds = @ldap_connect($host, $port);
	// La connexion en anomyme est-elle autorise (vrification du nom de l'hte ainsi du nom et du suffixe DNS) ?
	$r = @ldap_bind($ds);
	if ($r === false)
	{
		return (array(false, "Please, check hostname, DNS name or DNS suffix!"));
	}
	else
	{
		$administrator_name = bab_pp("administrator_name", bab_translate("Administrator", $GLOBALS["babAddonFolder"]));
		$dn = "cn=".$administrator_name.", cn=users, dc=".$domain_name.", dc=".$domain_suffix;
		$password = bab_pp("password", "");
		// Le mot de passe est-il vide ?
		if (empty($password))
		{
			@ldap_close($ds);
			return (array(false, "Please, check administror password (must not be empty)!"));
		}
		else
		{
			$r = @ldap_bind($ds, $dn, $password);
			// L'administrateur dsign peut-il se connecter  l'Active Directory (vrification du nom d'utilisateur et du mot de passe) ?
			if ($r === false)
			{
				@ldap_close($ds);
				return (array(false, "Please, check administrator name and password!"));
			}
			else
			{
				$establishment = bab_pp("establishment", "");
				$domain_name = bab_rp("domain_name", "");
				$domain_suffix = bab_rp("domain_suffix", "");
				$base_dn = "OU=eleve, OU=".$establishment.", DC=".$domain_name.", DC=".$domain_suffix;
				$filter = "(cn=*)";
				$sr = @ldap_search($ds, $base_dn, $filter);
				//Le nom de l'tablissement est il correct (prsence de l'UO) ?
				if (@ldap_count_entries($ds, $sr) == 0)
				{
					@ldap_close($ds);
					return (array(false, "Please, check establishment name!"));
				}
				else
				{
					@ldap_close($ds);
					return (array(true, ""));
				}
			}
		}		
	}
}

function actionSetSynchroForm()
{
	global $babBody;
	class actionSetSynchroFormClass 
	{
		function actionSetSynchroFormClass()
		{
			global $babDB;
			global $authentification_method;
			// Rcupration des donnes de la page prcdente
			$site_id = bab_pp("site_id", "1");
			$host_short_name = bab_pp("host_short_name", "");
			$this->domain_name = bab_pp("domain_name", "");
			$this->domain_suffix = bab_pp("domain_suffix", "");
			$port = bab_pp("port", "389");
			$host = $host_short_name;
			if (!is_ipv4_address($host_short_name))
			{
				if (!empty($this->domain_name)) $host = $host.".".$this->domain_name;
				if (!empty($this->domain_suffix)) $host = $host.".".$this->domain_suffix; 
			}
			$ldap_domainname = $this->domain_name.".".$this->domain_suffix;
			$establishment = bab_pp("establishment", "");
			$ldap_host = $host.":".$port;
			$ldap_searchdn = "OU=".$establishment.", DC=".$this->domain_name.", DC=".$this->domain_suffix;
			$administrator_name = bab_pp("administrator_name", bab_translate("Administrator", $GLOBALS["babAddonFolder"]));
			$dn = "cn=".$administrator_name.", cn=users, dc=".$this->domain_name.", dc=".$this->domain_suffix;
			$password = bab_pp("password", "");
			// Cryptage des informations
			$crypted_elements = ovi_crypt($password);
			$password = $crypted_elements[0];
			$crypt = $crypted_elements[1];
			// Slection du mode Active Directory comme processus d'identification
			$res = $babDB->db_query("UPDATE `bab_sites` SET `registration`= 'N', `change_nickname`  = 'N', `authentification` = '2', `ldap_host` = '".$ldap_host."', `ldap_domainname` = '".$ldap_domainname."', `ldap_searchdn` = '".$ldap_searchdn."', ldap_filter ='(|(samaccountname=%NICKNAME))', `ldap_allowadmincnx`  = 'Y', `ldap_decoding_type` = '1' WHERE `id` = ".$site_id);
			// Inscription du paramtrage de l'Active Directory dans la table sad_params
			$res = $babDB->db_query("SELECT `id` FROM `sad_params` WHERE `id_site`= ".$site_id);
			if ($babDB->db_num_rows($res) > 0)
			{
				$res = $babDB->db_query("UPDATE `sad_params` SET `host` = '".$host."', `port` = '".$port."', `dn` = '".$dn."', `password` = '".$babDB->db_escape_string($password)."', `crypt` = '".$babDB->db_escape_string($crypt)."', `etab` = '".$establishment."', `domaine` = '".$this->domain_name."' , `suffixe` = '".$this->domain_suffix."' WHERE `id_site` = ".$site_id);
			}
			else
			{
				$res = $babDB->db_query("INSERT INTO `sad_params` (`id_site`, `host`, `port` , `dn`, `password`, `crypt`, `etab`, `domaine`, `suffixe`) VALUES (".$site_id.", '".$host."', '".$port."', '".$dn."', '".$babDB->db_escape_string($password)."', '".$babDB->db_escape_string($crypt)."', '".$establishment."', '".$this->domain_name."', '".$this->domain_suffix."')");
			}
			// Nom -> sn
			$res = $babDB->db_query("SELECT `bab_ldap_sites_fields`.`id` FROM `bab_ldap_sites_fields`, `bab_dbdir_fields` WHERE `id_site` = ".$site_id." AND `id_field` = `bab_dbdir_fields`.`id` AND `bab_dbdir_fields`.`x_name` = 'sn'");
			if ($babDB->db_num_rows($res) > 0)
			{
				$arr = $babDB->db_fetch_array($res);
				$id = $arr["id"];
				$res = $babDB->db_query("UPDATE `bab_ldap_sites_fields` SET `x_name` = 'sn', `id_field` = (SELECT `id` FROM `bab_dbdir_fields` WHERE `name`= 'sn') WHERE `id` = '".$id."'");
			}
			else
			{
				$res = $babDB->db_query("INSERT INTO `bab_ldap_sites_fields` (`id_field`, `x_name`, `id_site`) VALUES ((SELECT `id` FROM `bab_dbdir_fields` WHERE `name`= 'sn'), 'sn', ".$site_id.")");
			}
			// Prnom -> givenname
			$res = $babDB->db_query("SELECT `bab_ldap_sites_fields`.`id` FROM `bab_ldap_sites_fields`, `bab_dbdir_fields` WHERE `id_site` = ".$site_id." AND `id_field` = `bab_dbdir_fields`.`id` AND `bab_dbdir_fields`.`x_name` = 'givenname'");
			if ($babDB->db_num_rows($res) > 0)
			{
				$arr = $babDB->db_fetch_array($res);
				$id = $arr["id"];
				$res = $babDB->db_query("UPDATE `bab_ldap_sites_fields` SET `x_name` = 'givenname', `id_field` = (SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'givenname') WHERE `id` = '".$id."'");
			}
			else
			{
				$res = $babDB->db_query("INSERT INTO `bab_ldap_sites_fields` (`id_field`, `x_name`, `id_site`) VALUES ((SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'givenname'), 'givenname', ".$site_id.")");
			}
			// Adresse de messagerie -> mail
			$email_mode = bab_pp("email_mode", "N");
			if ($email_mode == "Y")
			{
				$res = $babDB->db_query("SELECT `bab_ldap_sites_fields`.`id` FROM `bab_ldap_sites_fields`, `bab_dbdir_fields` WHERE `id_site` = ".$site_id." AND `id_field` = `bab_dbdir_fields`.`id` AND `bab_dbdir_fields`.`x_name` = 'mail'");
				if ($babDB->db_num_rows($res) > 0)
				{
					$arr = $babDB->db_fetch_array($res);
					$id = $arr["id"];
					$res = $babDB->db_query("UPDATE `bab_ldap_sites_fields` SET `x_name` = 'mail', `id_field` = (SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'mail') WHERE `id` = '".$id."'");
				}
				else
				{
					$res = $babDB->db_query("INSERT INTO `bab_ldap_sites_fields` (`id_field`, `x_name`, `id_site`) VALUES ((SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'mail'), 'mail', ".$site_id.")");
				}
			}
			else
			{
				$res = $babDB->db_query("SELECT `bab_ldap_sites_fields`.`id` FROM `bab_ldap_sites_fields`, `bab_dbdir_fields` WHERE `id_site` = ".$site_id." AND `id_field` = `bab_dbdir_fields`.`id` AND `bab_dbdir_fields`.`x_name` = 'mail'");
				if ($babDB->db_num_rows($res) > 0)
				{
					$arr = $babDB->db_fetch_array($res);
					$id = $arr["id"];
					$res = $babDB->db_query("UPDATE `bab_ldap_sites_fields` SET `x_name` = '', `id_field` = (SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'mail') WHERE `id` = '".$id."'");
				}
				else
				{
					$res = $babDB->db_query("INSERT INTO `bab_ldap_sites_fields` (`id_field`, `x_name`, `id_site`) VALUES ((SELECT `id` FROM `bab_dbdir_fields` WHERE `x_name`= 'mail'), '', ".$site_id.")");
				}
			}
			// Rcapitulatif du paramtrage
			$this->ovidentia_site_parameters= bab_translate("Parameters of the application Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name_label= bab_translate("Name of the site Ovidentia", $GLOBALS["babAddonFolder"]);
			$this->site_name = bab_pp("site_name", "");
			$this->orpeo_ad_parameters= bab_translate("Parameters of the ORPEO Active Directory", $GLOBALS["babAddonFolder"]);
			$this->host_label= bab_translate("Host", $GLOBALS["babAddonFolder"]);
			$this->host_short_name = bab_pp("host_short_name", "");
			$this->port_label= bab_translate("Port", $GLOBALS["babAddonFolder"]);
			$this->port = bab_pp("port", "");
			$this->administrator_name_label= bab_translate("Name of the administrator", $GLOBALS["babAddonFolder"]);
			$this->administrator_name = bab_pp("administrator_name", "");
			$this->administrator_password_label= bab_translate("Associated password", $GLOBALS["babAddonFolder"]);
			$this->password = str_pad("*", strlen(bab_pp("password", "")), "*");
			$this->establishment_label= bab_translate("Establishment name", $GLOBALS["babAddonFolder"]);
			$this->establishment = bab_pp("establishment", "");
			$this->domain_label = bab_translate("DNS Domain name", $GLOBALS["babAddonFolder"]);
			$this->domain = bab_pp("domain_name", "");
			$this->suffix_label= bab_translate("DNS Suffix", $GLOBALS["babAddonFolder"]);
			$this->suffix = bab_pp("domain_suffix", "");
			$this->email_mode_label = bab_translate("Synchronization of the email addresses", $GLOBALS["babAddonFolder"]);
			if ($email_mode == "Y")
			{
				$this->email_mode = bab_translate("Enabled", $GLOBALS["babAddonFolder"]);
			}
			else
			{
				$this->email_mode = bab_translate("Disabled", $GLOBALS["babAddonFolder"]);
			}
			$this->warning = bab_translate("Warning!", $GLOBALS["babAddonFolder"]);
			$this->warning_info = bab_translate("You need to set the parameters of the synchronization again each time the administrator's password is modified", $GLOBALS["babAddonFolder"]);
		}
	}
	$obj= new actionSetSynchroFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."set_params.html", "actionsetsynchro"));
}

$idx = bab_rp('idx', 'set');

switch($idx)
{
	case 'unset';
		if (bab_isAccessValid('sad_admin_groups', 1000))
		{
			$babBody->addItemMenu("set", bab_translate("Setting the synchronization", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."set_params&idx=set");
			$babBody->addItemMenu("unset", bab_translate("Unsetting the synchronization", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."set_params&idx=set");
			$babBody->title = bab_translate("Synchronization between the Ovidentia application and the ORPEO Active Directory", $GLOBALS["babAddonFolder"]);
			$confirm = bab_rp('confirm', '');
			if ($confirm == "yes")
			{
				$babBody->addError(bab_translate("Deletion of the synchronization made", $GLOBALS["babAddonFolder"]));
				actionUnsetSynchroForm();
			}
			else
			{
				displayUnsetSynchroForm();
			}
		}
		break;
	case 'set':
	default:
		if (bab_isAccessValid('sad_admin_groups', 1000))
		{
			$babBody->addItemMenu("set", bab_translate("Setting the synchronization", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."set_params&idx=set");
			$babBody->addItemMenu("unset", bab_translate("Unsetting the synchronization", $GLOBALS["babAddonFolder"]), $GLOBALS["babAddonUrl"]."set_params&idx=unset");
			$babBody->title = bab_translate("Synchronization between the Ovidentia application and the ORPEO Active Directory", $GLOBALS["babAddonFolder"]);
			$submission = bab_pp('submission','');
			if (empty($submission))
			{
				$babBody->addError(bab_translate("Parameters for the synchronization", $GLOBALS["babAddonFolder"]));
				displaySetSynchroForm();
			}
			else
			{
				list($test, $reason) = test_ldap_connexion();
				if($test)
				{
					$babBody->addError(bab_translate("Right parameters for the synchronization", $GLOBALS["babAddonFolder"]));
					actionSetSynchroForm();
				}
				else
				{
					$babBody->addError(bab_translate("Wrong parameters for the synchronization:", $GLOBALS["babAddonFolder"]));
					$babBody->addError(bab_translate($reason, $GLOBALS["babAddonFolder"]));
					displaySetSynchroForm();
				}
			}
		}
		break;
}

$babBody->setCurrentItemMenu($idx);

?>